2005-12-21  Dave Beckett  <dave@dajobe.org>

	* raptor/configure.ac, raptor/raptor.spec.in, raptor/Makefile.am:
	Write rpm release as 1 (with --enable-release) or SNAP otherwise.

	* raptor/src/turtle_parser.y, raptor/src/raptor_general.c,
	raptor/utils/rapper.1, rasqal/docs/librasqal.3,
	rasqal/utils/roqet.1, rasqal/fix-groff-xhtml,
	rasqal/rasqal-src-config.in, rasqal/configure.ac,
	rasqal/Makefile.am: updated urls

	* raptor/docs/tmpl/section-feature.sgml: Added
	@RAPTOR_FEATURE_WRITER_XML_DECLARATION

	* redland-config.in, redland-src-config.in, configure.ac,
	Redland.i, Makefile.am, Makefile.PL: updated urls

2005-12-20  Dave Beckett  <dave@dajobe.org>

	* raptor/utils/Makefile.am: Added rapper.html to dist

	* raptor/raptor-src-config.in, raptor/Makefile.am,
	raptor/manifest.pl, raptor/configure.ac: ILRT/UB link updates

	* raptor/docs/libraptor.3: Updated docs for 1.4.8

2005-11-30  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_xml_writer.c (raptor_xml_writer_indent): Fix
	writing an extra newline at doc start.

2005-11-26  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/tmpl/section-feature.sgml: Added new feature
	RAPTOR_FEATURE_WRITER_XML_DECLARATION.

	* raptor/src/raptor_rdfxml.c (raptor_start_element_grammar):
	Disable XML declaration when building XML fragment for
	parseType="Literal".

	* raptor/src/raptor_xml_writer.c: Add automatic writing of the XML
	declaration (dependent on the XML version).
	(raptor_xml_writer_write_xml_declaration): Added, to support this.
	New feature RAPTOR_FEATURE_WRITER_XML_DECLARATION can disable
	this.
	(main): Update the test code to expect an XML declaration in the
	string.

	* raptor/src/raptor_parse.c: Add do-nothing switch cases for
	RAPTOR_FEATURE_WRITER_XML_DECLARATION.

	* raptor/src/raptor_serialize_rdfxmla.c: Add Adobe XMP compatible
	output as new serializer rdfxml-xmp based on patch from Sid
	Steward.  Duplicate predicates are ignored for a single subject.

	* raptor/src/raptor_serialize_rdfxml.c: Defer writing xml
	declaration to the xml writer.

	* raptor/src/raptor_serialize.c: Add XML declaration writing
	feature support
	(RAPTOR_FEATURE_WRITER_XML_DECLARATION) for serializer.

	* raptor/utils/Makefile.am, raptor/utils/rdfcat.1,
	raptor/utils/rdfcat.c: Delete rdfcat for now

	* raptor/utils/Makefile.am, raptor/utils/rdfcat.1,
	raptor/utils/rdfcat.c: Added rdfcat from Sid Steward.  Not
	automatically built or installed

2005-11-25  Dave Beckett  <dave@dajobe.org>

	* configure.ac: Remove multi-level escapings - dquote in backticks
	in dquote that are likely not very portable.  Fixes Issue#0000058.

	* raptor/configure.ac: Add test X = 1 for expat and libxml tests.
	Fixes Issue#0000060

2005-11-22  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_feature.c: Added
	RAPTOR_FEATURE_WRITER_XML_DECLARATION feature.

	* raptor/src/raptor.h: Added RAPTOR_FEATURE_WRITER_XML_DECLARATION
	to control generating the XML declaration on serializers and XML
	writer.

2005-11-21  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_internal.h: docs

2005-11-20  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/Makefile.am, rasqal/src/rasqal_internal.h: Disable
	skiplist code for now (don't ship it)

2005-11-10  Dave Beckett  <dave@dajobe.org>

	* raptor/raptor.spec.in: Add gtk-doc docs to rpm

2005-11-05  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/tmpl/section-xml.sgml: new functions

	* raptor/docs/tmpl/section-feature.sgml: New feature

	* raptor/docs/libraptor.3: Updated for 1.4.8

2005-11-03  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/raptor-sections.txt: Added
	raptor_iostream_write_xml_any_escaped_string
	raptor_xml_any_escape_string

	* raptor/src/n3_parser.y, raptor/src/raptor_internal.h,
	raptor/src/turtle_parser.y: Added RAPTOR_ASSERT with no return
	value and use it for turtle and n3 parsers.  Some compilers
	complain at an empty 3rd macro arg with RAPTOR_ASSERT_RETURN.

	* raptor/src/raptor_serialize_rss.c: remove ;;

	* raptor/src/raptor_rdfxml.c (raptor_generate_statement): Make
	predicate type fix in reifying.

	* raptor/src/raptor_rdfxml.c (raptor_generate_statement): Make
	predicate revert fix actually work.

	* raptor/src/raptor_rdfxml.c, raptor/src/raptor_rss.c,
	raptor/src/turtle_parser.y, raptor/src/n3_parser.y,
	raptor/src/ntriples_parse.c, raptor/src/raptor.h: Revert
	RAPTOR_IDENTIFIER_TYPE_PREDICATE to
	RAPTOR_IDENTIFIER_TYPE_RESOURCE change for predicates until the
	next release.

2005-09-22  Dave Beckett  <dave@dajobe.org>

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Add new tests, 2
	fail

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Added new tests, 2
	fail

	* rasqal/tests/sparql/SyntaxFull/syntax-keywords-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-keywords-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-keywords-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-11.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-12.rq,
	rasqal/tests/sparql/ExprEquals/Makefile.am,
	rasqal/tests/sparql/ExprEquals/query-eq-graph-1.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-graph-2.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-graph-3.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-graph-4.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-graph-5.rq,
	rasqal/tests/sparql/ExprEquals/query-eq2-graph-1.rq,
	rasqal/tests/sparql/ExprEquals/result-eq-graph-1.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-graph-2.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-graph-3.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-graph-4.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-graph-5.ttl: Added new
	tests

	* rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/Makefile.am: Added
	the 9 EXPECTED_SPARQL_PARSER_FAILURES

	* rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/Makefile.am: Added
	3 EXPECTED_SPARQL_PARSER_FAILURES: syn-05.rq syn-06.rq syn-07.rq

	* rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/Makefile.am: ADded
	3 EXPECTED_SPARQL_CORRECT_FAILURES: syn-05.rq syn-06.rq syn-07.rq

	* rasqal/tests/sparql/check-sparql: If returning no results and
	expect fail, return 1

	* rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/Makefile.am: Added
	9 EXPECTED_SPARQL_CORRECT_FAILURES

	* rasqal/tests/sparql/ExprEquals/Makefile.am: Failures +1:
	"Equality - 2 var - test equals -- graph", total 3

	* rasqal/tests/sparql/check-sparql: report if expected failure
	happens OK early on

	* rasqal/tests/sparql/ExprEquals/manifest.n3: Update to DAWG CVS

2005-09-21  Dave Beckett  <dave@dajobe.org>

	* raptor/utils/rdfdiff.c: Some code style tidying.
	(rdfdiff_statement_equals): Fix comparisons of literals with/out
	language with/out datatype.

	* raptor/tests/Makefile.am: break on error with rdfxml

	* raptor/src/raptor_serialize.c (raptor_new_serializer): Init
	default xml_version to 10 (XML 1.0)

	* raptor/src/raptor_uri.c:
	(raptor_new_uri_for_xmlbase, raptor_new_uri_for_retrieval): Set
	ud->path_len to 1 when adding a default path of / Fixes bug
	0000045 http://bugs.librdf.org/mantis/view.php?id=45

2005-09-20  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_serialize_rdfxmla.c
	(raptor_rdfxmla_serialize_start): Pass down xml_version to the
	raptor_xml_writer and write the versioned header.

	* raptor/src/raptor_serialize_rdfxml.c
	(raptor_rdfxml_serialize_start): Pass down xml_version to the
	raptor_xml_writer and write the versioned header.

	* raptor/src/raptor_xml_writer.c: Add xml_version to
	raptor_xml_writer structure.
	(raptor_iostream_write_xml_element_start): Add xml_version field
	and pass it down to the XML escape function.
	(raptor_new_xml_writer): Init xml_version to 10.
	(raptor_xml_writer_empty_element, raptor_xml_writer_start_element,
	raptor_xml_writer_cdata, raptor_xml_writer_cdata_counted): Pass
	down xml_version.
	(raptor_xml_writer_set_feature, raptor_xml_writer_get_feature):
	Handle RAPTOR_FEATURE_WRITER_XML_VERSION.

	* raptor/src/raptor_xml.c (raptor_xml_any_escape_string,
	raptor_iostream_write_xml_any_escaped_string): Added, handling XML
	1.0 or XML 1.1 Error if writing #x1-#x1f (excluding #x9, #xA, #xD)
	or #x7F for XML 1.0

	* raptor/src/raptor_serialize.c (raptor_serializer_set_feature,
	raptor_serializer_get_feature): Add
	RAPTOR_FEATURE_WRITER_XML_VERSION

	* raptor/src/raptor_parse.c: switch on enum updates for feature
	RAPTOR_FEATURE_WRITER_XML_VERSION for serializer and xml writer

	* raptor/src/raptor_feature.c: Added
	RAPTOR_FEATURE_WRITER_XML_VERSION for serializer and xml writer
	with short name xmlVersion

	* raptor/src/raptor.h: Added RAPTOR_FEATURE_WRITER_XML_VERSION for
	serializer, xml writer.  Added prototypes for
	raptor_xml_any_escape_string and
	raptor_iostream_write_xml_any_escaped_string

	* raptor/src/raptor_internal.h: raptor_serializer_s gains an
	xml_version field

	* raptor/src/raptor_sax2.c (raptor_sax2_parse_chunk): Once more
	with static buffer, no vsnprintf

	* raptor/src/raptor_sax2.c (raptor_sax2_parse_chunk): Fix error
	message with 2 args for expat using raptor_vsnprintf.

	* raptor/src/raptor_namespace.c (raptor_namespaces_format): XML
	escape the written namespace name URI

	* raptor/tests/ex-59.rdf: correct result

	* raptor/tests/ex-59.nt, raptor/tests/ex-59.rdf: Test rdfxml
	serializer escapes dquote in uri attrs

	* raptor/tests/Makefile.am: Added RDF_SERIALIZE_TEST_FILES,
	RDF_SERIALIZE_OUT_FILES and ex-59 for testing the rdfxml
	serializer

	* raptor/examples/Makefile.am: fix libraptor.la dir

2005-09-18  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_rdfxml.c (raptor_generate_statement): When
	reifiying, just copy predicate_type.

	* raptor/src/raptor_uri.c (raptor_uri_equals): Alter to accept
	NULL pointers, which do not compare equal to a non-NULL URI.  NULL
	does equal NULL.

	* raptor/src/raptor.h: Document that
	RAPTOR_IDENTIFIER_TYPE_PREDICATE is never generated by a parser
	from now, replaced by RAPTOR_IDENTIFIER_TYPE_RESOURCE and
	RAPTOR_IDENTIFIER_TYPE_XML_LITERAL replaced by
	RAPTOR_IDENTIFIER_TYPE_LITERAL with the rdf:XMLLiteral datatype.

	* raptor/src/n3_parser.y, raptor/src/ntriples_parse.c,
	raptor/src/turtle_parser.y: Replace all
	RAPTOR_IDENTIFIER_TYPE_PREDICATE with
	RAPTOR_IDENTIFIER_TYPE_RESOURCE

	* raptor/src/raptor_rss.c: *** empty log message ***

	* raptor/src/raptor_rdfxml.c: Replace all
	RAPTOR_IDENTIFIER_TYPE_PREDICATE with
	RAPTOR_IDENTIFIER_TYPE_RESOURCE

	* raptor/src/raptor_rdfxml.c: Added a new concept for
	rdf:XMLLiteral Rename RAPTOR_N_CONCEPTS to
	RAPTOR_RDFXML_N_CONCEPTS
	(raptor_rdfxml_parse_init): Init it.
	(raptor_end_element_grammar): Never generate
	RAPTOR_IDENTIFIER_TYPE_XML_LITERAL, instead generate a
	RAPTOR_IDENTIFIER_TYPE_LITERAL with the rdf:XMLLiteral datatype.

2005-09-16  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/libraptor.3: Update for 1.4.8 - added
	raptor_set_namespace_handler

	* raptor/src/raptor.h, raptor/src/raptor_www.c: Revert: remove
	raptor_www_set_source_uri, raptor_www_set_source_file_handle,
	raptor_www_retrieve and raptor_www_retrieve_to_string

2005-09-15  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor.h: delete unused raptor_www_fetch_to_string
	prototype

	* raptor/src/raptor_www.c: autodocs
	(raptor_www_set_source_uri): Added to set URI for content source
	(raptor_www_set_source_file_handle): Added to set URI for content
	source.
	(raptor_www_file_handle_fetch): Added, with guts of
	raptor_www_file_fetch.
	(raptor_www_file_fetch): Modified to call
	raptor_www_file_handle_fetch.
	(raptor_www_retrieve): Added to retrieve from whatever source (URI
	or handle).
	(raptor_www_retrieve_to_string): Added to retrieve from whatever
	source (URI or handle) into a string.
	(raptor_www_fetch): Now a wrapper over raptor_www_retrieve.
	(raptor_www_fetch_to_string): Now a wrapper over
	raptor_www_retrieve_to_string.

	* raptor/src/raptor.h: Added prototypes for
	raptor_www_set_source_uri, raptor_www_set_source_file_handle,
	raptor_www_retrieve, raptor_www_retrieve_to_string and
	raptor_www_fetch_from_file_handle

	* raptor/src/raptor_internal.h:
	(struct raptor_www_s) gains a handle field

2005-09-14  Dave Beckett  <dave@dajobe.org>

	* librdf/rdf_parser_raptor.c
	(librdf_parser_raptor_parse_file_handle_as_stream): Renamed from
	librdf_parser_raptor_parse_file_as_stream and use FILE* arg.
	(librdf_parser_raptor_parse_as_stream_common): Update to handle
	rename.

	* raptor/docs/tmpl/section-parser.sgml: new functions

	* librdf/rdf_serializer_internal.h: struct
	librdf_serializer_factory_s gains serialize_model_to_iostream
	method.

	* librdf/rdf_serializer_raptor.c
	(librdf_serializer_raptor_serialize_model_to_iostream): Added to
	write to a raptor_iostream object.

	* librdf/rdf_serializer.c
	(librdf_serializer_serialize_model_to_iostream): Added to write to
	a raptor_iostream object.

	* librdf/rdf_serializer.h: Added
	librdf_serializer_serialize_model_to_iostream

2005-09-12  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/sparql_parser.y (ConstructTriplesList): renamed from
	TriplesList and allow an empty list.

	* rasqal/docs/tmpl/section-unused.sgml: less unused

	* rasqal/src/sparql_parser.y (GraphGraphPattern): Handle return of
	NULL graph pattern

	* rasqal/src/sparql_lexer.l ({QUOTEDURI}\(?): Pass the matched
	string through rasqal_escaped_name_to_utf8_string to expand \u and
	\Us and fail on errors, then make a new URI.
	(rasqal_sparql_name_check): Add debug messages.
	(sparql_copy_qname, sparql_copy_string_token): Report name errors
	in prefix or local name part of a qname.

	* rasqal/src/rasqal_general.c
	(rasqal_escaped_name_to_utf8_string): Calculate dest size from
	result pointers, not original string source.

	* rasqal/configure.ac, rasqal/tests/sparql/Makefile.am,
	rasqal/tests/sparql/SyntaxDev/Makefile.am,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/Makefile.am,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/manifest.ttl,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-basic-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-bnodes-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-expr-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-expr-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-expr-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-expr-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-expr-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-forms-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-forms-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-limit-offset-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-limit-offset-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-limit-offset-09.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lists-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lists-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lists-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lists-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lists-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-09.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-10.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-11.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-12.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-13.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-lit-14.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-order-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-pat-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-pat-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-pat-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-pat-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-qname-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-09.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-10.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-11.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-struct-12.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-union-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL/syntax-union-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/Makefile.am,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/manifest.ttl,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-bnode-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-bnode-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-bnode-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-dataset-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-dataset-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-dataset-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-dataset-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-esc-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-esc-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-esc-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-esc-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-ask-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-ask-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-construct06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-describe01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-describe02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-select-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-form-select-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-function-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-function-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-function-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-function-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-general-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-general-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-general-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-graph-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-keywords-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-keywords-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-keywords-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-lists-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-lists-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-lists-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-lists-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL2/syntax-lists-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/Makefile.am,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/bnode-dot.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/bnodes-missing-pvalues-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/bnodes-missing-pvalues-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/empty-optional-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/empty-optional-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/filter-missing-parens.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/lone-list.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/lone-node.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/manifest.ttl,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-01.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-02.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-03.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-04.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-05.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-06.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-07.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-08.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-09.rq,
	rasqal/tests/sparql/SyntaxDev/Syntax-SPARQL3/syn-bad-10.rq: Added
	unapproved sparql syntax tests from DAWG SyntaxDev area

	* rasqal/tests/sparql/check-sparql: Ad -n flag if no data is
	present

	* rasqal/tests/sparql/check-sparql: Handle expect fail tests of
	type mfx:TestBadSyntax Check return code of roqet for failing.

	* rasqal/tests/sparql/check-sparql: Handle mfx:SyntaxType
	rdf:typed actions and in that case pick up the action node as the
	query to use (no data, no result) Only evaluate queries that have
	files

2005-09-10  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_expat.c: Updates to use new raptor_sax2
	handler style.  The user data now points at the raptor_sax2*
	object, not the parser.
	(raptor_expat_init): send SAX2 events to core raptor_sax2_EVENT
	routines.
	(raptor_expat_update_document_locator): Moved from raptor_parser.c

	* raptor/src/raptor_libxml.c: Updates to use new raptor_sax2
	handler style.  The user data now points at the raptor_sax2*
	object, not the parser.  All raptor_parser* references are gone
	and error/fatal error/warnings are returned via handler/data
	pairs.
	(raptor_libxml_call_handler): Added to aid returning messages.
	Deleted old and unused internal entity resolution code.
	(raptor_libxml_init): send SAX2 events to core raptor_sax2_EVENT
	routines.

	* raptor/src/raptor_internal.h: Removed old and hardly tested
	internal handling of libxml entities

	* raptor/src/raptor_rdfxml.c: Rename raptor_xml_* to
	raptor_rdfxml_* in structs and functions.
	(raptor_rdfxml_start_element_handler,
	raptor_rdfxml_end_element_handler, raptor_cdata_grammar): Move
	expat BOM fixes to raptor_sax2.c
	(raptor_rdfxml_parse_init): Use new raptor_sax2_set_EVENT_handler
	methods. Use raptor_sax2_set_locator.
	(raptor_get_libxml_context, raptor_set_libxml_document_locator,
	raptor_get_libxml_document_locator, raptor_get_libxml_entities,
	raptor_set_libxml_entities, raptor_expat_update_document_locator):
	Deleted or merged into raptor_sax2.c

	* raptor/src/raptor_parse.c
	(raptor_parser_fatal_error_message_handler,
	raptor_parser_error_message_handler,
	raptor_parser_warning_message_handler): Added handlers that take
	location in same style as user message handler callbacks.
	(raptor_stats_print): Update for raptor_rdfxml_parser

	* raptor/src/raptor_locator.c (raptor_update_document_locator):
	Moved to raptor_sax2.c

	* raptor/src/raptor_general.c (raptor_init, raptor_finish): Call
	raptor_init_sax2 and raptor_finish_sax2 respectively.

	* raptor/src/raptor_internal.h: Removed several libxml/expat/rdxml
	functions used to be too friendly with internals of other classes.
	Renamed raptor_xml_parser to raptor_rdfxml_parser.  Updated
	prototype of raptor_libxml_update_document_locator.  Added new
	parser handler prototypes raptor_parser_error_message_handler,
	raptor_parser_fatal_error_message_handler and
	raptor_parser_warning_message_handler Added handlers for SAX2
	events - start element, end element, characters, cdata, comment,
	unparsed_entity_decl, external_entity_ref named as
	raptor_sax2_EVENT_handler.  raptor_sax2 gains a magic field as
	this is used as the user data for libxml.  raptor_sax2 uses the
	handler typedefs for the event handlers.  raptor_sax2 gains erorr,
	fatal and warning handler and data fields.  Added prototypes for
	raptor_init_sax2 and raptor_finish_sax2.  Updated prototype for
	raptor_new_sax2.  Added prototypes for
	raptor_sax2_set_start_element_handler,
	raptor_sax2_set_end_element_handler,
	raptor_sax2_set_characters_handler, raptor_sax2_set_cdata_handler,
	raptor_sax2_set_comment_handler,
	raptor_sax2_set_unparsed_entity_decl_handler and
	raptor_sax2_set_external_entity_ref_handler Added prototype for
	raptor_sax2_set_locator.  Added prototypes for:
	raptor_sax2_start_element raptor_sax2_end_element,
	raptor_sax2_characters, raptor_sax2_cdata, raptor_sax2_comment,
	raptor_sax2_unparsed_entity_decl and
	raptor_sax2_external_entity_ref.

	* raptor/src/raptor_sax2.c: Now a more complete class
	(raptor_init_sax2, raptor_finish_sax2): Added, calling any static
	initialising/finishing.
	(raptor_new_sax2): Added error, fatal_error and warning data and
	handler registers.  Register magic for libxml2 user_data fixups
	(raptor_sax2_set_start_element_handler,
	raptor_sax2_set_end_element_handler,
	raptor_sax2_set_characters_handler, raptor_sax2_set_cdata_handler,
	raptor_sax2_set_comment_handler,
	raptor_sax2_set_unparsed_entity_decl_handler,
	raptor_sax2_set_external_entity_ref_handler): Added for setting
	SAX2 callback handlers.
	(raptor_sax2_set_locator): Added, to set SAX2 file locator.
	(raptor_sax2_parse_chunk): Update for new handlers, remove all
	mention of raptor_parser.  Use this object (raptor_sax2*) as the
	user data now, not an external raptor_parser*.
	(raptor_sax2_update_document_locator): Added, updating the current
	location for the internal parser.
	(raptor_sax2_start_element): Added, internal function calling the
	start element handler, adding various workarounds needed.
	(raptor_sax2_end_element): Added, internal function calling the
	end element handler, adding various workarounds needed.
	(raptor_sax2_characters, raptor_sax2_cdata, raptor_sax2_comment,
	raptor_sax2_unparsed_entity_decl,
	raptor_sax2_external_entity_ref): Added, internal functions
	calling the same-named handler.

2005-09-09  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/raptor-sections.txt: Added new fns

	* rasqal/docs/rasqal-sections.txt: No rasqal_variable_s

	* rasqal/docs/tmpl/section-graph_pattern.sgml,
	rasqal/docs/tmpl/section-query.sgml: add new fns

	* rasqal/docs/tmpl/section-literal.sgml: remove dup text

	* rasqal/docs/rasqal-sections.txt: add new fns

	* rasqal/src/Makefile.am, rasqal/utils/Makefile.am: Include
	@RASQAL_INTERNAL_LIBS@ in linking flags to ensure internal raptor
	is used.

	* raptor/src/raptor_internal.h (raptor_parser_s): Add new fields
	to the end of the struct; add unused1 to try to make old offsets
	work

	* docs/tmpl/iterator.sgml: sgml docs for iterator

	* docs/tmpl/stream.sgml: sgml docs for stream

	* raptor/src/raptor_namespace.c (raptor_namespaces_init): Remove
	un-necessary casts for constant namespace names.

	* raptor/src/raptor_uri.c
	(raptor_uri_uri_string_to_filename_fragment): For win32, only
	remove leading / if there is one present. (patch from John
	C. Barstow)
	(main): Correct test case result to match above.

	* raptor/src/raptor_xslt.c (raptor_xslt_parse_chunk): If the
	content is in one chunk and is_end is true, call xmlParseChunk
	with the is_end flag.  (René Puls)

2005-09-07  Dave Beckett  <dave@dajobe.org>

	* raptor/src/n3_parser.y, raptor/src/turtle_parser.y (statement):
	Handle error recovery when subject is NULL

2005-09-06  Dave Beckett  <dave@dajobe.org>

	* raptor/utils/rapper.c: fix #ifdef SHOW_NAMESPACES_FLAG

	* raptor/src/turtle_common.c
	(raptor_stringbuffer_append_turtle_string): Do not check unsigned
	for <0

	* raptor/src/raptor_xml.c (raptor_xml_name_check): Do not check
	unsigned for <0

	* raptor/src/raptor_utf8.c (raptor_utf8_check): Do not check
	unsigned for <0

	* raptor/src/raptor_serialize.c (raptor_serializers_enumerate):
	counter can never be <0

	* raptor/src/raptor_rdfxml.c
	(raptor_element_content_type_as_string): Do not check unsigned for
	<0

	* raptor/src/raptor_feature.c (raptor_feature_value_type): Do not
	check unsigned for <0

	* raptor/src/ntriples_parse.c (raptor_ntriples_term): Do not check
	unsigned for <0

	* raptor/src/raptor_parse.c (raptor_syntaxes_enumerate): counter
	can never be <0

2005-09-01  Dave Beckett  <dave@dajobe.org>

	* utils/rdfproc.c: one fprintf stderr to stdout

	* rasqal/src/sparql_lexer.l: "true" and "false" are now case
	independent

2005-08-31  Dave Beckett  <dave@dajobe.org>

	* rasqal/configure.ac: Added --with-redland-config

	* rasqal/src/rasqal_internal.h: Updated
	erasqal_engine_merge_graph_patterns and
	rasqal_engine_merge_triples prototypes to return an int status.

	* rasqal/src/rasqal_engine.c:
	(rasqal_engine_merge_graph_patterns, rasqal_engine_merge_triples):
	Visitor function now returns a status.

	* rasqal/src/rasqal_query.c: Moved rasqal_graph_pattern_visit to
	rasqal_graph_pattern.c

	* rasqal/src/rasqal.h: Added rasqal_graph_pattern_visit_fn.  Added
	prototype for rasqal_graph_pattern_visit

	* rasqal/src/rasqal_graph_pattern.c (rasqal_graph_pattern_visit:):
	Moved from rasqal_query.c

	* rasqal/docs/tmpl/section-expression.sgml,
	rasqal/docs/tmpl/section-query_results.sgml: docs

	* rasqal/src/sparql_lexer.l, rasqal/src/sparql_parser.y: Remove
	NULL_LITERAL - not in SPARQL

2005-08-24  Dave Beckett  <dave@dajobe.org>

	* raptor/src/Makefile.am: Add more conditional compiles for
	serializers

	* raptor/src/Makefile.am: Added raptor_serialize_rdfxml.c
	raptor_serialize_ntriples.c raptor_serialize_simple.c

	* raptor/src/raptor_serialize.c: Moved specific serializers into
	separate files - rdfxml, ntriples, simple

	* raptor/src/raptor_serialize_rdfxml.c: RDF/XML serializer

	* raptor/src/raptor_serialize_ntriples.c: N-Triples serializer

	* raptor/src/raptor_serialize_simple.c: Simple serializer

	* raptor/src/raptor-config.1, raptor/src/raptor-config.in:
	s/features/options/ so not to confuse with raptor_feature

	* raptor/utils/rapper.c: Add HELP_TEXT_LONG to deal with help that
	has no short option.

	* raptor/utils/rapper.c: fix --show-namespaces help

	* raptor/utils/rapper.1: Added --show-namespaces

	* raptor/utils/rapper.c: (print_namespaces) Added Added
	--show-namespaces option - long options only.

	* raptor/src/n3_parser.y, raptor/src/raptor_rdfxml.c,
	raptor/src/turtle_parser.y: Handle raptor_new_namespace failing.

	* raptor/src/n3_parser.y, raptor/src/raptor_rdfxml.c,
	raptor/src/turtle_parser.y: Remove calls to
	raptor_namespaces_start_namespace_full and use the three functions
	raptor_new_namespace, raptor_namespaces_start_namespace and
	raptor_parser_start_namespace instead.

	* raptor/src/raptor_parse.c (raptor_set_namespace_handler): Added.
	New user method.
	(raptor_parser_start_namespace): Added.  Internal function to
	operate when namespaces are declared.

	* raptor/src/raptor.h: Added raptor_namespace_handler typedef.
	Added raptor_set_namespace_handler prototype.

	* raptor/src/raptor_internal.h: raptor_parser_s gains
	namespace_handler and namespace_handler_user_data fields.  Added
	raptor_parser_start_namespace prototype.

	* raptor/tests/Makefile.am: link to libxml2 bug report

	* raptor/src/raptor_rss.c (raptor_rss_emit_type_triple,
	raptor_rss_emit_enclosure, raptor_rss_emit_connection): Zap
	literal language and datatype before setting up statement objects.

	* raptor/src/ntriples_parse.c
	(raptor_ntriples_generate_statement): Zap literal language and
	datatype before setting up statement objects.

	* raptor/src/n3_parser.y (raptor_n3_generate_statement): Zap
	literal language and datatype for !literals.  Add assertion.

	* raptor/src/raptor_internal.h (RAPTOR_ASSERT_RETURN): Remove ()s
	around return to allow no-value.

	* raptor/src/turtle_parser.y (raptor_turtle_generate_statement):
	Zap literal language and datatype for !literals.  Add assertion.

2005-08-23  Dave Beckett  <dave@dajobe.org>

	* rasqal/docs/tmpl/section-triples_source.sgml: section title

	* rasqal/docs/rasqal-sections.txt: Added
	rasqal_new_expression_from_expression

	* rasqal/src/rasqal_expr.c: Added usage count to rasqal_expression
	constructors
	(rasqal_new_expression_from_expression): Added copy constructor.

	* rasqal/src/rasqal_engine.c (rasqal_engine_join_graph_patterns):
	Move constraints taking care to copy then free correctly.

	* rasqal/src/rasqal.h: Added usage count to rasqal_expression.
	Added rasqal_new_expression_from_expression prototype.

2005-08-22  Dave Beckett  <dave@dajobe.org>

	* raptor/docs/raptor-sections.txt: raptor_uri_init now internal

	* raptor/docs/tmpl/section-unused.sgml: raptor_uri_init now
	internal

	* raptor/docs/tmpl/section-general.sgml,
	raptor/src/raptor_internal.h: Remove unused container_test_handler
	function.

	* raptor/docs/raptor-sections.txt: No
	raptor_container_test_handler

	* raptor/src/raptor.h: raptor_uri_init was internal

	* raptor/src/raptor_internal.h: raptor_uri_init was internal

2005-08-19  Dave Beckett  <dave@dajobe.org>

	* raptor/Makefile.am: Enable gtk doc with make distcheck

	* raptor/docs/tmpl/section-xml-namespace.sgml: args

	* raptor/docs/version.xml.in: version.xml.in

	* raptor/docs/tmpl/section-serializer.sgml: whitespace

	* raptor/src/ntriples_parse.c, raptor/src/raptor.h,
	raptor/src/raptor_feature.c, raptor/src/raptor_general.c,
	raptor/src/raptor_identifier.c, raptor/src/raptor_iostream.c,
	raptor/src/raptor_locator.c, raptor/src/raptor_namespace.c,
	raptor/src/raptor_nfc.c, raptor/src/raptor_nfc_test.c,
	raptor/src/raptor_parse.c, raptor/src/raptor_qname.c,
	raptor/src/raptor_rdfxml.c, raptor/src/raptor_rfc2396.c,
	raptor/src/raptor_sequence.c, raptor/src/raptor_serialize.c,
	raptor/src/raptor_serialize_rdfxmla.c, raptor/src/raptor_set.c,
	raptor/src/raptor_stringbuffer.c, raptor/src/raptor_uri.c,
	raptor/src/raptor_utf8.c, raptor/src/raptor_www.c,
	raptor/src/raptor_www_libwww.c, raptor/src/raptor_xml.c,
	raptor/src/raptor_xml_writer.c, raptor/src/turtle_common.c:
	autodocs reformatted for gtk-doc

	* raptor/docs/tmpl/section-constants.sgml,
	raptor/docs/tmpl/section-feature.sgml,
	raptor/docs/tmpl/section-general.sgml,
	raptor/docs/tmpl/section-iostream.sgml,
	raptor/docs/tmpl/section-locator.sgml,
	raptor/docs/tmpl/section-memory.sgml,
	raptor/docs/tmpl/section-parser.sgml,
	raptor/docs/tmpl/section-sequence.sgml,
	raptor/docs/tmpl/section-serializer.sgml,
	raptor/docs/tmpl/section-stringbuffer.sgml,
	raptor/docs/tmpl/section-triples.sgml,
	raptor/docs/tmpl/section-unicode.sgml,
	raptor/docs/tmpl/section-unused.sgml,
	raptor/docs/tmpl/section-uri-factory.sgml,
	raptor/docs/tmpl/section-uri.sgml,
	raptor/docs/tmpl/section-www.sgml,
	raptor/docs/tmpl/section-xml-namespace.sgml,
	raptor/docs/tmpl/section-xml-qname.sgml,
	raptor/docs/tmpl/section-xml.sgml: initial templates

	* raptor/docs/raptor-docs.xml: fix

	* raptor/docs/raptor-docs.xml, raptor/docs/raptor-overrides.txt,
	raptor/docs/raptor-sections.txt: gtk-doc files

	* raptor/configure.ac, raptor/docs/Makefile.am: Enable gtk-doc

	* raptor/configure.ac: check for gtk-doc

	* raptor/src/raptor-config.1: Document --features and --help.
	Order flags alphabetically in summary and body.

	* raptor/src/raptor-config.in: Add --features argument to list
	configured or discovered features of the raptor library

	* raptor/configure.ac: Add AC_SUBSTs for recording discovered
	features: RAPTOR_WWW_LIBRARY (or none), RAPTOR_XML_PARSER (or
	none), RAPTOR_PARSERS (list) and RAPTOR_SERIALIZERS (list).

	* rasqal/src/rasqal.h, rasqal/src/rasqal_expr.c: autodocs fixes -
	use %RASQAL_

	* rasqal/docs/tmpl/section-graph_pattern.sgml: use %RASQAL

2005-08-18  Dave Beckett  <dave@dajobe.org>

	* rasqal/docs/tmpl/section-query_results.sgml,
	rasqal/docs/tmpl/section-literal.sgml,
	rasqal/docs/tmpl/section-query.sgml: document literal, query,
	query_results types

	* rasqal/docs/rasqal-sections.txt: Add rasqal_query and
	rasqal_query_results

	* rasqal/docs/rasqal-overrides.txt: override rasqal_query and
	rasqal_query_results

	* rasqal/docs/Makefile.am: Make gtkdoc-mkdb ignore the C files

	* raptor/src/raptor_sax2.c (raptor_sax2_parse_start): Fix for
	expat

	* raptor/src/raptor_rdfxml.c
	(raptor_xml_unparsed_entity_decl_handler,
	raptor_xml_external_entity_ref_handler): Casts for gcc4

	* raptor/src/raptor_expat.c (raptor_expat_init): Casts for expat
	to use sax2 handlers.

	* raptor/src/raptor_internal.h: Move raptor_sax2 declaration
	outside libxml-only block Fixup general arguments for
	raptor_xml_unparsed_entity_decl_handler and
	raptor_xml_external_entity_ref_handler.

	* raptor/src/raptor_rdfxml.c
	(raptor_xml_unparsed_entity_decl_handler,
	raptor_xml_external_entity_ref_handler): Generalise args from
	expat-specific.
	(raptor_xml_parse_init): Init sax2 handler fields

	* raptor/src/raptor_libxml.c (raptor_libxml_init): Use sax2
	structure handlers

	* raptor/src/raptor_expat.c (raptor_expat_init): Use sax2
	structure handlers

	* raptor/src/raptor_internal.h: raptor_sax2 gains handlers for
	start/end element, characters, cdata, comment, unparsed entity
	declaration, extenal entity reference.

	* rasqal/src/rasqal_query.c (rasqal_graph_pattern_visit): Make
	this recursive.

	* rasqal/tests/sparql/ExprBuiltins/Makefile.am: datatype-1 works

	* rasqal/src/rasqal_expr.c (rasqal_expression_evaluate): For
	datatype, if is a typed literal it has a datatype field then
	return that, otherwise fail.

	* rasqal/tests/sparql/ExprBuiltins/Makefile.am: str-1 passes

	* raptor/src/raptor_sax2.c (raptor_sax2_parse_start): Init expat
	and libxml the same

	* raptor/src/raptor_libxml.c (raptor_libxml_init): Take
	raptor_sax2* and raptor_uri* args

	* raptor/src/raptor_expat.c (raptor_expat_init): Take raptor_sax2*
	and raptor_uri* args

	* raptor/src/raptor_internal.h: raptor_libxml_init and
	raptor_expat_init take same args

	* raptor/src/n3_parser.y, raptor/src/ntriples_parse.c,
	raptor/src/raptor_guess.c, raptor/src/raptor_rdfxml.c,
	raptor/src/raptor_rss.c, raptor/src/raptor_xslt.c,
	raptor/src/turtle_parser.y: Update uses of
	raptor_parser_register_factory to remove alias argument and add
	calls to raptor_parser_factory_add_alias for raptor
	(rdfxml) and ntriplesplus (turtle)

	* raptor/src/raptor_internal.h: Update
	raptor_parser_register_factory prototype to return the registered
	factory and remvoe the alias arg.  Added prototype for
	raptor_parser_factory_add_alias

	* raptor/src/raptor_parse.c (raptor_parser_register_factory): Now
	returns the registered factory.  Removed alias arg into new
	function:
	(raptor_parser_factory_add_alias): Added.

2005-08-17  Dave Beckett  <dave@dajobe.org>

	* raptor/src/Makefile.am: maintainer clean n3 files

	* raptor/src/Makefile.am: clean n3 tests

	* raptor/src/n3_lexer.l (n3_lexer_syntax_error): Added, from
	turtle.

	* raptor/src/n3_lexer.l: Added n3_lexer_syntax_error
	(<LITERAL>\"\"\"): Copy just the len and always terminate the
	string.
	(n3_copy_string_token): Handle empty strings without stringbuffer
	and use raptor_stringbuffer_append_turtle_string for escapes.
	Ensure string is always termianted.

	* raptor/src/n3_common.h: added stringbuffer field

	* raptor/src/turtle_parser.y: Expect 9 conflicts.  Added
	FLOATING_LITERAL
	(FLOATING_LITERAL): Use raptor_new_identifier_from_double common
	with n3.

	* raptor/src/n3_parser.y (FLOATING_LITERAL): Use
	raptor_new_identifier_from_double common with turtle.

	* raptor/src/turtle_lexer.l (<LITERAL>\"\"\"): Copy just the len
	 and always terminate the string.  Added doubles to Turtle.
	(turtle_copy_string_token): Handle empty strings without
	stringbuffer.  Ensure string is always termianted.
	(turtle_token_print): Print FLOATING_LITERAL

	* raptor/tests/turtle/Makefile.am,
	raptor/tests/turtle/test-20.out, raptor/tests/turtle/test-20.ttl:
	Add test-20 for empty literals

	* raptor/tests/turtle/Makefile.am: re-add test-19

2005-08-16  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_internal.h: Added
	raptor_new_identifier_from_double pointer

	* raptor/src/Makefile.am: Added raptor_xsd.c

	* raptor/src/raptor_xsd.c: raptor_xsd.c

	* raptor/src/n3_lexer.l, raptor/src/n3_parser.y: Add double
	constants to N3 parser

	* raptor/src/n3_lexer.l (main): Make uri_string an unsigned char*

	* raptor/tests/turtle/Makefile.am: remove test-19 for now, no
	double constants

	* raptor/tests/turtle/Makefile.am,
	raptor/tests/turtle/test-19.out, raptor/tests/turtle/test-19.ttl:
	added test-19 for 1.0 as a double

	* raptor/src/Makefile.am: Add turtle_common.c

	* raptor/tests/turtle/test-18.out: Remove header/footer

	* raptor/src/turtle_parser.y: 2005

	* raptor/src/turtle_lexer.l: Added turtle_lexer_syntax_error Build
	up long strings inside a stringbuffer with
	raptor_stringbuffer_append_turtle_string and avoid greedy match of
	"""s
	(turtle_copy_string_token): Use
	raptor_stringbuffer_append_turtle_string
	(turtle_lexer_syntax_error): Added.

	* raptor/src/raptor_internal.h: Added
	raptor_stringbuffer_append_turtle_string prototype

	* raptor/src/turtle_common.h: Added raptor_stringbuffer* field sb

	* raptor/src/turtle_common.c: Raptor Turtle common code with
	raptor_stringbuffer_append_turtle_string from raptor_turtle.l

	* raptor/tests/turtle/Makefile.am,
	raptor/tests/turtle/test-18.out, raptor/tests/turtle/test-18.ttl:
	Added test-18 for multiple long literals with escapes

	* raptor/src/raptor_serialize_rss.c (raptor_rss10_emit_item): Die
	in debug mode with NULL item - all calls to this are currently
	wrapped with a check.
	(raptor_rss10_emit_item): Do not emit atom author when no such
	item exists.

	* raptor/manifest.pl: typo

2005-08-13  Dave Beckett  <dave@dajobe.org>

	* redland-src-config.in: Add --version and --version-decimal

	* rasqal/docs/tmpl/section-unused.sgml,
	rasqal/docs/tmpl/section-variable.sgml,
	rasqal/docs/tmpl/section-query_results.sgml,
	rasqal/docs/tmpl/section-triple.sgml,
	rasqal/docs/tmpl/section-prefix.sgml,
	rasqal/docs/tmpl/section-query.sgml,
	rasqal/docs/tmpl/section-graph_pattern.sgml,
	rasqal/docs/tmpl/section-literal.sgml,
	rasqal/docs/tmpl/section-expression.sgml,
	rasqal/docs/tmpl/section-general.sgml,
	rasqal/docs/rasqal-sections.txt: autodocs - sections intros

	* rasqal/src/rasqal.h, rasqal/src/rasqal_expr.c,
	rasqal/src/rasqal_general.c, rasqal/src/rasqal_engine.c: autodocs

	* rasqal/src/rasqal.h: Remove unused
	rasqal_new_variable_expression prototype.  Deprecate
	rasqal_expression_foreach for rasqal_expression_visit Add
	rasqal_expression_visit prototype and rasqal_expression_visit_fn.

	* rasqal/docs/rasqal-sections.txt: Add rasqal_expression_visit_fn
	rasqal_expression_visit

2005-08-11  Dave Beckett  <dave@dajobe.org>

	* autogen.sh, raptor/autogen.sh: update autogen.sh again

	* rasqal/autogen.sh: programs spello

	* autogen.sh, raptor/autogen.sh: update autogen.sh again

	* rasqal/autogen.sh: Add gtkdocize and swig (for bindings) only if
	seen in top-level configure.ac Add swig-specific version check,
	different from gnu style

	* autogen.sh, rasqal/autogen.sh: update autogen.sh again

	* raptor/autogen.sh: Move warning to end

	* raptor/autogen.sh, autogen.sh, rasqal/autogen.sh: Rewrite with
	functions, generalize to any redland package.  Add docs.

	* rasqal/src/rasqal_engine.c: restore undef RASQAL_DEBUG

	* rasqal/tests/sparql/part1/dawg-query-003.rq: Declare rdf:

	* rasqal/src/sparql_parser.y (rasqal_sparql_query_engine_init): Do
	not declare any namespaces by default.

	* rasqal/tests/sparql/syntax/Makefile.am: Added namespaces.rq

	* rasqal/tests/sparql/syntax/namespaces.rq: namespaces.rq

	* librdf/redland.spec.in: - Update Source: - Do not require
	python-devel at build time - Add sqlite-devel build requirement.
	- Use %configure and %makeinstall

	* rasqal/rasqal.spec.in, raptor/raptor.spec.in: - Update Source: -
	Use %makeinstall

2005-08-10  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/rasqal_engine.c (rasqal_engine_merge_graph_patterns):
	Renamed from rasqal_engine_make_basic_graph_pattern and added some
	docucomments.  It no longer handles UNIONS - they are never
	merged, the code was just handling them in order to descend down
	the tree, now done by the visitor calling this function. Remove
	calling lower sub-GPs.
	(rasqal_engine_merge_triples): Renamed from
	rasqal_engine_merge_basic_graph_patterns and added some
	docucomments.

	* rasqal/src/rasqal_internal.h: Added
	rasqal_graph_pattern_visit_fn typdef.  Added prototype for
	rasqal_query_graph_pattern_visit

	* rasqal/src/rasqal_query.c (rasqal_query_prepare): Rewrite to use
	rasqal_query_graph_pattern_visit to do graph pattern transforms.
	(rasqal_graph_pattern_visit): Added, called by:
	(rasqal_query_graph_pattern_visit): Added to walk all graph
	patterns in a query.

	* rasqal/src/rasqal_engine.c
	(rasqal_engine_make_basic_graph_pattern): Do not lose sub-grpah
	pattern UNION type.

	* rasqal/src/sparql_parser.y (PrimaryExpression): Explain rq23
	weirdness

	* raptor/raptor.spec.in: Use %configure and %{_make}

	* rasqal/tests/sparql/survey/query-survey-10.rq,
	rasqal/tests/sparql/survey/query-survey-11.rq,
	rasqal/tests/sparql/survey/query-survey-13.rq: FILTER() syntax

	* rasqal/rasqal.spec.in: Use %configure

	* rasqal/src/sparql_lexer.l: Remove '%' as a token.
	(sparql_token_print): Remove '%'

	* rasqal/src/sparql_parser.y: Remove '%' as a token.  Whitespace
	style fixes near rule definitions.

	* rasqal/src/sparql_parser.y: Make FILTER use Constraint for
	multiple forms.
	(Constraint): Added.  Allow the BrackettedExpression, BuiltInCall
	or FunctionCall alternatives.
	(Expression): Added.  9ConditionalOrExpression): Make it recursive
	rather than just allow 0 or 1 &&s.
	(MultiplicativeExpression): Remove '%' operator, not in SPARQL.
	(BuiltInCall): Renamed from CallExpression and remove FunctionCall
	from it.
	(PrimaryExpression): use BuiltInCall and add FunctionCall from
	above.

	* rasqal/tests/sparql/ValueTesting/Makefile.am: +3 more tests,
	extendedType-literal-ne fails.

	* rasqal/tests/sparql/syntax/cast0.rq,
	rasqal/tests/sparql/syntax/cast1.rq,
	rasqal/tests/sparql/bound/bound1.rq: FILTER() syntax

	* rasqal/tests/sparql/examples/ex11.2.3.8_0.rq,
	rasqal/tests/sparql/examples/ex3.rq: Updates from DAWG for
	FILTER()

	* rasqal/tests/sparql/SyntaxFull/manifest.ttl,
	rasqal/tests/sparql/simple/manifest.n3,
	rasqal/tests/sparql/sort/manifest.ttl,
	rasqal/tests/sparql/examples/manifest.n3: Update to DAWG tests -
	some approved

	* rasqal/tests/sparql/ValueTesting/extendedType-eq-pass-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-eq-pass.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-graph-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-graph.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-literal-eq-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-literal-eq.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-literal-ne-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-literal-ne.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-ne-fail-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-ne-fail.rq,
	rasqal/tests/sparql/ValueTesting/manifest.n3: Update to DAWG tests

2005-08-08  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_rss_common.c, raptor/src/raptor_internal.h,
	raptor/src/raptor_rss.c: Move time.h and sys/time.h #ifdef and
	includes to raptor_internal.h since time_t is mentioned there and
	visible to all files.

	* raptor/tests/Makefile.am: adjust -I to point to srcdir for
	raptor_empty_test

2005-08-04  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/rasqal_engine.c (rasqal_engine_join_graph_patterns):
	Renamed from rasqal_engine_join_basic_graph_patterns.  Warn if
	types are different.  Merge sub graph sequences.
	(rasqal_engine_make_basic_graph_pattern): Operate over unions
	recursively for any lower-level basic graph patterns.  Don't merge
	if all sub-graph patterns aren't of the same type.  Never merge
	union sequences of size>1

	* rasqal/src/rasqal_internal.h:
	rasqal_engine_join_basic_graph_patterns now
	rasqal_engine_join_graph_patterns

2005-08-03  Dave Beckett  <dave@dajobe.org>

	* configure.ac, rasqal/configure.ac: gtk-doc 1.3 is ok

2005-08-01  Dave Beckett  <dave@dajobe.org>

	* rasqal/utils/Makefile.am: Add AM_CPPFLAGS and AM_CFLAGS back

2005-07-31  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_xml_writer.c (main): syntax

	* configure.ac, rasqal/configure.ac: Fix for compiling against
	internal raptor

	* raptor/src/raptor_uri.c: Add (void) casts for fwrite debug
	messages

	* raptor/utils/Makefile.am: Re-add rapper.1 to dist

	* raptor/src/raptor_rdfxml.c, raptor/src/raptor_xml_writer.c,
	raptor/src/raptor_nfc_test.c: Add (void) casts for fwrite debug
	messages

	* raptor/utils/Makefile.am, raptor/Makefile.am,
	raptor/configure.ac, raptor/docs/Makefile.am,
	raptor/raptor-src-config.in, raptor/src/Makefile.am,
	raptor/tests/Makefile.am, raptor/tests/turtle/Makefile.am:
	Reorganise sources - libraptor is in src, man pages in docs,
	rapper in utils

	* configure.ac, librdf/Makefile.am: adjust source of librasqal.la

	* docs/Makefile.am, rasqal/docs/Makefile.am: Added version.xml to
	content_files

	* rasqal/docs/Makefile.am, rasqal/utils/Makefile.am: restore mans
	to dist

	* rasqal/src/Makefile.am: if STRCASECMP not GETOPT

	* rasqal/Makefile.am: Add utils dir

	* rasqal/utils/Makefile.am: roqet.html

	* rasqal/utils/Makefile.am: utils automakefile

	* rasqal/src/Makefile.am: Add Makefile.am

	* rasqal/tests/sparql/survey/Makefile.am,
	rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/ExprEquals/Makefile.am,
	rasqal/tests/sparql/SyntaxFull/Makefile.am,
	rasqal/tests/sparql/ValueTesting/Makefile.am,
	rasqal/tests/sparql/bound/Makefile.am,
	rasqal/tests/sparql/examples/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/regex/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/sort/Makefile.am, rasqal/docs/Makefile.am,
	rasqal/tests/rdql/Makefile.am,
	rasqal/tests/rdql/testsuite/Makefile.am,
	rasqal/tests/sparql/Expr1/Makefile.am,
	rasqal/tests/sparql/Expr2/Makefile.am,
	rasqal/tests/sparql/ExprBuiltins/Makefile.am, rasqal/Makefile.am,
	rasqal/configure.ac, rasqal/rasqal-src-config.in: Reorganise
	sources - librasqal is in src, man pages are in docs, roqt in
	utils.

2005-07-30  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/rasqal_expr.c, rasqal/src/rasqal.h: autodocs

	* rasqal/docs/tmpl/section-variable.sgml,
	rasqal/docs/tmpl/section-unused.sgml,
	rasqal/docs/tmpl/section-query_results.sgml,
	rasqal/docs/tmpl/section-triple.sgml,
	rasqal/docs/tmpl/section-query.sgml,
	rasqal/docs/tmpl/section-literal.sgml,
	rasqal/docs/tmpl/section-prefix.sgml,
	rasqal/docs/tmpl/section-general.sgml,
	rasqal/docs/tmpl/section-graph_pattern.sgml: Updated templates.

	* rasqal/docs/tmpl/section-expression.sgml: short and long desc
	add rasqal_compare_flags not #defines

	* rasqal/docs/tmpl/section-data.sgml: short and long desc

	* rasqal/docs/rasqal-overrides.txt: override some things to hide
	internals.

	* rasqal/docs/rasqal-sections.txt, rasqal/docs/rasqal-docs.xml,
	rasqal/src/rasqal_literal.c, rasqal/src/rasqal_expr.c,
	rasqal/src/rasqal_general.c, rasqal/src/rasqal.h: more autodocs

	* rasqal/src/rasqal_query.c, rasqal/src/rasqal_general.c,
	rasqal/src/rasqal_expr.c: more autodocs and fixes for gtk-doc
	style

	* rasqal/src/rasqal_expr.c: autodocs for rasqal_data_graph

	* rasqal/src/rasqal_query.c, rasqal/src/rasqal_expr.c,
	rasqal/src/rasqal_graph_pattern.c, rasqal/src/rasqal.h: Source
	code arg fixes for gtk-doc

2005-07-29  Dave Beckett  <dave@dajobe.org>

	* rasqal/docs/rasqal.types: empty types for gtk-doc

	* rasqal/Makefile.am: Added DISTCHECK_CONFIGURE_FLAGS

	* rasqal/rasqal.spec.in: Updated for gtk-doc locations

	* rasqal/docs/tmpl/section-data.sgml,
	rasqal/docs/tmpl/section-expression.sgml,
	rasqal/docs/tmpl/section-general.sgml,
	rasqal/docs/tmpl/section-graph_pattern.sgml,
	rasqal/docs/tmpl/section-literal.sgml,
	rasqal/docs/tmpl/section-prefix.sgml,
	rasqal/docs/tmpl/section-query.sgml,
	rasqal/docs/tmpl/section-query_results.sgml,
	rasqal/docs/tmpl/section-triple.sgml,
	rasqal/docs/tmpl/section-unused.sgml,
	rasqal/docs/tmpl/section-variable.sgml,
	rasqal/docs/rasqal-overrides.txt, rasqal/autogen.sh,
	rasqal/configure.ac, rasqal/docs/Makefile.am,
	rasqal/docs/api.sgml.in, rasqal/docs/build-docs,
	rasqal/docs/kernel-doc, rasqal/docs/rasqal-docs.xml,
	rasqal/docs/rasqal-sections.txt, rasqal/src/rasqal.h,
	rasqal/src/rasqal_engine.c, rasqal/src/rasqal_expr.c,
	rasqal/src/rasqal_general.c, rasqal/src/rasqal_graph_pattern.c,
	rasqal/src/rasqal_literal.c, rasqal/src/rasqal_map.c,
	rasqal/src/rasqal_query.c, rasqal/src/rasqal_raptor.c,
	rasqal/src/rasqal_skiplist.c: Switch to gtkdoc for autodocs.
	Adjust source code comment style.

	* rasqal/docs/version.xml.in: version xml

	* configure.ac: require gtk-doc 1.4

	* rasqal/autogen.sh: run gtkdocize

	* rasqal/configure.ac, configure.ac: require gtk-doc 1.4

2005-07-28  Dave Beckett  <dave@dajobe.org>

	* rasqal/utils/roqet.1: Update for newer result formats.

	* rasqal/tests/sparql/syntax/manifest.n3,
	rasqal/tests/sparql/syntax/Makefile.am: distinct-with-undef-var

	* rasqal/tests/sparql/syntax/distinct-undef.rq,
	rasqal/tests/sparql/syntax/result-distinct-undef.ttl: tests for
	distinct with an undef var

	* rasqal/src/rasqal_query.c
	(rasqal_query_result_literal_sequence_compare): Two NULL literals
	means equality not a final comparison result, so keep searching.

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/manifest.n3,
	rasqal/tests/sparql/syntax/order-distinct.rq,
	rasqal/tests/sparql/syntax/order.ttl,
	rasqal/tests/sparql/syntax/result-order-distinct.ttl: Added order
	and distinct check

	* rasqal/src/sparql_parser.y (PatternElement): Error recovery from
	NULL triples but do return a graph pattern of some sort.

	* rasqal/src/sparql_parser.y (PatternElement): Error recovery - do
	not die when triples is NULL.

2005-07-27  Dave Beckett  <dave@dajobe.org>

	* raptor/Makefile.am, raptor/docs/Makefile.am,
	raptor/src/Makefile.am, raptor/utils/Makefile.am: Add
	n3_lexer_test, n3_parser_test for maintainer

	* raptor/src/n3_parser.y, raptor/src/turtle_parser.y (main): Make
	it compile

	* raptor/src/n3_parser.y: Updates from turtle_parser.y: gcc4
	ignored return warning fixes:
	(main): Check fread() return value and throw a user error.
	(main): Fix for gcc4
	(main) Move filename here

	* raptor/examples/grapper.c: Add author url

	* raptor/src/raptor_rss.c (raptor_rss_uplift_fields): Add
	possibility of normalizing fields, but no code to do it yet.

	* raptor/src/raptor_rss_common.c (raptor_rss_date_uplift): fail
	and do nothing if function returns <0

	* raptor/src/raptor_rss.c (raptor_rss_uplift_fields): Moved date
	code into raptor_rss_date_uplift and call it.

	* raptor/src/raptor_rss.h: Added raptor_rss_date_uplift prototype

	* raptor/src/raptor_rss_common.c (raptor_rss_date_uplift): Added,
	pulled out of raptor_rss.c

	* raptor/src/turtle_parser.y: gcc4 ignored return warning fixes:
	(main): Check fread() return value and throw a user error.

	* rasqal/src/sparql_parser.y, rasqal/utils/roqet.c,
	rasqal/src/rdql_parser.y, rasqal/src/rasqal_map.c: gcc4 ignored
	return warning fixes: Discard fwrite() return values since
	fprintf/fputs() aren't checked.  Check fread() return values and
	throw a user error.

	* rasqal/src/rasqal_skiplist.c, rasqal/src/rasqal_map.c: autodocs

	* rasqal/src/rasqal_query.c (rasqal_query_execute): For a stored
	sequence of result rows, use result_count as an offset so
	initialise to 0 always
	(rasqal_query_results_next, rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_value_by_name): Adjust to use
	offset.

	* rasqal/src/rasqal_query.c: Removed RASQAL_MAP define; it's the
	default now.

	* rasqal/src/rasqal_skiplist.c (main): Update for new
	rasqal_new_skiplist API

	* rasqal/src/rasqal_query.c: General: rasqal_tree renamed to
	rasqal_map and code moved to rasqal_map.c
	(rasqal_new_query_result_row, rasqal_free_query_result_row):
	Init/use usage counting.
	(rasqal_new_query_result_row_from_query_result_row): Added.
	(rasqal_query_result_row_compare): Take void* args, like a qsort()
	compare Do a distinct comparison on values before an ordering, if
	needed and discard duplicates there.
	(rasqal_map_print_query_result_row,
	rasqal_map_free_query_result_row): Added as rasqal_map helpers.
	(rasqal_query_execute): Make a new map, not tree, calling above
	helpers.

	* rasqal/src/rasqal_map.c: autodocs

	* rasqal/src/rasqal_map.c (rasqal_free_map_node): follow subtrees
	recursively.

	* rasqal/src/rasqal_skiplist.c: rasqal_skiplist_s gains split
	key/value print handler methods
	(rasqal_new_skiplist): Split print_fn into print_key_fn and
	print_value_fn
	(rasqal_skiplist_node_print): Use new functions.

	* rasqal/src/rasqal_internal.h: rasqal_query_result_row gains
	usage count Changed skiplist API to split key/value print handler
	methods Added rasqal_map class, methods.

	* rasqal/Makefile.am: Added rasqal_map.c

	* rasqal/src/rasqal_map.c: Rasqal simple Key:Value Map with
	duplicates allowed

	* rasqal/src/rasqal_query.c (rasqal_query_execute): If added a
	duplicate, free the row.

	* rasqal/src/rasqal_raptor.c (ordinal_as_uri): off by 1 in making
	ordinal URI.

2005-07-26  Dave Beckett  <dave@dajobe.org>

	* rasqal/src/rasqal_query.c: sparql-results

	* rasqal/src/rasqal_query.c, rasqal/utils/roqet.c: Changed results
	namespace from http://www.w3.org/2005/06/sparqlResults to
	http://www.w3.org/2005/sparql-results#

2005-07-25  Dave Beckett  <dave@dajobe.org>

	* raptor/examples/grapper.c (fs_ok_button_callback): Protect from
	defining when when not used as a callback.
	(open_button_callback): cast for gcc4

2005-07-24  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_rss.c (raptor_rss_parser_processNode): for
	rss:link and atom:link with href, allow multiple link for atom,
	and continue to ignore all but <link rel="altenrate"> for rss.

	* raptor/src/raptor_rss_common.c: Tidying.  Added atom:feed and
	atom:entry to raptor_rss_types_info.  Declare atom namespace URI
	string raptor_atom_namespace_uri

	* raptor/src/raptor_rss.h: Added RAPTOR_ATOM_FEED,
	RAPTOR_ATOM_ENTRY.

	* raptor/src/raptor_serialize_rss.c: Add atom 1.0 serializing by
	generalising rss 1.0 serializing.  Change field names to reflect
	this rdf_nspace -> default_nspace, rdf_RDF_element ->
	root_element.  Add is_atom flag.
	(raptor_rss10_serialize_init): Init is_atom flag.
	(raptor_rss10_move_statements, raptor_rss10_store_statement):
	Rename back fields translated to rss: namespace.
	(raptor_rss10_build_xml_names): Init namespace qname for rss/atom.
	Declare the default namespace to rss/atom.  Ignore all item types
	but rss:item for atom; all but atom:author for rss.  For item node
	type use atom:entry / rss:item.
	(raptor_rss10_emit_item): Add emit_container flag to prevent
	generating the containing elements.  For atom:author, generate it
	inline for atom, ignore it for rss.  When generating URI-valued
	fields for atom, make them element content.  For atom, do not
	generate rdf:Seq block.
	(raptor_rss10_serialize_end): Only emit node type rss:item (aka
	atom:entry) for atom.
	(raptor_init_serializer_atom): Added.

	* raptor/configure.ac: Added atom serializer, enabled for
	maintainer only.

	* raptor/src/raptor_general.c (raptor_init): Add call to
	raptor_init_serializer_atom if enabled

	* raptor/src/raptor_internal.h: Added prototype for
	raptor_init_serializer_atom Added raptor_atom_namespace_uri

	* raptor/src/raptor_serialize_rss.c (raptor_rss10_serialize_end):
	End with an error if no rss channel was found.

	* raptor/Makefile.am, raptor/docs/Makefile.am,
	raptor/src/Makefile.am, raptor/utils/Makefile.am: Use
	RAPTOR_SERIALIZER_RSS_1_0 for new separate rss serializer.  Use
	RAPTOR_RSS_COMMON when either rss parser or serializer is needed.

	* raptor/configure.ac: RSS 1.0 serializer is always available and
	does not need the libxml requirements of the RSS tag soup parser.
	Added RAPTOR_SERIALIZER_RSS_1_0 define and makefile conditional.
	Added RAPTOR_RSS_COMMON when any rss code is needed.

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: Moved common code between
	parser and serializer from raptor_rss.c into new
	raptor_rss_common.c as new class raptor_rss_model.  Moved rss-1.0
	serializer into new raptor_serialize_rss.c.  Both can be compiled
	independent of the other.

	* raptor/src/raptor_rss.h: Redland Parser Toolkit Internal RSS
	Model and API

	* raptor/src/raptor_internal.h: Add RAPTOR_PARSEDATE_FUNCTION
	macro for parsedate.c

	* raptor/src/raptor_general.c (raptor_init): Use define
	RAPTOR_SERIALIZER_RSS_1_0 to call raptor_init_serializer_rss10

	* raptor/src/raptor_xml.c, raptor/src/raptor_sax2.c: Moved
	raptor_new_xml_element, raptor_free_xml_element,
	raptor_xml_element_set_attributes,
	raptor_xml_element_declare_namespace, raptor_print_xml_element,
	raptor_iostream_write_xml_element from raptor_sax2.c to
	raptor_xml.c

2005-07-23  Dave Beckett  <dave@dajobe.org>

	* librdf/redland.spec.in: date typo

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: More base URIs on base URIs
	fixes.
	(raptor_rss_parser_processNode): Ensure base URI is always copied
	at start element, always freed at end element.  Make sure xml:base
	processing is done for all elements including document and
	typed-node ones.
	(raptor_rss_parse_chunk): Remove duplicate document base URI
	setting.

2005-07-22  Dave Beckett  <dave@dajobe.org>

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: raptor_rss_info gains flags
	field to store RAPTOR_RSS_INFO_FLAG_URI_VALUE where the value of
	the element <foo>value</foo> is always a URI.  Apply that to
	atom:id, atom:icon and atom:logo.  struct
	raptor_rss_parser_context_s gains a sequence of base URIs
	per-element.
	(raptor_rss_context_init, raptor_rss_context_terminate): Init and
	free sequence of base URIs.
	(raptor_rss_parse_start): Start base URI sequence with parser base
	URI.
	(raptor_rss_parser_processNode): Init base_uri from top of stack
	of base URIs.  Update base_uri from an xml:base arg, relative to
	the current base URI.  Use the base URI for all URi constructions.
	Push the new base URI after an element has been found.  Pop the
	base URI at the end of an element.  At the end of an element, if
	the field always has a URI value, convert it.
	(raptor_rss_parse_chunk): Init the URI sequence with the parser
	base URI.

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: map raptor_atom_to_rss: turn
	more atom cloned rss fields into rss fields.
	(raptor_rss_uplift_fields): Change default action to copy
	(duplicate) fields.
	(raptor_rss10_emit_item): Do not emit link to atom:author types in
	rss1.0
	(raptor_rss10_serialize_end): Do not emit atom:author type in
	rss1.0

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: Added atom 1.0 namespace
	(ATOM1_0_NAMESPACE_URI, ASTOM1_0_NS) and terms.  Turn old atom 0.3
	terms into 1.0 versions where known using raptor_atom_to_rss.
	(raptor_rss_parser_processNode): Handle atom feed element
	properly, make a new channel item.  Convert atom 0.3 namespaced
	elements to atom 1.0 Use atom:id to get a URI for the feed/entry
	Copy atom:published to dc:date and atom:rights to dc:rights via
	raptor_rss_uplift_map.
	(raptor_rss_uplift_fields): Copy dc:date and atom:rights

	* raptor/src/raptor_rss.c, raptor/src/raptor_rss_common.c,
	raptor/src/raptor_serialize_rss.c: Added content: namespace
	CONTENT_NAMESPACE_URI, prefix "content:" Added content:encoded
	field RAPTOR_RSS_FIELD_CONTENT_ENCODED
	(raptor_rss_uplift_fields): Added an uplift from description to
	content:encoded
	(raptor_rss10_emit_item): Write content:encoded using
	<![CDATA[...]]>

2005-07-21  Dave Beckett  <dave@dajobe.org>

	* librdf/rdf_concepts.h: Move some docs into the sgml template

	* configure.ac: Added docs/version.xml

	* docs/Makefile.am, docs/redland-chapter-intro.xml,
	docs/redland-chapter-objects.xml, docs/redland-docs.xml,
	docs/redland-intro.xml, docs/redland-objects-in-c.xml,
	docs/version.xml.in: more gtk-doc

	* librdf/redland.spec.in: Updated for gtk-doc locations

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_result2,
	rasqal_query_results_write_xml_result3): Use
	RASQAL_XSD_BOOLEAN_TRUE and RASQAL_XSD_BOOLEAN_FALSE for boolean
	result value.
	(rasqal_query_results_write_xml_result3): Add ordered and distinct
	attributes to <results> element.

	* rasqal/rasqal_literal.c (rasqal_literal_string_to_native,
	rasqal_new_boolean_literal): Use RASQAL_XSD_BOOLEAN_TRUE and
	RASQAL_XSD_BOOLEAN_FALSE.

	* rasqal/rasqal_internal.h: Added RASQAL_XSD_BOOLEAN_TRUE and
	RASQAL_XSD_BOOLEAN_FALSE, maybe could be pointers to a shared
	string but compilers can work it out.

	* docs/redland-sections.txt: remove internal
	librdf_concept_ms_namespace_uri and
	librdf_concept_schema_namespace_uri

	* librdf/rdf_concepts.h: docs

	* docs/Makefile.am: Remove unused SCAN_OPTIONS

2005-07-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* examples/Makefile.am: added example7

	* examples/example7.c: read from a file 'file.rdf', add a triple,
	write it again

2005-07-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am: Remove 1-function headers from dist

	* librdf/rdf_node.h: removed librdf_node_init - has no code

	* docs/redland-docs.xml: redland doc

	* docs/redland-intro.xml: Doc intro

	* docs/redland-objects-in-c.xml: Objects in C

	* librdf/rdf_uri.c (librdf_uri_print): xml fix

	* docs/redland-sections.txt: doc sections

	* librdf/rdf_node.h: librdf_node_init removed - in header only

	* docs/Makefile.am: ignore internal headers

	* librdf/rdf_query_results.c, librdf/rdf_node.c: More fixes for
	gtkdoc

	* librdf/rdf_stream.c, librdf/rdf_stream.h, librdf/rdf_uri.c,
	librdf/rdf_uri.h, librdf/rdf_utf8.c, librdf/rdf_concepts.c,
	librdf/rdf_digest.c, librdf/rdf_digest.h, librdf/rdf_digest_md5.c,
	librdf/rdf_digest_openssl.c, librdf/rdf_digest_sha1.c,
	librdf/rdf_hash.c, librdf/rdf_hash.h, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash_cursor.c, librdf/rdf_hash_memory.c,
	librdf/rdf_heuristics.c, librdf/rdf_init.c, librdf/rdf_init.h,
	librdf/rdf_iterator.c, librdf/rdf_iterator.h, librdf/rdf_list.c,
	librdf/rdf_log.c, librdf/rdf_log.h, librdf/rdf_model.c,
	librdf/rdf_model.h, librdf/rdf_model_storage.c, librdf/rdf_node.c,
	librdf/rdf_node.h, librdf/rdf_parser.c, librdf/rdf_parser.h,
	librdf/rdf_parser_raptor.c, librdf/rdf_query.c,
	librdf/rdf_query.h, librdf/rdf_query_results.c,
	librdf/rdf_query_triples.c, librdf/rdf_serializer.c,
	librdf/rdf_serializer.h, librdf/rdf_serializer_raptor.c,
	librdf/rdf_statement.c, librdf/rdf_statement.h,
	librdf/rdf_storage.c, librdf/rdf_storage.h,
	librdf/rdf_storage_hashes.c, librdf/rdf_storage_list.c,
	librdf/rdf_storage_mysql.c, librdf/rdf_storage_sqlite.c,
	librdf/rdf_storage_tstore.c: automated docucomments updates for
	gtk-doc

	* autogen.sh: allow gtkdocize to fail

	* librdf/rdf_concepts_internal.h, librdf/rdf_digest_internal.h,
	librdf/rdf_hash_internal.h, librdf/rdf_iterator_internal.h,
	librdf/rdf_list_internal.h, librdf/rdf_log_internal.h,
	librdf/rdf_model_internal.h, librdf/rdf_node_internal.h,
	librdf/rdf_query_internal.h, librdf/rdf_serializer_internal.h,
	librdf/rdf_statement_internal.h, librdf/rdf_storage_internal.h,
	librdf/rdf_stream_internal.h, librdf/rdf_uri_internal.h: comment
	words

	* raptor/raptor_guess.c (raptor_guess_parse_chunk): unused var
	parser

	* librdf/rdf_list_internal.h: Remove some calls to public headers
	that are in redland.h also.

	* raptor/ntriples_parse.c (raptor_init_parser_ntriples): Do not
	register interest in text/plain -- too general.

	* librdf/Makefile.am: Added more internal headers

	* librdf/librdf.h, librdf/rdf_concepts.h, librdf/rdf_digest.h,
	librdf/rdf_hash.c, librdf/rdf_hash.h, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash_memory.c, librdf/rdf_init.h,
	librdf/rdf_internal.h, librdf/rdf_iterator.h, librdf/rdf_list.h,
	librdf/rdf_log.h, librdf/rdf_model.h, librdf/rdf_model_storage.h,
	librdf/rdf_node.h, librdf/rdf_parser.h, librdf/rdf_query.h,
	librdf/rdf_serializer.h, librdf/rdf_statement.h,
	librdf/rdf_storage.h, librdf/rdf_storage_hashes.c,
	librdf/rdf_stream.h, librdf/rdf_uri.h: use rdf_MODULE_internal.h
	headersrdf_*.h

	* librdf/rdf_concepts_internal.h, librdf/rdf_digest_internal.h,
	librdf/rdf_hash_internal.h, librdf/rdf_iterator_internal.h,
	librdf/rdf_list_internal.h, librdf/rdf_log_internal.h,
	librdf/rdf_model_internal.h, librdf/rdf_node_internal.h,
	librdf/rdf_parser_internal.h, librdf/rdf_query_internal.h,
	librdf/rdf_serializer_internal.h, librdf/rdf_statement_internal.h,
	librdf/rdf_storage_internal.h, librdf/rdf_stream_internal.h: added
	rdf_MODULE_internal.h headers

	* librdf/rdf_hash_bdb.h, librdf/rdf_hash_memory.h,
	librdf/rdf_storage_hashes.h, librdf/rdf_storage_list.h: delete 1
	function headers

	* docs/redland.types: must be empty

	* docs/kernel-doc, docs/build-docs: replace with gtk-doc

	* docs/api.html.in, docs/api.sgml.in: switch to gtk-doc

	* docs/redland-intro.xml, docs/redland-docs.xml: gtk-doc bit

	* autogen.sh: Run gtkdocize

	* docs/Makefile.am: Switch to gtk-doc

	* configure.ac: Added GTK_DOC_CHECK

	* Makefile.am: Added gtk-doc.make

	* librdf/Makefile.am: Added rdf_init_internal.h rdf_uri_internal.h

	* librdf/rdf_storage_sqlite.c, librdf/rdf_storage_tstore.c,
	librdf/rdf_stream.c, librdf/rdf_uri.c, librdf/rdf_uri.h,
	librdf/rdf_uri_internal.h, librdf/rdf_utf8.c, librdf/librdf.h,
	librdf/rdf_concepts.c, librdf/rdf_digest.c,
	librdf/rdf_digest_md5.c, librdf/rdf_digest_sha1.c,
	librdf/rdf_hash.c, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash_cursor.c, librdf/rdf_hash_memory.c,
	librdf/rdf_init.c, librdf/rdf_init.h, librdf/rdf_init_internal.h,
	librdf/rdf_internal.h, librdf/rdf_iterator.c, librdf/rdf_list.c,
	librdf/rdf_log.c, librdf/rdf_model.c, librdf/rdf_model.h,
	librdf/rdf_model_storage.c, librdf/rdf_node.c,
	librdf/rdf_parser.c, librdf/rdf_parser_raptor.c,
	librdf/rdf_query.c, librdf/rdf_query_results.c,
	librdf/rdf_query_triples.c, librdf/rdf_serializer.c,
	librdf/rdf_serializer_raptor.c, librdf/rdf_statement.c,
	librdf/rdf_storage.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_mysql.c: Updates for
	gtk-doc.  Pull out internal headers

	* Switch API docs from gnome-doc / kernel-doc to gtk-doc.  This
	requires a variety of source level changes that edit the
	docucomments as well as some header file edits to work with
	gtk-doc.   Internal symbols are removed from public headers
	entirely.
	
2005-07-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_concepts.c: death to M&S for xml docs

	* raptor/raptor_guess.c: Slim down, to use raptor_parser_exec.
	(raptor_guess_parse_start): Deleted again.
	(raptor_guess_parse_chunk): Use guessing and raptor_parser_exec to
	switch to the right parser.

	* raptor/raptor_internal.h: Added prototype to raptor_parser_exec

	* raptor/raptor_parse.c (raptor_parser_exec): Added to turn one
	parser type into another in-situ.

	* raptor/rdfdump.c: make -g invoke the guess parser and report the
	resulting parser at the first triple returned

	* raptor/raptor_guess.c (raptor_guess_parse_start): Added.
	(raptor_guess_parse_chunk): Pass in buffer to
	raptor_guess_parser_name since we have it.  Work with no
	content_type such as when using a filename alone.

	* raptor/ntriples_parse.c (raptor_ntriples_parse_chunk): Handle
	ending on \r\n by updating 'start' by 1 position.

	* configure.ac: Require rasqal 0.9.11

	* configure.ac: Require raptor 1.4.8 for guess parser.

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source): Use
	raptor guess parser.

	* rasqal/configure.ac: Require raptor 1.4.8 for guess parser.

	* raptor/ntriples_parse.c (raptor_ntriples_term): Check sscanf
	return to catch bad \u or \U hex escape.

	* raptor/turtle_lexer.l (turtle_copy_string_token): Check sscanf
	return to catch bad \u or \U hex escape.

	* raptor/raptor_general.c (raptor_init): Added guessing parser

	* raptor/configure.ac, raptor/Makefile.am: Added raptor_guess.c

	* raptor/raptor_guess.c: guessing parser using content type and an
	internal parser

	* raptor/raptor_xslt.c (raptor_xslt_parse_start): No need to init
	column, byte locator.

	* raptor/raptor_rdfxml.c (raptor_xml_parse_recognise_syntax):
	Guess that application/xml is likely RDF/XML

	* raptor/raptor_internal.h: raptor_parser_factory_s gains a
	content_type_handler field.

	* raptor/raptor_parse.c (raptor_start_parse): Init locator line,
	column, byte to -1 (unknown)
	(raptor_parse_uri_content_type_handler): Added to handle
	raptor_www content type field return.  Pass on to factory method
	content_type_handler if present.
	(raptor_parse_uri_with_connection): Init
	raptor_parse_uri_content_type_handler to receive raptor_www
	callbacks using raptor_www_set_content_type_handler.
	(raptor_guess_parser_name): Check static buffer size for overflow.
	Add some comments.

	* raptor/raptor_xslt.c (raptor_xslt_parse_start): Use
	raptor_parser_copy_user_state

	* raptor/raptor_parse.c (raptor_parser_copy_user_state): docs

	* raptor/raptor_parse.c (raptor_parser_copy_user_state): Added.

	* raptor/raptor_internal.h: Added prototype for
	raptor_parser_copy_user_state

	* raptor/tests/ex-58.rdf, raptor/tests/ex-58.out,
	raptor/tests/Makefile.am: Added ex-58

	* raptor/raptor_rdfxml.c (raptor_end_element_grammar): When
	emitting literals, handle a datatyped empty literal.  Merge the
	property element/member property element code.

	* raptor/tests/ex-57.rdf, raptor/tests/ex-57.out,
	raptor/tests/Makefile.am: Added ex-57

2005-07-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_tstore.c: Unbreak 3store backend from not
	compiling.

2005-07-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y: Update to rq23 CVS 1.423 2005/07/14
	12:04:17

	* rasqal/Makefile.am: rasqal_skiplist_test is in TESTS

	* rasqal/rasqal_internal.h, rasqal/rasqal_skiplist.c: Moved
	internal struct rasqal_skiplist_node into rasqal_skiplist.c again.

	* rasqal/rasqal_internal.h: words

	* rasqal/rasqal_internal.h, rasqal/rasqal_skiplist.c: Moved
	rasqal_skiplist headers into rasqal_internal.h for now.

	* rasqal/rasqal_skiplist.c: Skip list implememntation

	* rasqal/Makefile.am: Added rasqal_skiplist.c and
	rasqal_skiplist_test

2005-07-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_result3):
	Indent <boolean> by 2

	* rasqal/roqet.c: Added new xml format with URI
	http://www.w3.org/2005/06/sparqlResults and made old one available
	via xml-v2

	* rasqal/rasqal_query.c (rasqal_query_results_write): comments
	docs for URI http://www.w3.org/2005/06/sparqlResults.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Allow NULL
	URI for default format.  Add format V3 with URi
	http://www.w3.org/2005/06/sparqlResults.
	(rasqal_query_results_write_xml_result3): Added for latest format
	and new namespace.

	* rasqal/sparql_lexer.l (// comment rule, # comment rule): Use
	better grab-till-newline form.

	* raptor/turtle_lexer.l: Switch qname, blank node and prefix
	definitions to SPARQL ones.
	(main): Fixes for gcc4

	* raptor/turtle_parser.y (main): Fix for gcc4

	* rasqal/tests/sparql/SyntaxFull/manifest.ttl,
	rasqal/tests/sparql/ValueTesting/extendedType-0.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-eq-pass.rq,
	rasqal/tests/sparql/regex/regex-query-003.rq,
	rasqal/tests/sparql/regex/regex-query-004.rq: Update tests from
	DAWG CVS

	* raptor/raptor_utf8.c (raptor_unicode_is_xml11_namechar): Call
	raptor_unicode_is_xml11_namestartchar.

	* rasqal/sparql_lexer.l (rasqal_sparql_name_check): Ignore 0
	length names - checked in parser.  Make all name problems into
	errors rather than warnings.

2005-07-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_lexer.l: Reference rq23 Added
	sparql_name_check_flags enum for sparql name checking.  Updated
	SPARQL name tokens to match latest rq23 - lots of comments.
	(// C++ comment rule): Use pattern to find end of line with
	multiple line endings.  Count line.
	(/* C comment block rule): Use returned lines to bump the current
	line number.
	(<ID>{VARNAME} rule): Check varnames.
	(<PREF>{NCNAME_PREFIX}":" rule): Check prefix.
	({BNAME} rule): Check ncname.
	(rasqal_sparql_name_check): Added to do XML Name 1.1 check and
	others.
	(sparql_copy_name): Add check_flag and use it with
	rasqal_sparql_name_check instead of raptor_xml_name_check.
	(sparql_copy_qname, sparql_copy_string_token): Use
	rasqal_sparql_name_check instead of raptor_xml_name_check.
	(sparql_skip_cpp_comment): Deleted.

	* rasqal/rdql_lexer.l (// C++ comment rule): Use pattern to find
	end of line with multiple line endings.  Count line.
	(/* C comment block rule): Use returned lines to bump the current
	line number.
	(rdql_skip_cpp_comment): Deleted.

	* rasqal/tests/sparql/SyntaxFull/manifest.ttl,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-14.rq: Updates from
	DAWG tests

2005-07-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: time headers

	* rasqal/configure.ac: Test for srandomdev

	* raptor/configure.ac: Check for isascii, for parsedate.y

	* raptor/parsedate.y: Update source links

2005-06-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_query.c (rasqal_query_execute): Do the result
	making outside #ifdef RASQAL_DEBUG ... #endif Oops!

	* rasqal/rasqal_expr.c (main): Add flags arg to
	rasqal_expression_evaluate

	* rasqal/tests/sparql/survey/Makefile.am: survey-10 works.  now 1
	failure

	* rasqal/rasqal_query.c: Added alternate results sorting using
	RASQAL_TREE define trigger to merge into a b-tree.
	(rasqal_query_result_row_update): Pass query compare_flags
	argument to rasqal_expression_evaluate.
	(rasqal_query_result_literal_sequence_compare): Added with main
	contant from rasqal_engine_query_results_compare.  Operates over
	arrays of values of the given size.
	(rasqal_query_results_row_compare): Call above for order
	conditions or row values to handle ORDER BY(with/without DISTINCT)
	or DISTINCT alone.
	(rasqal_query_results_compare): Added.
	(rasqal_new_tree_node, rasqal_free_tree_node, rasqal_new_tree,
	rasqal_free_tree, rasqal_tree_node_add_row, rasqal_tree_add_row,
	rasqal_tree_node_write_indent, rasqal_tree_node_print_internal,
	rasqal_tree_print, rasqal_tree_node_visit, rasqal_tree_visit,
	rasqal_tree_add_to_sequence): Added to implement tree of rows
	sorted on add with optional distinct results.
	(rasqal_query_execute): Add alternate tree results collation
	enabled by RASQAL_TREE implementing distinct.

	* rasqal/tests/sparql/sort/Makefile.am: sort-6 now passes.  no
	sort failures

	* rasqal/tests/sparql/ExprEquals/Makefile.am: "Equality 1-1" and
	"Equality 1-2" now pass.  down to 2 failures

	* rasqal/rasqal_engine.c (rasqal_engine_check_constraint,
	rasqal_engine_expression_foreach_fold): Use flags argument
	in. rasqal_expression_evaluate taken from query compare_flags
	field.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_init): Set
	query compare_flags to RASQAL_COMPARE_XQUERY enabling XQuery
	comparison and promotions.

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): Added flags
	argument, to pass down to rasqal_literal_compare.  Pass it down to
	internal uses of rasqal_expression_evaluate also.

	* rasqal/rasqal_literal.c: rasqal_literal_type_labels reordered to
	match changes to rasqal_literal_type in rasqal.h
	(rasqal_literal_compare): Added RASQAL_COMPARE_XQUERY to use
	XQuery comparison and type promotions.  When the above flag is
	set, only promote numeric types and otherwise compare different
	types using the order in rasqal_literal_type enum.

	* rasqal/rasqal_internal.h: rasqal_query gains compare_flags
	structure

	* rasqal/roqet.c: spaces 80

	* rasqal/rasqal.h: Reordered the types in rasqal_literal_type to
	make them useful for sparql type promotion.  Added define
	RASQAL_COMPARE_XQUERY Added flags argument to
	rasqal_expression_evaluate prototype.

	* rasqal/roqet.c (roqet_write_indent): Handle any depth indenting.

	* raptor/raptor_rss.c (raptor_rss_uplift_fields): Fix valid
	condition.

	* raptor/raptor_rss.c: raptor_rss_uplift_map - added,
	rss091:pubDate -> dc:date in ISO format
	(raptor_rss_uplift_fields): Added, to search for fields to uplift.
	(raptor_rss_uplift_items): Added, to scan items to uplift.
	(raptor_rss_parse_chunk): Call raptor_rss_uplift_items.

2005-06-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c: Fixes for C++.

	* rasqal/tests/sparql/check-sparql: Warn short form of cmd lines

2005-06-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_engine_prepare): Call
	rasqal_engine_query_fold_expressions.
	(rasqal_engine_expression_foreach_fold): Added to use with
	rasqal_expression_foreach.
	(rasqal_engine_expression_fold): Added, to fold an expression tree
	until no changes are made.
	(rasqal_engine_graph_pattern_fold_expressions): Added, to fold
	expressions inside a graph pattern - in sub graph patterns and in
	constraint expression.
	(rasqal_engine_query_fold_expressions): Added, to fold expressions
	inside a graph - in graph patterns and order conditions.

	* rasqal/rasqal_expr.c (rasqal_expression_clear): Added, to
	deallocate a static rasqal_expression.
	(rasqal_free_expression): Use above.
	(rasqal_expression_foreach): Do current node explicitly first,
	before op check is done so that the user function could change the
	op potentially.  Handle op LITERAL and op FUNCTION correctly.
	(rasqal_expression_is_constant): Added to check if the expression
	tree is a constant expression.
	(rasqal_expression_convert_to_literal): Convert an expression tree
	into a literal in-situ.

	* rasqal/rasqal_literal.c (rasqal_literal_is_constant): Added
	returning non-0 if literal is a constant i.e. not a variable.

	* rasqal/rasqal_internal.h: Added prototypes for
	rasqal_engine_expression_fold,
	rasqal_engine_graph_pattern_fold_expressions,
	rasqal_engine_query_fold_expressions, rasqal_literal_is_constant,
	rasqal_expression_is_constant, rasqal_expression_clear and
	rasqal_expression_convert_to_literal.

	* rasqal/tests/sparql/examples/Makefile.am:
	sparql-query-example-Testing-Values-isLiteral works.  3 fail now.

	* rasqal/tests/sparql/examples/ex11.2.3.1_1.n3,
	rasqal/tests/sparql/examples/ex11.2.3.2_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.5_0.n3,
	rasqal/tests/sparql/examples/ex11_0.n3: Date fixes from DAWG CVS

	* rasqal/tests/sparql/examples/ex11.2.3.1_1.rq,
	rasqal/tests/sparql/examples/ex11.2.3.2_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.2_1.rq,
	rasqal/tests/sparql/examples/ex11.2.3.7_0.rq,
	rasqal/tests/sparql/examples/ex11_0.rq,
	rasqal/tests/sparql/examples/ex11_1.rq,
	rasqal/tests/sparql/examples/ex11.2.3.1_0.rq: Update for FILTER()

	* rasqal/tests/sparql/examples/Makefile.am: Correct test failures,
	count remains same

2005-06-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/survey/Makefile.am: survey-13 now passes.
	now 2 failures

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_20041221,
	rasqal_query_results_write_xml_result2): Use string_len rather
	than strlen().

	* rasqal/rasqal_internal.h: Added prototype for
	rasqal_literal_ebv.  Added constants rasqal_xsd_decimal_uri,
	rasqal_xsd_datetime_uri and rasqal_xsd_string_uri.

	* rasqal/rasqal_literal.c (rasqal_new_integer_literal,
	rasqal_new_double_literal, rasqal_new_pattern_literal,
	rasqal_new_string_literal, rasqal_new_simple_literal,
	rasqal_new_boolean_literal): Initialise the string_len field.
	(rasqal_literal_string_to_native): Initialise string_len field
	when turning into a boolean.
	(rasqal_literal_expand_qname): Use string_len field to initialise
	raptor_qname_string_to_uri.
	(rasqal_literal_as_node): When making a new typed literal,
	initialise string_len field.
	(rasqal_literal_ebv): Added, to return the Effective Boolean Value
	(EBV) of a literal.

	* rasqal/rasqal.h: rasqal_literal gains string_len field.

	* rasqal/sparql_parser.y (sparql_is_builtin_xsd_datatype): Added
	to check for the types that sparql supports.
	(FunctionCall): Use sparql_is_builtin_xsd_datatype to distinguish
	a cast from a function - name is the datatype URI, has 1 arg.

	* rasqal/rasqal_general.c: Added constants rasqal_xsd_decimal_uri,
	rasqal_xsd_datetime_uri and rasqal_xsd_string_uri constants.
	(rasqal_uri_init, rasqal_uri_finish): Init and free
	rasqal_xsd_decimal_uri, rasqal_xsd_datetime_uri and
	rasqal_xsd_string_uri.

2005-06-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/Expr1/expr-1.rq,
	rasqal/tests/sparql/Expr1/expr-2.rq,
	rasqal/tests/sparql/Expr1/expr-3.rq,
	rasqal/tests/sparql/Expr2/query-bev-1.rq,
	rasqal/tests/sparql/Expr2/query-bev-3.rq,
	rasqal/tests/sparql/Expr2/query-bev-4.rq,
	rasqal/tests/sparql/Expr2/query-bev-5.rq,
	rasqal/tests/sparql/Expr2/query-bev-6.rq,
	rasqal/tests/sparql/ExprBuiltins/q-datatype-1.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-1.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-2.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-3.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-4.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-1.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-2.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-3.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-4.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-5.rq,
	rasqal/tests/sparql/ExprEquals/query-eq2-1.rq,
	rasqal/tests/sparql/ExprEquals/query-eq2-2.rq,
	rasqal/tests/sparql/SyntaxFull/manifest.ttl,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-08.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-0.n3,
	rasqal/tests/sparql/regex/regex-query-001.rq,
	rasqal/tests/sparql/regex/regex-query-002.rq,
	rasqal/tests/sparql/regex/regex-query-003.rq,
	rasqal/tests/sparql/regex/regex-query-004.rq: Updates from DAWG
	CVS

	* rasqal/rasqal_query.c: Moved rasqal_query_result_row to
	rasqal-internal.h
	(rasqal_new_query_result_row): Handle no order_conditions_sequence
	present.  Set NULL literal values when they appear, as from
	OPTIONAL.
	(rasqal_query_results_update): Added, based on core of
	rasqal_query_results_next to get next result from query engine,
	including offsets.
	(rasqal_query_execute): Use rasqal_query_results_update when not
	sorting and make a query_results->row
	(rasqal_free_query_results): Free any row field used.
	(rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_value_by_name): Return row
	values, using query_results row field for stream results.

	* rasqal/rasqal_raptor.c (rasqal_raptor_bind_match): Use
	rasqal_new_literal_from_literal when binding literal values, do
	not turn them into nodes this early.

	* rasqal/tests/sparql/sort/Makefile.am: sort-4 sort-7 pass now
	only fail sort-6

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): For case
	RASQAL_EXPR_LT, RASQAL_EXPR_GT, RASQAL_EXPR_LE, RASQAL_EXPR_GE -
	invert the test for the result of rasqal_literal_compare test as
	it was totally backwards for ints and doubles.

	* rasqal/rasqal_literal.c (rasqal_literal_compare): Return correct
	<0, 0, >0 for integers and doubles.  It was formerly negative the
	right result.

	* rasqal/rasqal_internal.h: Added struct rasqal_query_result_row
	internal for now.  rasqal_query_results gains field row for use as
	the current result row when streaming results.

	* rasqal/tests/sparql/check-sparql: tidy messages

	* rasqal/rasqal_query.c (rasqal_new_query_result_row): Just do
	allocations here, and use rasqal_query_result_row_update to update
	the contents from the current query engine result.
	(rasqal_query_result_row_update): Added, updating the given row
	with the current query engine result.

2005-06-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_literal.c (rasqal_literal_print): Fix formats for
	decimal, datetime

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_20041221,
	rasqal_query_results_write_xml_result2,
	rasqal_query_results_get_triple): Handle RASQAL_LITERAL_FLOAT (as
	a double), RASQAL_LITERAL_DECIMAL (as a string) and
	RASQAL_LITERAL_DATETIME (as a string).

	* rasqal/rasqal_literal.c (rasqal_new_double_literal): Added,
	based on rasqal_new_floating_literal.
	(rasqal_new_floating_literal): Now a wrapper around the above.
	(rasqal_literal_string_to_native): Promote xsd:float too.
	(rasqal_free_literal, rasqal_literal_print,
	rasqal_literal_as_boolean, rasqal_literal_as_integer,
	rasqal_literal_as_floating, rasqal_literal_as_string,
	rasqal_literal_compare, rasqal_literal_equals,
	rasqal_literal_as_node): Handle RASQAL_LITERAL_FLOAT (as a
	double), RASQAL_LITERAL_DECIMAL (as a string) and
	RASQAL_LITERAL_DATETIME (as a string).

	* rasqal/rasqal_redland.c: Use RASQAL_LITERAL_DOUBLE instead of
	RASQAL_LITERAL_FLOATING

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l,
	rasqal/rasqal_expr.c: Replace rasqal_new_floating_literal with
	rasqal_new_double_literal

	* rasqal/rasqal_general.c: Added rasqal_xsd_float_uri URI
	constant.
	(rasqal_uri_init, rasqal_uri_finish): Init/free it.

	* rasqal/rasqal_internal.h: Added rasqal_xsd_float_uri.

	* rasqal/rasqal.h: Added RASQAL_LITERAL_DOUBLE (formerly
	RASQAL_LITERAL_FLOATING), RASQAL_LITERAL_FLOAT,
	RASQAL_LITERAL_DECIMAL and RASQAL_LITERAL_DATETIME.  float uses
	the 'double floating' field.  decimal and datetime use the string
	field, for now.  Deprecated rasqal_new_floating_literal Added
	prototype for rasqal_new_double_literal

	* rasqal/roqet.c: Added a -e/--exec option to execute a query
	string directly.  Usage updated to show the two forms.

2005-06-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c, rasqal/win32_rasqal_config.h: win32
	fixes from John Barstow.

2005-06-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_hash.c: Ignore fwrite return values (gcc4 warning).
	It's not like anyone ever checks fprintf, fputs either...

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l: Check for sscanf
	failure and return errors for hex, floating, \u and \U constants.

	* rasqal/rasqal_literal.c (rasqal_literal_string_to_native): Add
	error handler and data args.  Use it if sscanf fails on converting
	a float string.
	(rasqal_new_string_literal): If rasqal_literal_string_to_native
	fails, tidy up and return NULL.
	(rasqal_literal_expand_qname): if rasqal_literal_string_to_native
	fails, tidy up and return 1.

	* rasqal/rasqal_internal.h: Update rasqal_literal_string_to_native
	prototype to take an error handler and data.

	* rasqal/rasqal_general.c (rasqal_escaped_name_to_utf8_string):
	Check for sscanf failure with \u and \U such as \uGHIJ which isn't
	hex.

	* librdf/rdf_storage_list.c: remove librdf_node_encode2

	* librdf/redland.spec.in, rasqal/rasqal.spec.in,
	raptor/raptor.spec.in: License not Copyright header

2005-06-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_mysql.c,
	librdf/rdf_storage_sqlite.c, librdf/rdf_storage_tstore.c,
	librdf/rdf_stream.c, librdf/rdf_hash_bdb.c,
	librdf/rdf_hash_memory.c, librdf/rdf_list.c,
	librdf/rdf_parser_raptor.c, librdf/rdf_query.c,
	librdf/rdf_query_rasqal.c, librdf/rdf_serializer_raptor.c,
	librdf/rdf_statement.c, librdf/rdf_hash.c: Remove \n from the end
	of log messages.

	* librdf/rdf_node.c (librdf_node_encode): Give an error when a
	node cannot be encoded due to string data being too long.  Remove
	legacy 0.9.12+ #if-defed out encoding code.  It remains in
	librdf_node_decode.

2005-06-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/check-sparql: updated messages

	* rasqal/tests/sparql/regex/Makefile.am: 1 failure

	* rasqal/tests/sparql/ExprEquals/Makefile.am: 4 failures.  Add
	explicit count.

	* rasqal/tests/sparql/ExprBuiltins/Makefile.am: 4 failures

	* rasqal/tests/sparql/Expr2/Makefile.am: 6 failures.  Add explict
	count.

	* rasqal/tests/sparql/Expr1/Makefile.am: 2 failures.  Add explict
	count.

	* rasqal/tests/sparql/ExprBuiltins/Makefile.am: manifest.ttl

	* rasqal/configure.ac: Add tests/sparql regex, Expr1, Expr2,
	ExprBuiltins, ExprEquals dirs

	* rasqal/tests/sparql/ExprEquals/data-eq.ttl,
	rasqal/tests/sparql/ExprEquals/manifest.n3,
	rasqal/tests/sparql/ExprEquals/query-eq-1.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-2.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-3.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-4.rq,
	rasqal/tests/sparql/ExprEquals/query-eq-5.rq,
	rasqal/tests/sparql/ExprEquals/query-eq2-1.rq,
	rasqal/tests/sparql/ExprEquals/query-eq2-2.rq,
	rasqal/tests/sparql/ExprEquals/result-eq-1.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-2.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-3.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-4.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq-5.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq2-1.ttl,
	rasqal/tests/sparql/ExprEquals/result-eq2-2.ttl,
	rasqal/tests/sparql/regex/Makefile.am,
	rasqal/tests/sparql/regex/manifest.n3,
	rasqal/tests/sparql/regex/regex-data-01.n3,
	rasqal/tests/sparql/regex/regex-query-001.rq,
	rasqal/tests/sparql/regex/regex-query-002.rq,
	rasqal/tests/sparql/regex/regex-query-003.rq,
	rasqal/tests/sparql/regex/regex-query-004.rq,
	rasqal/tests/sparql/regex/regex-result-001.n3,
	rasqal/tests/sparql/regex/regex-result-002.n3,
	rasqal/tests/sparql/regex/regex-result-003.n3,
	rasqal/tests/sparql/regex/regex-result-004.n3,
	rasqal/tests/sparql/Expr2/data-1.ttl,
	rasqal/tests/sparql/Expr2/data-2.ttl,
	rasqal/tests/sparql/Expr2/manifest.n3,
	rasqal/tests/sparql/Expr2/query-bev-1.rq,
	rasqal/tests/sparql/Expr2/query-bev-2.rq,
	rasqal/tests/sparql/Expr2/query-bev-3.rq,
	rasqal/tests/sparql/Expr2/query-bev-4.rq,
	rasqal/tests/sparql/Expr2/query-bev-5.rq,
	rasqal/tests/sparql/Expr2/query-bev-6.rq,
	rasqal/tests/sparql/Expr2/result-bev-1.ttl,
	rasqal/tests/sparql/Expr2/result-bev-2.ttl,
	rasqal/tests/sparql/Expr2/result-bev-3.ttl,
	rasqal/tests/sparql/Expr2/result-bev-4.ttl,
	rasqal/tests/sparql/Expr2/result-bev-5.ttl,
	rasqal/tests/sparql/Expr2/result-bev-6.ttl,
	rasqal/tests/sparql/ExprBuiltins/Makefile.am,
	rasqal/tests/sparql/ExprBuiltins/data-builtin-1.ttl,
	rasqal/tests/sparql/ExprBuiltins/manifest.ttl,
	rasqal/tests/sparql/ExprBuiltins/q-blank-1.rq,
	rasqal/tests/sparql/ExprBuiltins/q-datatype-1.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-1.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-2.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-3.rq,
	rasqal/tests/sparql/ExprBuiltins/q-str-4.rq,
	rasqal/tests/sparql/ExprBuiltins/q-uri-1.rq,
	rasqal/tests/sparql/ExprBuiltins/result-blank-1.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-datatype-1.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-str-1.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-str-2.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-str-3.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-str-4.ttl,
	rasqal/tests/sparql/ExprBuiltins/result-uri-1.ttl,
	rasqal/tests/sparql/ExprEquals/Makefile.am,
	rasqal/tests/sparql/Expr1/Makefile.am,
	rasqal/tests/sparql/Expr1/data-1.ttl,
	rasqal/tests/sparql/Expr1/expr-1-result.ttl,
	rasqal/tests/sparql/Expr1/expr-1.rq,
	rasqal/tests/sparql/Expr1/expr-2-result.ttl,
	rasqal/tests/sparql/Expr1/expr-2.rq,
	rasqal/tests/sparql/Expr1/expr-3-result.ttl,
	rasqal/tests/sparql/Expr1/expr-3.rq,
	rasqal/tests/sparql/Expr1/manifest.n3,
	rasqal/tests/sparql/Expr2/Makefile.am,
	rasqal/tests/sparql/Makefile.am: Import Expr1 Expr2 ExprBuiltins
	ExprEquals regex from DAWG tests

2005-06-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_select_NULL_last_compare): Added
	helper for removing duplicate select variables.
	(rasqal_engine_assign_variables): Look for duplicate select
	variables, warn about them and remove them by sorting and then
	deleting NULL variables.

	* rasqal/tests/sparql/syntax/Makefile.am: Added select-dup.rq

	* rasqal/tests/sparql/syntax/select-dup.rq: Test for duplicates in
	select

2005-06-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/examples/Makefile.am:
	sparql-query-example-Testing-Values-isBlank now works

	* rasqal/tests/sparql/survey/Makefile.am: survey-2 now works.

	* rasqal/rasqal_query.c (rasqal_query_prepare): Call
	rasqal_engine_merge_basic_graph_patterns

	* rasqal/rasqal_engine.c
	(rasqal_engine_join_basic_graph_patterns): Move the triples and
	constraints from a source to a destination graph pattern.
	(rasqal_engine_make_basic_graph_pattern): Use
	rasqal_engine_join_basic_graph_patterns to merge: 1) a group of
	all basic graph patterns 2) an optional group of all basic graph
	patterns 3) a graph pattern with 1 sub-graph pattern Have to play
	some games with graph pattern operators.
	(rasqal_engine_merge_basic_graph_patterns): Use
	rasqal_engine_join_basic_graph_patterns to merge all basic graph
	patterns in a group into group of a single basic graph pattern of
	all the triples and constraints.

	* rasqal/rasqal_internal.h: Added prototypes for
	rasqal_engine_join_basic_graph_patterns and
	rasqal_engine_merge_basic_graph_patterns

	* rasqal/rasqal_query.c (rasqal_query_execute): For ordering
	results, directly use rasqal_engine_get_next_result to avoid doing
	limit and offset checks too early.  Start off from result_count 1.
	(rasqal_query_results_next): For ordered results, handle limit and
	offset with a loop and a check with
	rasqal_engine_check_limit_offset.  For streaming results, move
	check code to rasqal_engine_check_limit_offset and use it.
	(rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_value_by_name): For ordered
	results, use result_count-1 as an index.

	* rasqal/rasqal_engine.c (rasqal_engine_check_limit_offset): Added
	to check the current query result is in the range specified by
	limit and offset

	* rasqal/rasqal_internal.h: Added prototype for
	rasqal_engine_check_limit_offset

2005-06-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c: update for INN parsedate

	* raptor/configure.ac: Look for parsedate in libINN

2005-06-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/Makefile.am: Add parsedate.y to EXTRA_DIST

	* raptor/configure.ac: Better check for parsedate function

	* raptor/raptor_rss.c: Add the time includes for AC_HEADER_TIME

	* raptor/configure.ac: Add the standard AC_HEADER_TIME checks.

	* raptor/raptor_rss.c: Turn rss091:date into dc:date using a date
	parsing function PARSEDATE_FUNCTION to decode it and strftiem to
	make the new ISO format.

	* raptor/configure.ac: Get date parsing code from parsedate, curl
	curl_getdate or raptor parsedate if neither is available.

	* raptor/Makefile.am: Add parsedate.c if PARSEDATE defined Build
	parsedate.c from parsedate.y

	* raptor/parsedate.y: Fixes to build in raptor

	* raptor/parsedate.y: Imported from
	http://cvs.php.net/php-src/ext/standard/parsedate.y

2005-06-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/win32_rdf_config.h, configure.ac: Bumped version to 1.0.3

	* Snapshotted redland_1_0_2 for 1.0.2 release

	* raptor/raptor_rss.c: Added Suzan Foster to copyright

2005-06-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac: raptor min 1.4.4 (same as rasqal) rasqal min
	0.9.10

	* rasqal/: Snapshotted rasqal_0_9_10 for 0.9.10 release

	* rasqal/tests/sparql/ValueTesting/Makefile.am:
	extendedType-eq-pass passes

	* rasqal/rasqal_query.c (rasqal_new_query_result_row): Added
	offset to store original sort order in case it is needed to order
	two identical literals.
	(rasqal_query_result_row_print): Print offset.
	(rasqal_engine_query_results_compare): Renamed from
	rasqal_engine_query_results_sort.  Lots more debug messages and
	checks.  Order NULL literals before other types.
	(rasqal_query_execute): Pass result offset into
	rasqal_new_query_result_row.

	* rasqal/rasqal_literal.c (rasqal_literal_compare): Make
	comparison stable for URIs and datatyped strings - use strcmp on
	string values of URIs.

	* rasqal/tests/sparql/sort/Makefile.am: sort-3 works

	* rasqal/librasqal.3: Updates for 0.9.10

2005-06-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/win32_rasqal_config.h: Undefine OPTIONAL as something in
	win32 defines it.

	* rasqal/sparql_parser.y, rasqal/roqet.c, rasqal/rasqal_query.c,
	rasqal/rasqal_internal.h, rasqal/rasqal_graph_pattern.c,
	rasqal/rasqal_engine.c: Rename rasqal_graph_pattern_operator
	variables called 'operator' to 'op' for C++.  Other casts for C++

	* rasqal/rasqal_internal.h: Added RASQAL_DEPRECATED_WARNING to
	generate a rasqal warning once only.

	* rasqal/sparql_parser.y (OrderCondition): Use
	RASQAL_DEPRECATED_WARNING to explain ASC[] and DESC[] have been
	replaced.

	* rasqal/sparql_parser.y (OrderCondition): Use
	RASQAL_EXPR_ORDER_COND_ASC or DESC not NONE which is deleted.

	* rasqal/rasqal_query.c, rasqal/rasqal_expr.c, rasqal/rasqal.h:
	Deleted RASQAL_EXPR_ORDER_COND_NONE

	* rasqal/rasqal_query.c (rasqal_engine_query_results_sort): If
	result is 0 at the end, use the difference between the object
	pointers to create a stable sort when duplicates occur.

	* rasqal/Makefile.am: Do not build rasqal_xsd_datatypes_test
	unless RASQAL_DATATYPES makefile conditional is enabled.

	* rasqal/configure.ac: Add makefile conditional RASQAL_DATATYPES
	true when datatypes enabled.

	* rasqal/rasqal.pc.in: Add PKGCONFIG_REQUIRES, PKGCONFIG_LIBS and
	PKGCONFIG_CFLAGS

	* rasqal/configure.ac: Tidy specification of min versions Added
	pkgconfig specific additions: +PKGCONFIG_REQUIRES, PKGCONFIG_LIBS
	and PKGCONFIG_CFLAGS substituted into rasqal.pc.in Add PCRE
	cflags, libs to PKGCONFIG cflags/libs when used.  Add libxml-2.0
	to PKGCONFIG requires when used.

	* raptor/: Snapshotted raptor_1_4_7 for 1.4.7 release

	* raptor/libraptor.3: Note no changes in 1.4.6 and 1.4.7

	* rasqal/rasqal_query.c (rasqal_query_execute): When sorting, set
	finished flag if there are no results.
	(rasqal_query_results_next): When sorting, set finished flag if
	match or exceed number of results.
	(rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_value_by_name): When sorting, set
	finished flag if current row is beyond results.

2005-06-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_serialize_rdfxmla.c
	(raptor_new_qname_from_resource): Fail to split predicate if
	entire uri is an XML name - it's probably not an absolute URI.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Fail to split predicate if entire uri is an XML name - it's
	probably not an absolute URI.

	* raptor/raptor_namespace.c
	(raptor_namespaces_find_namespace_by_uri): Return NULL if ns_uri
	is NULL.

	* rasqal/tests/sparql/ValueTesting/extendedType-ne-fail.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-eq-pass-result.n3:
	Update to DAWG cvs

	* rasqal/tests/sparql/ValueTesting/extendedType-eq-pass-result.n3:
	delete results from extendedType-eq-pass-result.n3

	* rasqal/tests/sparql/ValueTesting/Makefile.am: 2 fail

	* rasqal/configure.ac: Added tests/sparql/ValueTesting

	* rasqal/tests/sparql/Makefile.am,
	rasqal/tests/sparql/ValueTesting/Makefile.am,
	rasqal/tests/sparql/ValueTesting/extendedType-0.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-eq-pass-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-eq-pass.rq,
	rasqal/tests/sparql/ValueTesting/extendedType-ne-fail-result.n3,
	rasqal/tests/sparql/ValueTesting/extendedType-ne-fail.rq,
	rasqal/tests/sparql/ValueTesting/manifest.n3: Added ValueTesting

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	Allow OPTIONAL to gather up inner basic graph patterns.  Print
	operator type when debugging.

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	More debug explanations of why merging/not merging.  Only work on
	a GROUP graph pattern.

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Init/free query->results_sequence.  Added internal
	rasqal_query_result_row
	(rasqal_new_query_result_row): Added to make a row out from a copy
	of all of the values of the current query result including the
	values of the ordering expressions for this row.
	(rasqal_free_query_result_row): Added to free a row.
	(rasqal_query_result_row_print): Added to print a row.
	(rasqal_engine_query_results_sort): Sequence helper function to do
	the query results ordering using rasqal_literal_compare.
	(rasqal_query_execute): If an ordering condition sequence is
	present, gather all the results, order them and store them in
	query->results_sequence.
	(rasqal_query_results_next, rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_value_by_name): Handle getting
	ordered result values from query->results_sequence.

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): Return the
	expression argumetn for ordering conditions.

	* rasqal/tests/sparql/sort/Makefile.am: Fail 4 now it does
	something

	* rasqal/tests/sparql/check-sparql: Handle sorted results by not
	sorting, and unsorted results by sorting.  Clear?

	* rasqal/rasqal_internal.h: rasqal_query structure gains internal
	results_sequence

	* rasqal/rasqal_literal.c (rasqal_literal_as_node): Handle unbound
	variable values.

	* rasqal/librasqal.3: rasqal_query_results_write: Note 2005-05-27
	WD and add format uris

	* rasqal/rasqal_query.c (rasqal_query_results_write): Note
	2005-05-27 WD and add format uris

	* rasqal/sparql_parser.y (PatternElementsList 2): Added debugging.

	* rasqal/sparql_parser.y (PatternElementsList): Doesn't need mygp

2005-06-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss_emit): Fix crash when no RSS
	channel is present (Suzan Foster)

2005-06-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c: wrods

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init): Update the
	hack modification to report it with a debug dump after, and set
	top graph pattern operator to GROUP

	* rasqal/sparql_parser.y (PatternElementsList): Set graph pattern
	operator to GROUP bydefault.

	* rasqal/configure.ac: Simplify libxml check Add message/report
	for datatypes support

	* rasqal/configure.ac: Check for libxml2, add xml2-config and
	xmlschema header files.  Added --enable-datatypes method to enable
	linking libxml for datatypes.

	* rasqal/rasqal_xsd_datatypes.c: Protect xml includes with
	HAVE_LIBXML_XMLSCHEMAS_H

2005-06-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am: Remove XML2_CONFIG

2005-06-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	Change resulting graph parent pattern operator to BASIC if it was
	GROUP

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: 0 failures now

	* rasqal/sparql_parser.y: Document the 12 shift/reduce conflicts
	now.
	(PropertyListOpt): Docs.
	(PropertyListTail): Use PropertyListOpt to allow ending on a ';'

	* rasqal/sparql_parser.y (AskClause): ASK is done

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Update lists

	* rasqal/tests/sparql/SyntaxFull/syntax-forms-03.arq: Remove
	unused tests

	* rasqal/tests/sparql/SyntaxFull/syntax-query-pat-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-05.rq: Delete old
	tests

	* rasqal/tests/sparql/SyntaxFull/syntax-bnodes-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-08.rq: Remove unused
	tests

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Added
	check-sparql-correct target

	* rasqal/tests/sparql/SyntaxFull/syntax-query-pat-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-04.rq: Added
	syntax-bnodes-08.rq syntax-bnodes-09.rq syntax-query-pat-01.rq
	syntax-query-pat-02.rq syntax-query-pat-03.rq
	syntax-query-pat-04.rq syntax-query-pat-05.rq tests

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: 3 to 1 failure

	* rasqal/rasqal_xsd_datatypes.c: Pull in libxml schema headers

	* rasqal/sparql_parser.y (OrderClauseOpt, LimitClauseOpt,
	OffsetClauseOpt): Check that ORDER BY is not used with ASK, LIMIT
	or OFFSET rather than put in grammar now.
	(OrderCondition): Allow FunctionCall, Var and '(' Expression ')'
	after rq23 latest.

	* rasqal/Makefile.am: Added XML2_CONFIG for datatypes testing

	* rasqal/rasqal_xsd_datatypes.c (main): run rasqal_init/finish.

	* rasqal/sparql_parser.y: Document 6 shift/reduce

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: from 4 to 3 failures

	* rasqal/sparql_lexer.l: Ensure <> does not get grabbed as LT GT

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: from 8 to 4 failures

	* rasqal/sparql_parser.y: Added PropertyListOpt as an outer triple
	in SPARQL can be just a subject [ :a :b ]
	(ObjectTail): Added to tidy up Object lists, remove duplicates.

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_print): No
	\n after (

	* rasqal/sparql_parser.y (GraphPattern): Do not set graph pattern
	operator here.
	(PropertyListTail): Added after last WD grammer to aid in allowing
	a trailing ;
	(PatternElementsList): Set default operator to basic.
	(PropertyList): Use PropertyListTail
	(PropertyList): Added
	(VarOrBnodeOrURI): Moved '[' ']' to BlankNode.
	(BlankNode): Allow '[' ']' in all cases.

	* librdf/rdf_stream.c (librdf_free_stream): Only call
	finished_method if it exists.  This likely caused crashes with
	empty iterators

2005-06-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: crashes stopped

	* rasqal/sparql_parser.y (VarOrBnodeOrURI): Added, used for
	Predicate and allows explicit bnode or []

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_init): Add
	init of current_graph_pattern field when there are sub-graph
	patterns.  Moved from rasqal_engine_execute_init.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init): Move init
	of current_graph_pattern field into rasqal_graph_pattern_init

	* rasqal/tests/sparql/examples/ex11.2.3.1_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.2_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.5_0-result.n3,
	rasqal/tests/sparql/examples/ex11_0-result.n3,
	rasqal/tests/sparql/examples/ex11_1-result.n3: Updated examples

	* rasqal/tests/sparql/sort/query-sort-6.rq,
	rasqal/tests/sparql/sort/query-sort-5.rq,
	rasqal/tests/sparql/sort/query-sort-4.rq,
	rasqal/tests/sparql/sort/query-sort-3.rq,
	rasqal/tests/sparql/sort/query-sort-2.rq: Use ASC() and DESC()

	* rasqal/tests/sparql/sort/manifest.ttl: rdfs:comment

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: 10 failures

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: note latest failures

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Added new tests

	* rasqal/tests/sparql/SyntaxFull/manifest.ttl: Added tests
	syntax-bnodes-0[567] syntax-limit-offset-0[789] and
	syntax-order[06]

	* rasqal/tests/sparql/SyntaxFull/syntax-limit-offset-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-limit-offset-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-limit-offset-09.rq: tests
	for limit and offset

	* rasqal/tests/sparql/SyntaxFull/syntax-bnodes-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-07.rq: More bnodes
	forms

	* rasqal/tests/sparql/SyntaxFull/syntax-order-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-06.rq: ASC/DESC using
	() not []s

	* rasqal/tests/sparql/examples/Makefile.am:
	sparql-query-example-Testing-Values-RDFterm-equal now passes

	* rasqal/sparql_parser.y (OrderCondition): Accept ASC() and DESC()
	deprecating ASC[] and DESC[]

	* rasqal/sparql_lexer.l: ASC and DESC are just the tokens, no [

	* raptor/Makefile.am: Added ChangeLog.[2-5]

	* raptor/ChangeLog: 2004 to ChangeLog.5

	* raptor/raptor_rss.c (raptor_rss_parser_processNode): Copy
	attribute value before storing in the item field.

2005-05-31  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c (roqet_graph_pattern_walk): Print graph pattern
	operator

	* rasqal/sparql_parser.y: Updates for graph pattern operators, not
	flags.
	(GraphPattern): Set group graph pattern operator.
	(PatternElementsList): Start off with an unknown grpah pattern
	operator, to catch missing cases.
	(PatternElement): Set basic graph pattern operator.
	(OptionalGraphPattern): Set optional graph pattern operator.
	(GraphGraphPattern): Set graph graph pattern operator.
	(UnionGraphPattern): Set union graph pattern operator.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare): Make a
	root basic graph pattern.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Print
	the graph pattern operator and update to check for optional step
	by operator.
	(rasqal_engine_make_basic_graph_pattern): Fold in a set of
	sub-graph patterns that are all basic graph patterns.

	* rasqal/rasqal_graph_pattern.c
	(rasqal_new_graph_pattern_from_sequence,
	rasqal_graph_pattern_add_triples): Final argument is now a graph
	pattern operator.
	(rasqal_graph_pattern_order): Sort optionals by operator.
	(rasqal_graph_pattern_init): Check for graph pattern operator.
	(rasqal_graph_pattern_get_operator,
	rasqal_graph_pattern_operator_as_string): Added.
	(rasqal_graph_pattern_print): Print the graph pattern operator.

	* rasqal/rasqal_query.c (rasqal_graph_pattern_get_flags):
	Deprecated, always returns 0.

	* rasqal/rasqal_internal.h:
	Added operator field to rasqal_graph_pattern.
	Change final argument of rasqal_new_graph_pattern_from_sequence and
	rasqal_graph_pattern_add_triples to operator.

	* rasqal/rasqal.h: Added rasqal_graph_pattern_operator
	Deprecated rasqal_graph_pattern_get_flags
	Added prototypes for rasqal_graph_pattern_get_operator and
	rasqal_graph_pattern_operator_as_string

	* rasqal/sparql_parser.y: Update grammar doc references to use
	SPARQL Query Language for RDF, 19 April 2005
	http://www.w3.org/TR/2005/WD-rdf-sparql-query-20050419/

2005-05-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac, librdf/win32_rdf_config.h: Bumped version to 1.0.2

	* Snapshotted redland_1_0_1 for 1.0.1 release

	* librdf/rdf_storage_mysql.c: remove errbuff

	* configure.ac: remove mysql -fno-common fix, breaks regular stuff

2005-05-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c: Define mysql common symbol errbuff
	if NEED_MYSQL_ERRBUFF defined.

	* configure.ac: If -fno-common is in the PIC compile args, define
	the mysql errbuff common symbol.

	* configure.ac: Only look for BDB in /sw (fink) if /sw/bin is in
	the path.

2005-05-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xslt.c: docs

2005-05-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: Removed deprecated flags -f and -o

	* rasqal/rasqal_expr.c (rasqal_triple_set_flags,
	rasqal_triple_get_flags): Removed deprecated functions.

	* rasqal/rasqal_engine.c (rasqal_new_triples_match): Removed
	rasqal_triples_source deprecated factory method new_triples_match.

	* rasqal/rasqal_query.c:
	(rasqal_new_query, rasqal_free_query,
	rasqal_query_add_data_graph): Removed rasqal_query deprecated list
	sources.
	(rasqal_query_add_source, rasqal_query_get_source_sequence,
	rasqal_query_get_source, rasqal_query_add_constraint,
	rasqal_query_get_constraint_sequence,
	rasqal_query_get_constraint): Removed deprecated functions.

	* rasqal/rasqal_internal.h: Removed rasqal_query deprecated list
	sources.

	* rasqal/rasqal.h: Removed deprecated functions:
	rasqal_query_add_source, rasqal_query_get_source_sequence,
	rasqal_query_get_source, rasqal_query_add_constraint,
	rasqal_query_get_constraint_sequence, rasqal_query_get_constraint,
	rasqal_triple_set_flags and rasqal_triple_get_flags.  Removed
	rasqal_triples_source deprecated factory method new_triples_match

	* rasqal/rasqal_engine.c (rasqal_set_triples_source_factory): Does
	not need RASQAL_API in the C

	* rasqal/rasqal_engine.c (rasqal_reset_triple_meta): Removed code
	that will never be called, freeing triples_match field for the
	second time

	* rasqal/rasqal_engine.c (rasqal_engine_expand_wildcards): Added,
	containing code from rasqal_engine_assign_variables to handle
	wildcard *.  Handle remaining query verbs.
	(rasqal_engine_assign_variables): Moved wildcard handling code
	above.
	(rasqal_engine_prepare): Call rasqal_engine_expand_wildcards.

2005-05-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am: Added COMPILE_LINK rule for making tests in
	one step.

	* configure.ac: syntax - delete ;s

	* librdf/rdf_digest_sha1.c (SHA1Transform): Take const buffer

	* librdf/rdf_digest_md5.c: duplicate const

	* librdf/rdf_hash.c: docs

	* Redland.i: Added digest and hash classes to API emphasising
	methods for creating hex-strings digests of strings and making
	hashes for model options.

	* librdf/rdf_uri.c (librdf_uri_get_digest): No need to call
	librdf_digest_init as the constructor does that.

	* librdf/rdf_digest.c: Docs.
	(librdf_new_digest_from_factory): Call init factory method here.
	(librdf_digest_init): Note this is a re-init.

	* librdf/rdf_digest.c (librdf_digest_update_string): Added.

	* librdf/rdf_digest.h: Added prototype for
	librdf_digest_update_string

	* librdf/rdf_digest_sha1.c, librdf/rdf_digest_openssl.c,
	librdf/rdf_digest_md5.c: Update the factory method to take a const
	buffer.

	* librdf/rdf_digest.c (librdf_digest_get_digest_length): Added.

	* librdf/rdf_digest.h: Factory method update takes const buffer.
	Reduced public API removing methods mentioning
	librdf_digest_factory.  Added prototype for
	librdf_digest_get_digest_length

	* librdf/rdf_hash.c (librdf_hash_get_as_boolean,
	librdf_hash_get_as_long librdf_hash_get_del): Take const key args

	* librdf/rdf_hash.h: Make librdf_hash_get_as_boolean,
	librdf_hash_get_as_long and librdf_hash_get_del take const key
	args

	* librdf/rdf_hash.c:
	(librdf_new_hash_from_string,
	librdf_new_hash_from_array_of_strings): return NULL if inner
	constructor fails.

	* librdf/rdf_hash.h: Make public API smaller; do not mention
	librdf_hash_factory or librdf_hash_datum.  Added prototypes for
	new public constructors librdf_new_hash_from_string and
	librdf_new_hash_from_array_of_strings

	* librdf/rdf_hash.c:
	(librdf_new_hash_from_string,
	librdf_new_hash_from_array_of_strings): Added constructors around
	internal functions for use by public API.
	(librdf_hash_from_array_of_strings): Take const array.
	(main): Update for const args.

	* librdf/win32/README.txt: Add win32 README.txt

2005-05-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Test for libxslt/xslt.h as well as library,
	and disable if missing.

2005-05-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/Makefile.am, librdf/rdf_internal.h, librdf/librdf.h:
	Add rdf_digest.h and rdf_hash.h to public includes.

	* librdf/rdf_digest.h, librdf/rdf_hash.h:
	Make API public, declare with REDLAND_API

	* librdf/rdf_digest.h, librdf/rdf_hash.h:
	Moved class init/finish methods into internal

	* librdf/rdf_query.c: (main) option of memory/disk test and comments

	* librdf/rdf_model.c: (main) comments

	* librdf/Makefile.am: clean any sqlite test file

	* librdf/rdf_storage_sqlite.c: The change below
	fixes Issue #0000006 - http://bugs.librdf.org/mantis/view.php?id=6

	* librdf/rdf_storage_sqlite.c (librdf_storage_sqlite_serialise):
	Do not free query stringbuffer before reporting error.
	(librdf_storage_sqlite_serialise_next_statement): Finish if
	failed.
	(librdf_storage_sqlite_find_statements): Restructure need_and code
	and fix AND string count.  Do not free query stringbuffer before
	reporting error.
	(librdf_storage_sqlite_find_statements_end_of_stream): Do not read
	an extra statement when testing for end, only if there is no
	current statement.
	(librdf_storage_sqlite_find_statements_next_statement): Finish if
	failed.
	(librdf_storage_sqlite_context_serialise): Do not free query
	stringbuffer before reporting error.
	(librdf_storage_sqlite_context_serialise_end_of_stream): Do not
	read an extra context when testing for end, only if there is no
	current context.
	(librdf_storage_sqlite_context_serialise_next_statement): Finish
	if failed.
	(librdf_storage_sqlite_get_contexts_is_end): Do not read an extra
	context when testing for end, only if there is no current context.
	(librdf_storage_sqlite_get_contexts_next_method): Finish if
	failed.
	(librdf_storage_sqlite_get_contexts): Do not free query
	stringbuffer before reporting error.

	* librdf/rdf_storage_sqlite.c
	(librdf_storage_sqlite_serialise_end_of_stream): Do not read an
	extra statement when testing for end, only if there is no current
	statement.

	* configure.ac: Edit mysql_config --cflags output to prevent it
	defining -O<n> Edit *CFLAGS and *CPPFLAGS to delete -O options
	just before writing files.

2005-05-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/win32_rasqal_config.h, rasqal/configure.ac:
	Bumped version to 0.9.10

	* Snapshotted rasqal_0_9_9 for 0.9.9 release

	* rasqal/rasqal_engine.c (rasqal_new_triples_match): Restore but
	deprecate rasqal_triples_source factory method new_triples_match
	for now.

	* rasqal/rasqal.h: Restore rasqal_triples_source factory method
	new_triples_match for now.

	* Makefile.am: added redland.sln

	* redland.sln: Import configuration from John Barstow

	* configure.ac: Added librdf/win32 subdir

	* librdf/Makefile.am: Added win32 subdir

	* librdf/win32/msvc.def, librdf/win32/Makefile.am,
	librdf/win32/librdf.vcproj, raptor/win32/Makefile.am,
	rasqal/win32/README.txt, rasqal/win32/Makefile.am,
	rasqal/win32/rasqal.vcproj, raptor/win32/rapper.vcproj,
	raptor/win32/raptor.sln, raptor/win32/raptor.vcproj,
	raptor/win32/raptortest.vcproj: Import configuration from John
	Barstow

	* raptor/win32/README.txt: updates

	* librdf/rdf_internal.h: Added REDLAND_INLINE

	* librdf/librdf.h: REDLAND_API before public statics

	* librdf/win32_rdf_config.h: Added REDLAND_INLINE Defines updated
	for win32 (John Barstow)

	* librdf/rdf_model.c (librdf_model_supports_contexts): Use
	REDLAND_INLINE

	* raptor/win32_raptor_config.h: Switch to libxml

	* rasqal/rasqal.h: RASQAL_API before public statics

	* rasqal/win32_rasqal_config.h: Added #define YY_NO_UNISTD_H

	* raptor/win32_raptor_config.h: Spelling: RAPTOR_INLINE

	* raptor/raptor_general.c (raptor_init): Added conditionals around
	serializers: RAPTOR_SERIALIZER_RDFXML/NTRIPLES/RDFXML_ABBREV

	* raptor/Makefile.am: Added conditionally included
	RAPTOR_SERIALIZER_RDFXML_ABBREV

	* raptor/configure.ac: Added --enable-serializers=LIST and
	serializers to summary.  Reformat other help messages to match.

2005-05-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/turtle_parser.y: (main) Move filename here

	* raptor/configure.ac: Add proper check for libxslt

	* rasqal/sparql_parser.y: Add print handler to all sequences, not
	conditional on debugging.

	* configure.ac, rasqal/configure.ac, raptor/configure.ac: default
	memory-signing no

	* configure.ac: usage formatting

	* configure.ac: Added --with-memory-sign default no.  DANGER: When
	enabled, memory returned to bindings which is freed, such as the
	node/uri/.._to_string() memory is off by 4 bytes from the pointer
	that free() expects.  Typically causes crashes.

	* librdf/rdf_log.h: Added LIBRDF_FROM_MEMORY

	* librdf/rdf_init.c (librdf_sign_malloc, librdf_sign_calloc,
	librdf_sign_realloc, librdf_sign_free): Added for signed memory
	checking.

	* librdf/rdf_internal.h: Added signed memory functions

	* librdf/rdf_storage_sqlite.c, librdf/rdf_storage_mysql.c,
	librdf/rdf_storage_list.c, librdf/rdf_storage_hashes.c,
	librdf/rdf_storage.c: Revert returning an empty iterator on
	failure to create an inner iterator, which is caused only by out
	of memory.

	* librdf/rdf_storage_list.c (librdf_storage_list_serialise):
	Return empty stream if list iterator ends.
	(librdf_storage_list_context_serialise): Return empty stream if
	contexts hash iterator ends.

	* librdf/rdf_storage_hashes.c
	(librdf_storage_hashes_serialise_common): Return empty stream if
	hash iterator ends.
	(librdf_storage_hashes_context_serialise): Return empty stream if
	contexts hash iterator ends.

	* librdf/rdf_model.c (librdf_model_find_statements_in_context):
	Return empty stream if context_as_stream returns nULL

	* librdf/rdf_stream.c (librdf_new_empty_stream): Added helper for
	empty stream.

	* librdf/rdf_stream.h: Added prototype for librdf_new_empty_stream

	* librdf/rdf_storage_sqlite.c
	(librdf_storage_sqlite_get_contexts): Return an empty iterator
	when the iterator fails to be constructed.

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_get_context):
	Return an empty iterator when the contexts returns NULL
	immediately or the iterator fails to be constructed.

	* librdf/rdf_storage_list.c (librdf_storage_list_get_contexts):
	Return an empty iterator when the hashes keys iterator returns
	NULL or the hashes iterator fails to be constructed.

	* librdf/rdf_storage_hashes.c
	(librdf_storage_hashes_node_iterator_create): Return an empty
	iterator when the hahes node iterator returns NULL.

	* librdf/rdf_storage.c
	(librdf_storage_node_stream_to_node_create): Return an empty
	iterator when find_statements returns NULL.

	* librdf/rdf_iterator.c (librdf_new_empty_iterator): Added helper
	to make an always-empty iterator.

	* librdf/rdf_iterator.h: Added prototype for
	librdf_new_empty_iterator

	* librdf/rdf_query_rasqal.c (redland_node_to_rasqal_literal): Use
	rasqal_alloc_memory to make things for inside rasqal.

	* rasqal/rasqal_general.c:
	(rasqal_free_memory, rasqal_alloc_memory, rasqal_calloc_memory):
	Added, for allocating and freeingmemory inside rasqal.

	* rasqal/rasqal.h: Added prototypes for rasqal_free_memory,
	rasqal_alloc_memory and rasqal_calloc_memory

	* rasqal/librasqal.3: Updates for 0.9.9

	* rasqal/rasqal_query.c: thethe

	* utils/rdfproc.c, configure.ac, rasqal/roqet.c,
	rasqal/configure.ac, raptor/rdfdump.c, raptor/configure.ac: Bugs
	to http://bugs.librdf.org/

	* rasqal/sparql_lexer.l (NCCHAR): Add _ which the comment says but
	wasn't actually done.
	(NCCHARV): Adjust comment to match regex

2005-05-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_identifier.c, raptor/raptor_parse.c,
	raptor/raptor_serialize_rdfxmla.c, raptor/raptor_serialize.c,
	raptor/raptor_sax2.c, raptor/raptor_rdfxml.c: Casts for
	RAPTOR_FREE

	* librdf/rdf_init.c (librdf_world_open): Init query after parser
	and explain why.

	* librdf/rdf_query_rasqal.c (rasqal_redland_init_triples_match):
	Renamed from rasqal_redland_new_triples_match.  Update for rasqal
	0.9.9.  Takes an existing rasqal_triples_match structure and
	returns non-0 on failure.

	* rasqal/rasqal_redland.c (rasqal_redland_init_triples_match):
	Renamed from rasqal_redland_new_triples_match.  Takes an existing
	rasqal_triples_match structure and returns non-0 on failure.

	* rasqal/rasqal_raptor.c (rasqal_raptor_init_triples_match):
	Renamed from rasqal_raptor_new_triples_match.  Takes an existing
	rasqal_triples_match structure and returns non-0 on failure.

	* rasqal/rasqal_engine.c (rasqal_new_triples_match): Call
	init_triples_match factory method with an already alloced
	rasqal_triples_match structure.  Free it here on error.

	* rasqal/rasqal.h: rasqal_triples_source factory method
	new_triples_match changed to init_triples_match, taking an
	initialised rtm field, returning a status.

	* rasqal/rasqal_general.c, rasqal/rasqal_literal.c,
	rasqal/rasqal.h, rasqal/rasqal_engine.c, rasqal/rasqal_expr.c:
	Casts for RASQAL_FREE.

	* raptor/configure.ac: usage message formatting

	* rasqal/rdql_lexer.l, rasqal/sparql_lexer.l: Use
	RASQAL_MALLOC/CALLOC/FREE

	* rasqal/configure.ac: Added --with-memory-signing rasqal signing
	memory debugging

	* raptor/raptor_general.c (raptor_free_statement): Casts for
	RAPTOR_FREE

	* rasqal/rasqal_general.c (rasqal_sign_malloc, rasqal_sign_calloc,
	rasqal_sign_realloc, rasqal_sign_free): Added rasqal signing
	memory debugging trigged by RASQAL_MEMORY_SIGN.

	* rasqal/rasqal_internal.h: Added rasqal signing memory debugging
	trigged by RASQAL_MEMORY_SIGN

	* rasqal/rasqal_query_test.c (main): Use RASQAL_MALLOC/FREE

	* raptor/configure.ac: Added --with-memory-signing raptor signing
	memory debugging Reformatted some other --with help messages.

	* raptor/raptor_general.c (raptor_sign_malloc, raptor_sign_calloc,
	raptor_sign_realloc, raptor_sign_free): Added raptor signing
	memory debugging trigged by RAPTOR_MEMORY_SIGN.

	* raptor/raptor_internal.h: Added raptor signing memory debugging
	trigged by RAPTOR_MEMORY_SIGN

	* raptor/n3_lexer.l: Use RAPTOR_MALLOC, RAPTOR_FREE

	* raptor/n3_parser.y, raptor/turtle_parser.y (directive,
	resource): Use RAPTOR_MALLOC, RAPTOR_FREE

	* raptor/turtle_lexer.l: Use RAPTOR_MALLOC, RAPTOR_FREE

	* raptor/rdfdiff.c:
	(rdfdiff_new_file, rdfdiff_new_blank) Use RAPTOR_MALLOC rather
	than strdup.

	* raptor/raptor_www_curl.c (raptor_www_curl_header_callback): Use
	RAPTOR_MALLOC on type field data.

	* raptor/rdfdump.c: Add raptor_finish() before usage exit

2005-05-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (TriplesList): Do not lose triples
	sequence after sequence join.

	* rasqal/rasqal_expr.c: docs

2005-05-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c, rasqal/rasqal_query.c, rasqal/roqet.c,
	rasqal/sparql_parser.y, rasqal/rasqal_expr.c: Casts for C++

	* rasqal/sparql_parser.y (DefaultGraphClause, NamedGraphClause):
	Free URI literal

	* rasqal/sparql_parser.y: ItemList is now a raptor_sequence of
	rasqal_formula.
	(ItemList): Update to do that, copy over any underlying triples
	(Collection): Walk the list of formula to create the RDF
	collection triples.

	* raptor/raptor_serialize_rdfxmla.c:
	(raptor_rdfxmla_serialize_init,
	raptor_rdfxmla_serialize_terminate): Init/free rdf_xml_literal_uri
	for the rdf:XMLLiteral URI.
	(raptor_rdfxmla_serialize_statement): Turn datatyped literals that
	are rdf:XMLLiteral into inline XML, not escaped.

2005-05-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_serialize.c:
	(raptor_rdfxml_serialize_init, raptor_rdfxml_serialize_terminate):
	Init/free rdf_xml_literal_uri for the rdf:XMLLiteral URI.
	(raptor_rdfxml_serialize_statement): Turn datatyped literals that
	are rdf:XMLLiteral into inline XML, not escaped.

	* rasqal/tests/sparql/survey/Makefile.am: survey-11 works

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables): adjust
	anon variables offsets to point to absolute index in full list of
	variables (rasqal_query field variables)

	* rasqal/sparql_parser.y (Triples): When predicate list is empty,
	return subject formula.

	* rasqal/sparql_parser.y (Triples): Protect when list is empty

	* rasqal/sparql_parser.y (Triples): Copy along any triples from
	subject formula.

	* rasqal/rasqal_engine.c, rasqal/rasqal_query.c
	(rasqal_query_prepare, rasqal_engine_execute_init): Move
	rasqal_engine_make_basic_graph_pattern call to
	rasqal_query_prepare after factory has prepared (parsed)

	* rasqal/roqet.c: Really make sparql the default

	* rasqal/roqet.c (roqet_graph_pattern_walk): space

	* rasqal/roqet.c (roqet_graph_pattern_walk): Add {}s around
	constraints

	* rasqal/roqet.c (roqet_query_walk): Print bound variables.

	* rasqal/roqet.1: Updates for 0.9.9 Do not mention deprecated
	-f/--format and -o/--output.  Merge -f and -o into in -r/--results
	and complete the list.  Added V1 and V2 of sparql query results
	xml format.  For -i, note sparql is default query language.

	* rasqal/rasqal_general.c (rasqal_init): sparql is now the default
	query language.

	* rasqal/roqet.c: Deprecated -f/--format and -o/--output both now
	in -r/--results.  Add V1 and V2 xml results formats.  Deleted
	invalid argument help for -r, see usage instead.

	* rasqal/roqet.c (roqet_write_indent): Added.
	(roqet_graph_pattern_walk): Add lots of {...}s around blocks.  use
	#number for gps, triples.  Change to use roqet_write_indent.
	(roqet_query_walk): Take indent arg, use it with
	roqet_write_indent.  Walk constructed triples.

	* rasqal/rasqal_query.c
	(rasqal_query_get_construct_triples_sequence,
	rasqal_query_get_construct_triple): Added, to get access to
	construct triples via API.
	(rasqal_query_verb_as_string): Added to get a string for a verb.
	(rasqal_query_print): Use the above.

	* rasqal/rasqal.h: Added prototypes for
	rasqal_query_get_construct_triples_sequence and
	rasqal_query_get_construct_triple

	* Redland.i: Added librdf_query_get_limit, librdf_query_set_limit,
	librdf_query_get_offset and librdf_query_set_offset

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_get_limit,
	librdf_query_rasqal_set_limit, librdf_query_rasqal_get_offset,
	librdf_query_rasqal_set_offset): Added to implement factory
	methods for get/setting of query results limit and offsets.
	(librdf_query_rasqal_register_factory): Register the above
	methods.

	* librdf/rdf_query.c (librdf_query_get_limit,
	librdf_query_set_limit, librdf_query_get_offset,
	librdf_query_set_offset): Added to provide access to new factory
	methods for get/setting of query results limit - max results to
	return and offset - initial results to skip.

	* librdf/rdf_query.h: Added factory methods: get_limit, set_limit,
	get_offset and set_offset.  Added prototypes for
	librdf_query_get_limit, librdf_query_set_limit,
	librdf_query_get_offset and librdf_query_set_offset

	* configure.ac: require rasqal 0.9.9

	* rasqal/roqet.c: Make -c/--count work properly.
	Print count to stdout.
	Tidy result format wording.

	* rasqal/rasqal_query.c (rasqal_query_results_get_count):
	Adjust the returned count by any offset.
	(rasqal_query_results_next): Implement limit and offset.
	Addresses Issue#0000005 - http://bugs.librdf.org/mantis/view.php?id=5

	* rasqal/rasqal_query.c (rasqal_query_results_next):
	Adjust result_count here.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Move
	result_count to rasqal_query_results_next.

2005-05-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Change quotes around bison test

	* raptor/configure.ac: Try to work for older bison version styles

2005-05-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c:
	Update from Suzan Foster to reflect the latest status of the
	enclosure vocabulary and allow multiple common items and fields.
	Fields in items are now a linked list of raptor_rss_field items.
	(raptor_rss_context_init): Empty common area.
	(raptor_enclosure_free): Use raptor_enclosure_free to empty enclosure
	list.
	(raptor_rss_field_free): Added to free a list of rss fields.
	(raptor_clear_rss_item): Use raptor_rss_field_free for freeing
	duplicate fields.
	(raptor_clear_rss_common_items): added to empty common item field
	lists.
	(raptor_rss_context_terminate): Empty common item fields with
	raptor_clear_rss_common_items.
	(raptor_rss_new_field): Added.
	(raptor_rss_enclosure_add): Added.
	(raptor_rss_field_add): Added to add a new field value to the list of
	values for one field item.
	(raptor_rss_common_add): Added to add a new common item to the list
	of common items for the current type.
	(raptor_rss_common_get): Added to get the last common item for the
	current type.
	(raptor_rss_parser_processNode): Updates for new fields structure.
	(raptor_rss_insert_enclosure_identifiers): Update for handling uris
	and bnodes.
	(raptor_rss_insert_identifiers): Update for lists for common items
	and lists of ields.
	(raptor_rss_emit_enclosure): Update for handling uris and bnodes.
	(raptor_rss_emit_item, raptor_rss_emit, raptor_rss10_move_statements,
	raptor_rss10_store_statement, raptor_rss10_serialize_statement,
	raptor_rss10_build_xml_names): Updates for lists of common items and
	lists of fields.
	(raptor_rss10_emit_item): Added fix for moving fields to the item
	when they got stuck on the enclosure when the enclosure uri = the guid.
	Updates for lists of common items and lists of fields.
	(raptor_rss10_serialize_end): Updates for lists of common items and
	lists of fields.

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_20041221):
	Check only variable bindings are asked for.
	(rasqal_query_results_write_xml_result2): Check only variable
	bindings or boolean are asked for.  Add boolean results format.

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_result2):
	Write <binding> with name attribute.

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_result2):
	Write out bnode strings right.

	* rasqal/roqet.c:
	Default to unpublished version2 of the XML results format.

	* rasqal/rasqal_query.c (rasqal_query_results_write_xml_20041221):
	Added, renamed from
	rasqal_query_results_write contents to emit the 2004-12-21 XML format
	(rasqal_query_results_write_xml_result2): Added, to emit the
	unpublished version2 of the XML format.
	(rasqal_query_results_write): Call above functions depending on the
	format_uri.

	* librdf/rdf_storage_mysql.c:
	Added MySQL connection handle pooling by Morten Frederiksen.
	Added librdf_storage_mysql_connection_status enum and
	staruct librdf_storage_mysql_connection to store used/opened
	connections.
	(librdf_storage_mysql_init_connections,
	librdf_storage_mysql_finish_connections): Added to init/finish
	connections
	(librdf_storage_mysql_get_handle): Added helper to get a connection
	handle either from the pool or make a new one.
	(librdf_storage_mysql_release_handle): Release a connection handle
	back to the pool.
	(librdf_storage_mysql_*): Use the connection pool to get handles
	using librdf_storage_mysql_get_handle.
	No longer return 0-mysql_errno(&context->connection) error codes,
	just -1 as the connection is strictly no longer available.

	Fixes Issue#0000027 - http://bugs.librdf.org/mantis/view.php?id=27

2005-05-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.1: Document query command
	Fixes Issue#0000024 - http://bugs.librdf.org/mantis/view.php?id=24

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_hash):
	Copy the first 8 bytes of digest into
	unsigned 64bit hash using a method portable across big/little
	endianness. 
	Fixes Issue#0000023 - http://bugs.librdf.org/mantis/view.php?id=23

	* rasqal/librasqal.3: Updated for 0.9.9

	* rasqal/rasqal_query.c: typo

2005-05-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal.h: Added prototype for rasqal_query_get_wildcard

	* rasqal/rasqal_query.c (rasqal_query_get_wildcard): Added

	* rasqal/rasqal.h:
	Added prototypes for rasqal_query_get_order_conditions_sequence
	rasqal_query_get_order_condition

	* rasqal/rasqal_query.c (rasqal_query_get_order_conditions_sequence,rasqal_query_get_order_condition):
	Added to return query order conditions.

2005-05-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_mysql.c (librdf_storage_mysql_hash): Copy the
	first 8 bytes of digest into unsigned 64bit hash using a method
	portable across big/little endianness. Fixes Issue#0000023 -
	http://bugs.librdf.org/mantis/view.php?id=23
	(Morten Frederiksen)

	* rasqal/librasqal.3: Updated for 0.9.9

	* rasqal/rasqal_query.c: typo

2005-05-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_query.c (rasqal_query_get_wildcard): Added

	* rasqal/rasqal.h: Added prototype for rasqal_query_get_wildcard

	* rasqal/rasqal.h: Added prototypes for
	rasqal_query_get_order_conditions_sequence
	rasqal_query_get_order_condition

	* rasqal/rasqal_query.c:
	(rasqal_query_get_order_conditions_sequence,
	rasqal_query_get_order_condition): Added to return query order
	conditions.

2005-05-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_lexer.l (VARNAME): Use NCCHARV to allow vars to
	start with _, [0-9] too.

	* raptor/win32_raptor_config.h: Added SIZEOF_UNSIGNED_SHORT

2005-05-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac: Added tests/sparql/sort dir

	* rasqal/tests/sparql/Makefile.am: Added sort dir

	* rasqal/tests/sparql/sort/result-sort-3.rdf,
	rasqal/tests/sparql/sort/result-sort-4.rdf,
	rasqal/tests/sparql/sort/result-sort-5.rdf,
	rasqal/tests/sparql/sort/result-sort-6.rdf,
	rasqal/tests/sparql/sort/result-sort-7.rdf,
	rasqal/tests/sparql/sort/result-sort-8.rdf,
	rasqal/tests/sparql/sort/Makefile.am,
	rasqal/tests/sparql/sort/data-sort-1.ttl,
	rasqal/tests/sparql/sort/data-sort-3.ttl,
	rasqal/tests/sparql/sort/data-sort-4.ttl,
	rasqal/tests/sparql/sort/data-sort-6.ttl,
	rasqal/tests/sparql/sort/data-sort-7.ttl,
	rasqal/tests/sparql/sort/data-sort-8.ttl,
	rasqal/tests/sparql/sort/manifest.ttl,
	rasqal/tests/sparql/sort/query-sort-1.rq,
	rasqal/tests/sparql/sort/query-sort-2.rq,
	rasqal/tests/sparql/sort/query-sort-3.rq,
	rasqal/tests/sparql/sort/query-sort-4.rq,
	rasqal/tests/sparql/sort/query-sort-5.rq,
	rasqal/tests/sparql/sort/query-sort-6.rq,
	rasqal/tests/sparql/sort/result-sort-1.rdf,
	rasqal/tests/sparql/sort/result-sort-2.rdf: added dawg sort tests

2005-05-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/survey/Makefile.am: More diagnosis of
	failures

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables): Add
	anonymous variables to the variables/variables_declared_in arrays.
	(rasqal_query_graph_pattern_build_declared_in_variable): Added
	helper.
	(rasqal_query_graph_pattern_build_declared_in): Use above
	(rasqal_engine_do_optional_step): Check any outermost constraint
	expression if there is a match.
	(rasqal_engine_make_basic_graph_pattern): Use
	rasqal_graph_pattern_add_constraint when moving constraints.
	Rebuild constraints expression after moving constraints.

	* rasqal/tests/sparql/survey/Makefile.am: 5 failures now

	* rasqal/roqet.c (roqet_query_walk): Start from top graph pattern,
	not contents of it.

	* rasqal/rasqal_query.c (rasqal_query_get_query_graph_pattern):
	Added to get the top graph pattern.

	* rasqal/rasqal.h: Added prototype for
	rasqal_query_get_query_graph_pattern

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables): Use the
	wildcard flag for SELECT * and CONSTRUCT *

	* rasqal/rasqal_query.c: Added rasqal_query_verb_labels for debug
	printing.
	(rasqal_query_print): Print out the query verb.
	(rasqal_query_results_is_bindings,
	rasqal_query_results_is_boolean, rasqal_query_results_is_graph):
	Use the query verb to decide this.
	(rasqal_query_get_verb): Added.

	* rasqal/sparql_parser.y (Report): Set the query verb to SELECT,
	CONSTRUCT, DESCRIBE or ASK.  Do not use select_is_describe or ask.
	(SelectClause): Set wildcard flag with SELECT (DISTINCT) *
	(ConstructClause): Set the wildcard flag with CONSTRUCT *

	* rasqal/rdql_parser.y (Query): Set query verb to SELECT.
	(SelectClause): Set wildcard flag with SELECT *

	* rasqal/rasqal_internal.h: rasqal_query gains a verb and wildcard
	fields replacing select_all, select_is_describe, construct_all and
	ask

	* rasqal/rasqal.h: Added rasqal_query_verb enum.  Added prototype
	for rasqal_query_get_verb

	* rasqal/sparql_parser.y (OptionalGraphPattern): Do not set
	optional flags on triples.

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_init):
	Record triple_meta is_exact field.

	* rasqal/rasqal_expr.c: Removed rasqal_triple_flag_strings
	(rasqal_triple_print): Removed printing flags.
	(rasqal_triple_set_flags, rasqal_triple_get_flags): Note
	deprecated.

	* rasqal/rasqal_engine.c (rasqal_graph_pattern_get_next_match):
	Use triple_meta file is_exact instead of rasqal_triple flag field
	(rasqal_engine_prepare): No longer init triple flags.

	* rasqal/rasqal.h: Deprecated rasqal_triple flags field. - the
	value EXACT was only used in the execution engine and properly
	lives in rasqal_triple_meta. The value OPTIONAL was never used.
	Added is_exact file to rasqal_triple_meta.  Deprecated
	rasqal_triple_set_flags and rasqal_triple_get_flags.

	* rasqal/rasqal_engine.c (rasqal_engine_execute_init): Transform
	the query graph pattern for execution purposes - make basic graph
	patterns and make sure the top is always a sequence of graph
	patterns, for now.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Remove the building of basic graph patterns from here. Just build
	the simplest graph pattern and let the execution engine change it
	if it needs to.

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare): Just
	build the simplest graph pattern here, let the executionengine
	change it if it needs to.

2005-05-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Updated for tests
	updates, removals for required top level graph pattern.

	* rasqal/tests/sparql/SyntaxFull/syntax-bnodes-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-09.rq: Removed
	renamed syntax-bnodes tests

	* rasqal/tests/sparql/SyntaxFull/syntax-query-pat-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-05.rq: Removed
	WHERE no {} tests

2005-04-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/examples/Makefile.am:
	sparql-query-example-Testing-Values-str works with right data

	* rasqal/tests/sparql/examples/Makefile.am:
	sparql-query-example-Testing-Values-str fails

	* rasqal/sparql_parser.y (CallExpression): use nflags for pattern
	expression flags

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: fix dup terms

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Added empty.nt

	* rasqal/tests/sparql/SyntaxFull/empty.nt: empty.nt

	* rasqal/tests/sparql/SyntaxFull/syntax-bnodes-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-04.rq,
	rasqal/tests/sparql/SyntaxFull/manifest.ttl,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-02.rq,
	rasqal/tests/sparql/SyntaxFull/Makefile.am: Added
	syntax-bnodes-01,02,03 and 04

	* rasqal/tests/sparql/check-sparql: Handle no result in manifest

	* rasqal/rasqal_engine.c
	(rasqal_engine_convert_blank_node_to_anonymous_variable): Helper
	added.
	(rasqal_engine_build_anonymous_variables): Added to turn bnodes
	inside graph pattern triples into variables.  ISSUE: should not do
	this with construct triples

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	init/free anon_variables_sequence
	(rasqal_query_print): Print anonymous variables

	* rasqal/rasqal_expr.c (rasqal_new_variable_typed): Added with
	type parameter.
	(rasqal_new_variable): Changed to use it.
	(rasqal_variable_print): Print variable type.

	* rasqal/rasqal_internal.h: Added anon_variables_sequence and
	anon_variables_count

	* rasqal/rasqal.h: typoo

	* rasqal/rasqal.h: Added rasqal_variable_type enum.
	rasqal_variable gained field 'type' Added prototypes for
	rasqal_query_set_distinct, rasqal_query_set_limit,
	rasqal_query_set_offset and rasqal_new_variable_typed

	* rasqal/rasqal_query.c (rasqal_query_set_distinct,
	rasqal_query_set_limit, rasqal_query_set_offset): Added.

	* rasqal/sparql_lexer.l, rasqal/sparql_parser.y: Removed unused
	tokens PATTERN_LITERAL and '&'.

	* rasqal/tests/sparql/survey/Makefile.am: fix failure count

	* rasqal/tests/sparql/syntax/cast1.rq: no == operator

	* rasqal/tests/sparql/bound/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/survey/Makefile.am: Remove check-sparql-works
	targets - check-sparql-correct does it better and using manifest

	* rasqal/tests/sparql/examples/ex11.2.3.5_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.5_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.6_0-result.n3: Fix what I
	think are test query/data bugs

	* rasqal/tests/sparql/examples/Makefile.am: Added ex11_1.rq
	ex11_1-result.n3 Note which query files have the failing query.

	* rasqal/tests/sparql/examples/ex11_1-result.n3,
	rasqal/tests/sparql/examples/ex11_1.rq: example ex11_1

	* rasqal/tests/sparql/examples/ex11.2.3.6_0-result.n3,
	rasqal/tests/sparql/examples/ex11_0-result.n3,
	rasqal/tests/sparql/examples/manifest.n3: Sync tests to dawg

2005-04-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql (toDebug): Handle no value.

	* rasqal/tests/sparql/survey/Makefile.am: Added expected failures

	* rasqal/sparql_lexer.l: Remove == token

	* rasqal/sparql_lexer.l: Align name tokens with rq23 post WD
	2005-04-19 CVS 1.326

	* rasqal/tests/sparql/bound/bound1.rq: new turtley syntax

	* rasqal/tests/sparql/examples/Makefile.am: Annotate failures.

	* rasqal/sparql_parser.y: less super-debuggy

	* rasqal/sparql_parser.y:
	(CallExpression) Copy the string from rasqal_literal_as_string
	when making pattern literals or flags. Free the unused literal
	args.

	* rasqal/rasqal_expr.c:
	(rasqal_expression_evaluate) For the RASQAL_EXPR_STR operation,
	copy the string from rasqal_literal_as_string.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Restore hack to build an outer list of GPs if the folding made it
	all into one.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Just call rasqal_engine_make_basic_graph_pattern on the query
	graph pattern.

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	More debug messages.  Always merge a GP with a GP of size 1
	inside.  Ignore any inner OPTIONAL GPs Merge sequences of triples
	if seen.

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: syntax-struct-01.rq
	no longer crashes

	* rasqal/sparql_parser.y (OptionalGraphPattern): Don't die if no
	GraphPattern.

	* rasqal/sparql_parser.y: Debug messages

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_print):
	Print graph pattern/triple sequence sizes.

	* rasqal/rasqal_query.c (rasqal_new_query): Set initial offset to
	unset (<0)

	* rasqal/rasqal_engine.c (rasqal_query_build_declared_in): warning
	wording

	* rasqal/rasqal_engine.c (rasqal_query_build_declared_in): No \n
	in warning.

	* rasqal/sparql_parser.y (UnionGraphPatternList): Added.
	(UnionGraphPattern): Make a graph pattern with the contained union
	graphs.  Renamed from OptionalGraphPatternList.

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Fixed
	syntax-union-02.rq

	* rasqal/sparql_parser.y (OptionalGraphPatternList): Require UNION
	between GPs

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Typo

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): Warn and then
	return false for function expressions - not implemented.

	* rasqal/sparql_parser.y: Removed string operators STR_EQ STR_NE
	STR_MATCH STR_NMATCH
	(OptionalGraphPatternList): List cannnot be empty Lots of renaming
	of grammar terms to match rq23 / WD 19 April 2005
	(RelationalExpression): Renamed from ValueLogical and merged with
	former RelationalExpression.
	(CallExpression): Renamed from BuiltinExpression and reordered to
	match rq23

	* rasqal/sparql_lexer.l: Removed regex pattern literals, PATTERN
	state, sparql_copy_regex_token, EQ/eq, NE/NE, =~, ~~, !~

	* rasqal/sparql_parser.y (OptionalGraphPatternList): Added, to
	allow GraphPattern UNION GraphPattern*

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	Verbose debugging if RASQAL_DEBUG > 1

2005-04-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/SyntaxFull/Makefile.am: Note failures so far

	* rasqal/sparql_parser.y (BuiltinExpression): Move URIBrace work
	into FunctionCall
	(FunctionCall): Pick cast or function, I choose function

	* rasqal/sparql_lexer.l: Widen QUOTEDURI and include <>

	* rasqal/sparql_parser.y (WhereClauseOpt): Warn WHERE omitted.
	(BuiltinExpression): Call FunctionCall
	(PrimaryExpression): Add '(' Expression ')'
	(FunctionCall): Add URI name.
	(ArgList): Now a list of expressions

	* rasqal/sparql_parser.y (OrderClauseOpt): Use OrderConditionList
	and store it in query field order_conditions_seequence.
	(OrderConditionList): Added, making a raptor_sequence of
	expressions
	(OrderCondition): Implemented ASC/DESC/none
	(OrderExpression): Added, using FunctionCall or Var
	(ItemList): Init $$->triples and set formula.
	(PrimaryExpression): Use FunctionCall
	(FunctionCall): Restored, now it's used twice.

	* rasqal/rasqal.h: Added RASQAL_EXPR_ORDER_COND_ASC,
	RASQAL_EXPR_ORDER_COND_DESC and RASQAL_EXPR_ORDER_COND_NONE

	* rasqal/rasqal_internal.h: Added order_conditions_sequence to
	query

	* rasqal/rasqal_query.c (rasqal_query_print): Print order
	conditions.

	* rasqal/rasqal_query.c (rasqal_new_query,rasqal_free_query): Init
	and free order_conditions_sequence

	* rasqal/rasqal_expr.c (rasqal_free_expression,
	rasqal_expression_foreach, rasqal_expression_evaluate,
	rasqal_expression_print): Added cases for
	RASQAL_EXPR_ORDER_COND_ASC, RASQAL_EXPR_ORDER_COND_DESC and
	RASQAL_EXPR_ORDER_COND_NONE

	* rasqal/sparql_lexer.l: ASC, DESC take following [ too
	(sparql_token_print): Added ASC, DESC

	* rasqal/sparql_parser.y, rasqal/sparql_lexer.l: Added ASC, DESC

	* rasqal/sparql_lexer.l (PREFIX, NAME): Allow . after first char

	* rasqal/sparql_lexer.l: Added '''strings''' (not in Turtle)

	* rasqal/sparql_lexer.l: Added """string""" literals

	* rasqal/tests/sparql/SyntaxFull/syntax-union-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-union-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-10.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-struct-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-14.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-query-pat-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-12.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-13.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-11.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-10.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-qname-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-pat-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-pat-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-pat-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-pat-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-order-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-14.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-13.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-12.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-11.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-10.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lists-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lists-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lists-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lit-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lists-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-lists-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-forms-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-forms-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-forms-03.arq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-04.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-expr-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-07.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-08.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-09.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-05.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-bnodes-06.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-01.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-02.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-03.rq,
	rasqal/tests/sparql/SyntaxFull/syntax-basic-04.rq,
	rasqal/tests/sparql/Makefile.am,
	rasqal/tests/sparql/SyntaxFull/Makefile.am,
	rasqal/tests/sparql/SyntaxFull/manifest.ttl, rasqal/configure.ac:
	Added SyntaxFull tests from dawg

2005-04-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/survey/Makefile.am: data is
	survey-sample.ttl

2005-04-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): Handle
	unbound variable values in RASQAL_EXPR_DATATYPE,
	RASQAL_EXPR_ISURI, RASQAL_EXPR_ISBLANK, RASQAL_EXPR_ISLITERAL

	* rasqal/sparql_lexer.l: Make keyword tokens case independent not
	just upper or lowercase.

	* rasqal/tests/sparql/examples/Makefile.am: Update for new example
	files

	* rasqal/sparql_parser.y: No conflicts

	* rasqal/tests/sparql/examples/ex11.2.3.1_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.1_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.1_1.n3,
	rasqal/tests/sparql/examples/ex11.2.3.1_1.rq,
	rasqal/tests/sparql/examples/ex11.2.3.2_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.2_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.2_1.rq,
	rasqal/tests/sparql/examples/ex11.2.3.3_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.3_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.4_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.4_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.5_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.5_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.6_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.6_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.7_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.7_0.rq,
	rasqal/tests/sparql/examples/ex11.2.3.8_0.n3,
	rasqal/tests/sparql/examples/ex11.2.3.8_0.rq,
	rasqal/tests/sparql/examples/ex11_0.n3,
	rasqal/tests/sparql/examples/ex11_0.rq,
	rasqal/tests/sparql/examples/ex3.rq,
	rasqal/tests/sparql/examples/ex11.2.3.1_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.1_1-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.2_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.2_1-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.3_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.4_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.5_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.6_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.7_0-result.n3,
	rasqal/tests/sparql/examples/ex11.2.3.8_0-result.n3,
	rasqal/tests/sparql/examples/ex11_0-result.n3,
	rasqal/tests/sparql/examples/manifest.n3: Imported updated
	examples

	* rasqal/tests/sparql/check-sparql: remove debug print

	* rasqal/sparql_parser.y: Make construct work again.  Now %type
	<seq>: TriplesList ConstructTemplate
	(ConstructClause): Take triples from seq ConstructTemplate
	(ConstructTemplate): Use TriplesList
	(TriplesList): Added, making a raptor_sequence of triples from
	triples in Triples formulas.

	* rasqal/rasqal_graph_pattern.c (rasqal_new_graph_pattern): Init
	columns to defaults here.

	* rasqal/rasqal_engine.c (rasqal_engine_make_basic_graph_pattern):
	Added.

	* rasqal/rasqal_internal.h: Added
	rasqal_engine_make_basic_graph_pattern prototype.

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Call rasqal_engine_make_basic_graph_pattern on the top level
	subgraph patterns.

	* rasqal/tests/sparql/syntax/Makefile.am: Print failure summaries

	* rasqal/tests/sparql/syntax/offset0.rq,
	rasqal/tests/sparql/syntax/cast0.rq,
	rasqal/tests/sparql/syntax/cast1.rq: updates for turtle sparql
	syntax

	* rasqal/tests/sparql/check-sparql: Read manfiest.ttl or
	manifest.n3

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql: Emit failing roqet line when
	roqet returns errors.

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql: Emit failing roqet line on
	FAILURE

2005-04-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_list.c (librdf_storage_list_node_equals): Not
	equal if only one context is NULL.

2005-04-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y: Updates to SPARQL rq23 around $Revision:
	1.303 $ of $Date: 2005/04/16 17:13:51 $ Removed AND, WITH.  Added
	NAMED.  Removed many %type that were used with NULL value or none.
	(DatasetClauseOpt, DefaultGraphClause): Added after rq23
	(NamedGraphClauseList): Added
	(PatternElementsList): Renamed from PatternElementList and now in
	rq23, returns a graph pattern.  FILTER handled here, not in older
	PatternElementConstraint.
	(PatternElementConstraint): Deleted.
	(ItemList): Moved adjacent to Collection which it serves.
	(URIList): Deleted, no longer used.

	* rasqal/rasqal_engine.c
	(rasqal_engine_build_constraints_expression): Handle no graph
	pattern.
	(rasqal_engine_execute_init): Handle no graph pattern.

	* rasqal/tests/sparql/syntax/describe1.rq,
	rasqal/tests/sparql/syntax/groups.rq,
	rasqal/tests/sparql/syntax/construct1.rq,
	rasqal/tests/sparql/syntax/limit0.rq,
	rasqal/tests/sparql/syntax/construct0.rq,
	rasqal/tests/sparql/syntax/construct2.rq,
	rasqal/tests/sparql/syntax/distinct0.rq,
	rasqal/tests/sparql/syntax/ask0.rq: Update to turtle query syntax

	* rasqal/rasqal_graph_pattern.c
	(rasqal_new_graph_pattern_from_sequence): Do not flatten gps.

	* rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/part1/dawg-query-001,
	rasqal/tests/sparql/part1/dawg-query-001.rq,
	rasqal/tests/sparql/part1/dawg-query-002,
	rasqal/tests/sparql/part1/dawg-query-002.rq,
	rasqal/tests/sparql/part1/dawg-query-003,
	rasqal/tests/sparql/part1/dawg-query-003.rq,
	rasqal/tests/sparql/part1/dawg-query-004,
	rasqal/tests/sparql/part1/dawg-query-004.rq,
	rasqal/tests/sparql/part1/manifest.n3: Updated to turtle query
	syntax and renamed dawg-query-001.rq dawg-query-002.rq
	dawg-query-003.rq dawg-query-004.rq

	* rasqal/tests/sparql/examples/ex2-1a.rq,
	rasqal/tests/sparql/examples/ex2-1b.rq,
	rasqal/tests/sparql/examples/ex2-1c.rq,
	rasqal/tests/sparql/examples/ex2-1e.rq,
	rasqal/tests/sparql/examples/ex2-2a.rq,
	rasqal/tests/sparql/examples/ex2-3a.rq,
	rasqal/tests/sparql/examples/ex2-4a.rq,
	rasqal/tests/sparql/examples/manifest.n3: update to turtle syntax
	queries, latest naming

	* rasqal/tests/sparql/simple/data-03.n3,
	rasqal/tests/sparql/simple/dawg-tp-05.rq: import from dawg

	* rasqal/tests/sparql/simple/dawg-tp-01.rq,
	rasqal/tests/sparql/simple/dawg-tp-02.rq,
	rasqal/tests/sparql/simple/dawg-tp-03.rq,
	rasqal/tests/sparql/simple/dawg-tp-04.rq,
	rasqal/tests/sparql/simple/manifest.n3: update to turtle syntax
	queries

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare): Init
	query graph pattern.

	* rasqal/rasqal_query.c (rasqal_new_query): Start with a NULL
	query graph pattern.

	* rasqal/sparql_lexer.l: -AND

	* rasqal/sparql_lexer.l: -WITH, +NAMED

	* rasqal/tests/sparql/survey/manifest.ttl: Added manifest.ttl

	* rasqal/tests/sparql/survey/query-survey-1.rq,
	rasqal/tests/sparql/survey/query-survey-10.rq,
	rasqal/tests/sparql/survey/query-survey-11.rq,
	rasqal/tests/sparql/survey/query-survey-12.rq,
	rasqal/tests/sparql/survey/query-survey-13.rq,
	rasqal/tests/sparql/survey/query-survey-2.rq,
	rasqal/tests/sparql/survey/query-survey-3.rq,
	rasqal/tests/sparql/survey/query-survey-8.rq,
	rasqal/tests/sparql/survey/query-survey-9.rq,
	rasqal/tests/sparql/survey/result-survey-10.ttl,
	rasqal/tests/sparql/survey/result-survey-3.ttl,
	rasqal/tests/sparql/survey/survey-sample.ttl: Update to latest
	DAWG versions of test

	* rasqal/tests/sparql/survey/Makefile.am: manifest file is
	manifest.ttl

	* ChangeLog, ChangeLog.5, Makefile.am: Added ChangeLog.5 for 2004

	* librdf/rdf_query.c: Mark class librdf_init/finish_FOO as INTERNAL.
	Tidy head doc

	* librdf/rdf_log.c:
	Export several useful internal documented functions marked INTERNAL.

	* librdf/rdf_serializer.c, librdf/rdf_storage.c, librdf/rdf_uri.c,
	librdf/rdf_init.c, librdf/rdf_model.c, librdf/rdf_parser.c,
	librdf/rdf_digest.c, librdf/rdf_hash.c, librdf/rdf_concepts.c:
	Mark class librdf_init/finish_FOO as INTERNAL.  Tidy head doc,
	2005.

	* autogen.sh, raptor/autogen.sh, rasqal/autogen.sh: allow
	envariables to override the programs

2005-04-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_iostream.c: (raptor_string_iostream_finish): Fixes
	bug 0000021: the output of to_string for an empty model should
	always be parsable and result in an empty model
	http://bugs.librdf.org/mantis/view.php?id=21

	* Redland.i: Typo: fraptor_locator_line -> raptor_locator_line

	* raptor/raptor_iostream.c (raptor_string_iostream_finish): Return
	an empty string "" (aka 1 byte, \0) when the stringbuffer is NULL,
	do not return the NULL.

2005-04-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y: First set of sparql turtle syntax
	changes Added %token: ORDER, BY, REGEX Added %type:
	OrderClauseOpt, PatternElementList, DotOptional,
	ConstructTemplate, Triples, PropertyList, ObjectList, ItemList
	Collection, Subject, Predicate Object, TriplesNode, GraphPattern,
	GraphGraphPattern, UnionGraphPattern (based on rq23) Removed
	%type: VarOrURIOrBNode as turtle syntax rules cover it Many terms
	renamed to match rq23 terms, updated to use formula.  Other
	changes:
	(Query): Added OrderClauseOpt
	(BaseDeclOpt, PrefixDeclOpt): moved in source, no change.
	(WhereClauseOpt): Just assign GraphPattern value
	(OrderClauseOpt): Skeletal and incomplete.
	(GraphPattern): Take a list of .-separated triples, with optional
	.  or an empty {}
	(DotOptional): Added
	(Triples, PropertyList, ObjectList, ItemList, Subject, Predicate,
	Object, Collection): imported for turtle and updated to pass
	around rasqal_formula and use them to store triples + literal
	value.
	(TriplesNode): Imported from rq23 partially.
	(BuiltinExpression): Added REGEX

	* rasqal/sparql_lexer.l: Added tokens: ORDER, By, REGEX, ., ; for
	rq23 sparql Noted FIXME to remove old comparison ops EQ/eq, NE/ne,
	==, !=

	* rasqal/rasqal.h: Added rasqal_generate_bnodeid_handler typedef.
	Added prototypes for
	rasqal_query_set_default_generate_bnodeid_parameters and
	rasqal_query_set_generate_bnodeid_handler

	* rasqal/rasqal_graph_pattern.c: docs

	* rasqal/rasqal_internal.h: Added bnodeid handler params to query.
	Added prototype for rasqal_query_set_generate_bnodeid_handler.
	Added extern references for rasqal_rdf_namespace_uri,
	rasqal_rdf_first_uri, rasqal_rdf_rest_uri and rasqal_rdf_nil_uri

	* rasqal/rasqal_general.c: Add rdf uris for namespace, rdf:first,
	rdf:rest, rdf:nul
	(rasqal_uri_init, rasqal_uri_finish): Init and tidy up above.
	(rasqal_query_set_default_generate_bnodeid_parameters,
	rasqal_query_set_generate_bnodeid_handler,
	rasqal_default_generate_bnodeid_handler,
	rasqal_query_generate_bnodeid): Added, import from raptor.

	* raptor/raptor_parse.c: docs typo

	* rasqal/rasqal_literal.c: Added rasqal_formula for sparql parser.
	(rasqal_new_formula): Added constructor
	(rasqal_free_formula): Added destructor
	(rasqal_formula_print): Added print method, for sequences of
	formulas

	* rasqal/rasqal_internal.h: Added rasqal_formula for sparql
	parser.  Added prototypes for rasqal_new_formula,
	rasqal_free_formula and rasqal_formula_print

	* rasqal/tests/sparql/syntax/cast0.rq,
	rasqal/tests/sparql/syntax/cast1.rq: AND to FILTER

	* rasqal/tests/sparql/syntax/Makefile.am: Added offset0.rq

	* rasqal/sparql_parser.y: Added tokens FILTER OFFSET A Now up to
	expecting 3 shift/reduce (filter + offset can both be missing)
	Added LimitClauseOpt OffsetClauseOpt types
	(Query): Added OffsetClause
	(OffsetClauseOpt): Added, not in 2005-02-17 SPARQL WD
	(PatternElementConstraint): Deprecate AND (removed 2005-04-19
	SPARQL WD) and add FILTER.

	* rasqal/roqet.c (roqet_query_walk): Print any result offset
	(main): Fix help message

	* rasqal/tests/sparql/syntax/offset0.rq: LIMIT and OFFSET test

	* rasqal/rasqal_engine.c
	(rasqal_engine_query_constraints_has_qname): Handle no
	query_graph_pattern present.

	* rasqal/sparql_lexer.l: Added FILTER, OFFSET, A tokens

	* rasqal/rasqal_query.c (rasqal_query_get_offset): Added,
	returning the query results offset.
	(rasqal_query_print): Print query results offset

	* rasqal/rasqal.h: Added rasqal_query_get_offset prototype.

	* rasqal/rasqal_internal.h: Added offset to query structure

2005-04-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_lexer.l: Deleted keyword LOAD

	* rasqal/sparql_parser.y (LoadClauseOpt): Deleted, along with old
	keyword LOAD

	* rasqal/sparql_parser.y: Removed deprecated [ ... ] syntax for
	optionals

	* rasqal/sparql_lexer.l, rasqal/sparql_parser.y: Removed
	deprecated SOURCE keyword

	* rasqal/configure.ac: Added tests/sparql/survey/Makefile

	* rasqal/tests/sparql/Makefile.am: Added survey dir

	* rasqal/tests/sparql/survey/Makefile.am,
	rasqal/tests/sparql/survey/query-survey-1.rq,
	rasqal/tests/sparql/survey/query-survey-10.rq,
	rasqal/tests/sparql/survey/query-survey-11.rq,
	rasqal/tests/sparql/survey/query-survey-12.rq,
	rasqal/tests/sparql/survey/query-survey-13.rq,
	rasqal/tests/sparql/survey/query-survey-2.rq,
	rasqal/tests/sparql/survey/query-survey-3.rq,
	rasqal/tests/sparql/survey/query-survey-8.rq,
	rasqal/tests/sparql/survey/query-survey-9.rq,
	rasqal/tests/sparql/survey/result-survey-1.ttl,
	rasqal/tests/sparql/survey/result-survey-10.ttl,
	rasqal/tests/sparql/survey/result-survey-11.ttl,
	rasqal/tests/sparql/survey/result-survey-12.ttl,
	rasqal/tests/sparql/survey/result-survey-13.ttl,
	rasqal/tests/sparql/survey/result-survey-2.ttl,
	rasqal/tests/sparql/survey/result-survey-3.ttl,
	rasqal/tests/sparql/survey/result-survey-8.ttl,
	rasqal/tests/sparql/survey/result-survey-9.ttl,
	rasqal/tests/sparql/survey/survey-sample.ttl: dawg suvey tests

	* raptor/tests/Makefile.am, raptor/tests/ex-56.out,
	raptor/tests/ex-56.rdf: Added ex-56 test that relative URIs in
	datatypes work (Graham Klyne)

2005-04-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/configure.ac, rasqal/win32_rasqal_config.h: Bumped
	version to 0.9.9

	* rasqal: Snapshotted rasqal_0_9_8 for 0.9.8 release

2005-04-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_serializer.c: Add missing switch cases to make
	-Wswitch-enum happy.

	* configure.ac: More gcc -W flags in maintainer mode.  Require
	rasqal 0.9.8

	* librdf/rdf_stream.c, librdf/rdf_storage_sqlite.c,
	librdf/rdf_storage.c, librdf/rdf_serializer_raptor.c,
	librdf/rdf_node.c, librdf/rdf_log.c: Add missing switch cases to
	make -Wswitch-enum happy.

	* librdf/rdf_query_rasqal.c (rasqal_redland_new_triples_source):
	Use new rasqal 0.9.8+ rasqal_query_get_data_graph_sequence

	* librdf/rdf_node.h: Remove unused LIBRDF_NODE_TYPE_RESERVED1 (#3)
	from librdf_node_type enum

	* raptor/raptor_xml_writer.c, raptor/raptor_serialize_rdfxmla.c,
	raptor/raptor_serialize.c, raptor/raptor_rdfxml.c,
	raptor/raptor_parse.c, raptor/raptor_general.c: Add missing switch
	cases to make -Wswitch-enum happy.

	* raptor/configure.ac: More gcc -W flags in maintainer mode.

	* raptor/raptor_xslt.c: Casts for C++

	* rasqal/configure.ac: More gcc -W flags in maintainer mode.

	* rasqal/rasqal_literal.c, rasqal/rasqal_general.c: Casts for C++

2005-04-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xslt.c (raptor_init_parser_grddl): Expand grddl
	parser description.

	* raptor/libraptor.3: Added missing 1.4.5 API changes, adding XML
	writer features and support functions as used by the
	rdf/xml-abbrev serializer.

	* raptor/tests/Makefile.am: test should use = not == for string
	compare portability

2005-04-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xslt.c: Added a list of XPaths to try, fixed
	searching for a profile.  Now handles 2 XHTML forms and XML.
	(raptor_xslt_parse_chunk): Walk through the list of XPaths.  Do
	not give an error if no GRDDL is found, 0 triples are ok.

	* raptor/raptor_libxml.c (raptor_libxml_error_common): Added,
	passing in prefix and is_fatal flag.  Handle NULL ctx and hence
	NULL parser.
	(raptor_libxml_error, raptor_libxml_generic_error,
	raptor_libxml_fatal_error, raptor_libxml_validation_error): Use
	the new function, share very common code.

	* raptor/raptor_parse.c (raptor_parser_error_varargs): Survive a
	NULL parser.

	* raptor/raptor_rdfxml.c (raptor_get_libxml_context,
	 raptor_set_libxml_document_locator,
	 raptor_get_libxml_document_locator): Survive NULL rdf_parser
	 calls.

	* raptor/raptor_internal.h: Added
	raptor_libxml_init_generic_error_handlers prototype

	* raptor/raptor_xslt.c (raptor_xslt_parse_start): Init column,
	byte to -1
	(raptor_xslt_xmlStructuredErrorFunc): Added, not tested.
	(raptor_xslt_parse_chunk): Ensure last chunk with is_end is always
	run.  Report error if no XML DOM made.  Set xslt context
	structured error handler to raptor_xslt_xmlStructuredErrorFunc.

2005-04-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xslt.c (raptor_xslt_parse_chunk): Declare 'nodes'
	at top of block.  Init doc_txt/doc_txt_len earlier so do not free
	junk.  Get the base URI string from the XML doc if it exists.

2005-03-25  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/configure.ac: Added --with-xslt-config Added grddl parser
	and checking.  Added simple search for libxslt needed by grddl.

	* raptor/Makefile.am: Added grddl if RAPTOR_PARSER_GRDDL

	* raptor/raptor_general.c (raptor_init): Added grddl

	* raptor/raptor_libxml.c (raptor_libxml_init_sax_error_handlers):
	Added to just init the static error handlers for libxml for grddl.

	* raptor/raptor_internal.h: Export
	raptor_libxml_init_sax_error_handlers for grddl.  Added
	raptor_init_parser_grddl

	* raptor/raptor_xslt.c: Generates triples via in internal rdf/xml
	parser.
	(raptor_xslt_parse_start): Copy any user-set handlers to the
	internal rdf/xml parser.
	(main): Deleted, experimental code merged.

	* raptor/raptor_xslt.c: Reformed test code into parser named
	'grddl'
	(raptor_xslt_parse_init, raptor_xslt_parse_terminate,
	raptor_xslt_parse_start, raptor_xslt_parse_chunk,
	raptor_xslt_parse_recognise_syntax,
	raptor_xslt_parser_register_factory, raptor_init_parser_xslt):
	Added

2005-03-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xslt.c: Fix memory leaks.

	* raptor/raptor_xslt.c: Remove commented out standalone xslt

	* raptor/Makefile.am: Added bodge raptor_xslt_test

	* raptor/raptor_xslt.c: Raptor GRDDL XSLT

	* raptor/raptor_parse.c (raptor_parse_chunk): docs

	* librdf/rdf_storage.c
	(librdf_storage_node_stream_to_node_create): node1 or node2 can be
	NULL but not both - edit docs and assertion.

2005-03-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_init): Set
	origin parts only if there is an origin.

	* rasqal/rasqal_engine.c
	(rasqal_query_graph_pattern_build_declared_in): Set origin vars
	only if there is an origin.

	* rasqal/rasqal_query.c (rasqal_graph_pattern_set_origin): Set all
	columns, not 1 less.

	* rasqal/rasqal_graph_pattern.c (rasqal_graph_pattern_init): Add
	origin triple parts.

	* rasqal/rasqal_engine.c
	(rasqal_query_graph_pattern_build_declared_in): Mark vars declared
	in origin.

	* rasqal/rdql_parser.y (Query): Add background data graphs as this
	rdql does not allow origin queries.

	* rasqal/sparql_parser.y (LoadClauseOpt): Add named data graphs
	from LOAD
	(GraphOrPattern, NamedGraphPattern, OptionalGraphPattern): Add
	FIXMEs for UNION, GRAPH *, SOURCE *, deprecated SOURCE, deprecated
	[]

	* rasqal/rasqal_query.c (rasqal_query_add_data_graph,
	rasqal_query_add_variable, rasqal_query_add_prefix): Add data
	graphs, sources, variables, prefixes to the end of the sequence -
	more sensible and also quicker.

	* rasqal/rasqal_graph_pattern.c
	(rasqal_graph_pattern_add_constraint): Add constraints to end of
	sequence - more sensible and also quicker.

	* rasqal/rdql_parser.y (Query): Make data graphs here, don't edit
	deprecated sources list.

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source): Pass
	in graph names as base URIs to parsing.

	* rasqal/rasqal_redland.c (rasqal_redland_new_triples_source): Use
	data graphs to gather source URIs and graph URI names.  Pass in
	graph names as base URIs to parsing.

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source): Use
	data graphs to gather source URIs and graph URI names

2005-03-20  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (NamedGraphClauseOpt): Set name uri when
	adding a data graph, to same uri as source uri

	* rasqal/librasqal.3: 0.9.8 API changes, style, refs

	* rasqal/rasqal.h, rasqal/rasqal_query.c:
	(rasqal_query_get_variable_sequence, rasqal_query_add_triple):
	Removed.  Were announced deprecated in 0.9.7

	* rasqal/rasqal_expr.c (main): Call rasqal_uri_init and
	rasqal_uri_finish around test code.

	* rasqal/rasqal_literal.c (rasqal_new_integer_literal): Use
	rasqal_xsd_integer_uri.
	(rasqal_new_floating_literal): Use rasqal_xsd_double_uri.
	(rasqal_literal_string_to_native): Use rasqal_xsd_integer_uri and
	rasqal_xsd_double_uri.  Also convert xsd:boolean rdf literals into
	internal RASQAL_LITERAL_BOOLEAN

	* rasqal/rasqal_general.c (rasqal_init): Call rasqal_uri_init
	(rasqal_finish): Call rasqal_uri_finish and always call
	raptor_finish.
	(rasqal_uri_init, rasqal_uri_finish): Added to initialise/free
	URIs used in the library.

	* rasqal/rasqal_internal.h: Added interanl URIs
	rasqal_xsd_namespace_uri, rasqal_xsd_integer_uri,
	rasqal_xsd_double_uri and rasqal_xsd_boolean_uri.  Added
	prototypes for rasqal_uri_init and rasqal_uri_finish to make them.

	* rasqal/tests/sparql/syntax/cast1.rq: Type check should be
	xsd:integer.

2005-03-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Finish
	if the query has query graph or the query graph has no graph
	patterns in it.

2005-03-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/cast1.rq: Added cast1.rq

	* Redland.i: Added librdf_log_message_code,
	librdf_log_message_level, librdf_log_message_facility,
	librdf_log_message_message, librdf_log_message_locator,
	fraptor_locator_line, raptor_locator_column, raptor_locator_byte,
	raptor_locator_file, raptor_locator_uri for raptor locators.

	* rasqal/sparql_parser.y (PatternElementConstraint): Added, Taking
	the AND Expression out of PatternElement, ensuring the constraint
	gets added to the adjacent graph pattern rather than one with no
	other content.  Replaced all other references to PatternElement
	with this term.
	[now have 2 shift/reduce conflicts]

	* rasqal/rasqal_engine.c (rasqal_query_build_declared_in): Less
	debug noise for defined variables

	* rasqal/tests/sparql/syntax/describe1.rq: use ?p in the query

	* rasqal/tests/sparql/syntax/groups.rq: select ?mbox mentioned in
	query

2005-03-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/Makefile.am, rasqal/rasqal_engine.c,
	rasqal/rasqal_internal.h, rasqal/rasqal_graph_pattern.c: Move
	rasqal_graph_pattern to new rasqal_graph_pattern.c

2005-03-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c
	(rasqal_engine_query_constraints_has_qname): Check for query
	constraints in sub-graph patterns via
	rasqal_engine_graph_pattern_constraints_has_qname on
	query_graph_pattern.
	(rasqal_engine_graph_pattern_constraints_has_qname): Check in
	sub-graph patterns here.
	(rasqal_engine_expand_graph_pattern_constraints_qnames): Expand
	qnames in sub graph patterns via recursion.
	(rasqal_engine_expand_query_constraints_qnames): Expand via
	rasqal_engine_expand_graph_pattern_constraints_qnames on
	query_graph_pattern.
	(rasqal_engine_build_constraints_expression): Build constraints in
	sub graph patterns via recursion.
	(rasqal_new_graph_pattern_from_triples): Use
	rasqal_graph_pattern_add_triples to init.
	(rasqal_graph_pattern_add_triples): Added, to add triples to an
	existing graph pattern.
	(rasqal_graph_pattern_init): Init sub graph_patterns by recusion.
	Optional flags are now stored per graph pattern.
	(rasqal_query_graph_pattern_build_declared_in): Added to build the
	variables_declared_in fields per graph_pattern.
	(rasqal_query_build_declared_in): Use the above to init from the
	query_graph_pattern down.
	(rasqal_engine_prepare): Use
	rasqal_engine_build_constraints_expression to init
	query_graph_pattern constraints.
	(rasqal_engine_execute_init): Moved graph pattern sequence init
	into rasqal_graph_pattern_init.
	(rasqal_engine_move_to_graph_pattern): Move within an outer graph
	pattern not a query.
	(rasqal_engine_do_step, rasqal_engine_do_optional_step): Perform a
	step within an outer graph_pattern containing graph pattern gp.
	(rasqal_engine_get_next_result): Execute over contents of query's
	query_graph_pattern.

	* rasqal/sparql_parser.y (WhereClauseOpt): Append to
	query_graph_pattern

	* rasqal/rdql_parser.y (rasqal_rdql_query_engine_prepare): Use
	rasqal_graph_pattern_add_sub_graph_pattern on query_graph_pattern

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Remove graph_patterns and optional_graph_pattern fields.
	(rasqal_query_add_constraint,
	rasqal_query_get_constraint_sequence,
	rasqal_query_get_constraint): Still deprecated, but now use the
	query's query_graph_pattern field.
	(rasqal_query_get_graph_pattern_sequence,
	rasqal_query_get_graph_pattern): Use the graph pattern sequence
	inside the query's query_graph_pattern.
	(rasqal_graph_pattern_add_sub_graph_pattern): Added.
	(rasqal_query_print): Print from the query_graph_pattern.

	* rasqal/rasqal_internal.h: Moved from structure rasqal_query to
	rasqal_graph_pattern fields: current_graph_pattern,
	max_optional_graph_pattern, optional_graph_pattern_matches_count
	to graph_pattern structure for execution of sub-graph patterns.
	Added prototype of rasqal_graph_pattern_add_triples.

	* rasqal/rasqal.h: Added prototype for
	rasqal_graph_pattern_add_sub_graph_pattern

2005-03-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern): Added.

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Init query_graph_pattern using rasqal_new_graph_pattern.

	* rasqal/rasqal_internal.h: Added prototype for
	rasqal_new_graph_pattern

	* rasqal/sparql_parser.y, rasqal/rdql_parser.y: execute factory
	method takes rasqal_query_results* arg

	* rasqal/rasqal_engine.c: style

	* rasqal/rasqal_query.c (rasqal_query_execute): execute factory
	method takes rasqal_query_results*

	* rasqal/rasqal_internal.h: execute method takes
	rasqal_query_results*

	* rasqal/rasqal_internal.h: style

2005-03-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/sparql_parser.y (rasqal_sparql_query_engine_prepare):
	Move qname expansion checks from sparql_parse.

	* rasqal/sparql_parser.y: Restore TriplePatternList as first part
	of PatternElement.

	* rasqal/tests/sparql/syntax/data.n3: Add something for casting

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): Evaluate
	RASQAL_EXPR_CAST.

	* rasqal/rdql_parser.y (main): Cast for C++

	* rasqal/tests/sparql/syntax/Makefile.am: Added cast0.rq

	* rasqal/tests/sparql/syntax/cast0.rq: Added cast test

	* rasqal/sparql_lexer.l: and {QUOTEDURI} add optional ')' and
	return URI_LITERAL_BRACE, QNAME_LITERAL_BRACE instead of
	URI_LITERAL / QNAME_LITERAL.

	* rasqal/sparql_parser.y: Added tokens URI_LITERAL_BRACE
	QNAME_LITERAL_BRACE for URI+'(' and QNAME+'('
	(URIBrace): Added for handling the two above, replacing two
	alternatives in BuiltinExpression, removing a conflict.

	* raptor/tests/turtle/Makefile.am: add test-17.out

	* rasqal/rasqal_expr.c (rasqal_new_cast_expression): Added for
	type casting
	(rasqal_free_expression, rasqal_expression_foreach,
	rasqal_expression_evaluate, rasqal_expression_print): Added
	RASQAL_EXPR_CAST support

	* rasqal/rasqal.h: Added RASQAL_EXPR_CAST for sparql type casting
	Added prototype for rasqal_new_cast_expression

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l,
	raptor/turtle_lexer.l, raptor/n3_lexer.l: Tidy to use .|\n to
	match any char

	* raptor/n3_lexer.l, raptor/turtle_lexer.l: Added """long
	literals""" Use yyterminate() to end on errors

	* raptor/tests/turtle/test-17.out: test-17

	* raptor/tests/turtle/bad-14.ttl, raptor/tests/turtle/test-17.ttl:
	long literals

	* raptor/tests/turtle/Makefile.am: Added test-17.ttl bad-14.ttl for
	long literals

	* rasqal/rdql_lexer.l, rasqal/sparql_lexer.l ('-strings, and
	"-strings): Count passed into sparql_copy_string_token is one too
	small.

	* rasqal/rasqal_query.c (rasqal_graph_pattern_set_origin): Set
	origin only on this graph pattern's columns/triples.

	* rasqal/roqet.c: Indenting tidying

2005-03-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c (roqet_graph_pattern_walk): Print constraints
	per-graph pattern.

	* rasqal/rasqal_engine.c (rasqal_graph_pattern_get_constraint):
	use idx

	* rasqal/sparql_lexer.l: Remove NOT

	* rasqal/sparql_parser.y: Updates to grammar structure to match
	that of the 17 February 2005 WD in
	http://www.w3.org/TR/2005/WD-rdf-sparql-query-20050217/ Remove
	unused NOT token 1 shift/reduce conflcit near: URI '(' which can
	be a cast in a rule part of BuiltinExpression or a Literal.

	* rasqal/sparql_parser.y (sparql_parse): Use
	rasqal_engine_query_constraints_has_qname.

	* rasqal/rdql_parser.y: Construct constraints in parsing via query
	field constraints_sequence
	(rasqal_rdql_query_engine_prepare): Init constraints_sequence and
	after parsing, assign to the main graph pattern and delete it.
	Then do the qname expansion.
	(rdql_parse): Remove qname expansion to above function.
	(main): Use rasqal_query_prepare rather than writing internal
	fields directly.

	* rasqal/rasqal.h: Deprecate rasqal_query_add_constraint,
	rasqal_query_get_constraint_sequence and
	rasqal_query_get_constraint Added prototypes for
	rasqal_graph_pattern_add_constraint,
	rasqal_graph_pattern_get_constraint_sequence and
	rasqal_graph_pattern_get_constraint

	* rasqal/rasqal_query.c: Moved constraints code to graph_pattern
	(rasqal_free_query): Removed constraints code.
	(rasqal_query_add_source, rasqal_query_get_source_sequence,
	rasqal_query_get_source, rasqal_query_get_variable_sequence): Add
	RASQAL_DEPRECATED_MESSAGE pointing at new choice.
	(rasqal_query_add_constraint,
	rasqal_query_get_constraint_sequence,
	rasqal_query_get_constraint): Deprecated to methods on a
	rasqal_graph_pattern
	(rasqal_query_print): Remove constraints printing.

	* rasqal/rasqal_engine.c
	(rasqal_engine_query_constraints_has_qname): Renamed from
	rasqal_engine_constraints_has_qname
	(rasqal_engine_graph_pattern_constraints_has_qname): Added.
	(rasqal_engine_expand_graph_pattern_constraints_qnames): Renamed
	from rasqal_engine_expand_constraints_qnames
	(rasqal_engine_expand_query_constraints_qnames): Added.
	(rasqal_free_graph_pattern): Free constraints_expression and
	constraints when present (moved from rasqal_free_query).
	(rasqal_graph_pattern_add_constraint): Added, based on
	rasqal_query_add_constraint.
	(rasqal_graph_pattern_get_constraint_sequence): Added, based on
	rasqal_query_get_constraint_sequence
	(rasqal_graph_pattern_get_constraint): Added, based on
	rasqal_query_get_constraint
	(rasqal_graph_pattern_print): Add printing of constraints
	(rasqal_engine_prepare): Build constraints expressions per graph
	pattern.
	(rasqal_engine_check_constraint, rasqal_engine_do_step,
	rasqal_engine_do_optional_step): Operate constraints per-current
	graph pattern.

	* rasqal/rasqal_internal.h: RASQAL_DEPRECATED_MESSAGE gains a
	count so it warns just once.  rasqal_graph_pattern gains
	constraints, constraints_expression fields.  rasqal_query internal
	looses constraints.  Gains constraints_equence for rdql parsing
	use.  Added prototypes for
	rasqal_engine_query_constraints_has_qname,
	rasqal_engine_graph_pattern_constraints_has_qname,
	rasqal_engine_expand_query_constraints_qnames and
	rasqal_engine_expand_graph_pattern_constraints_qnames

2005-03-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_serialize_rdfxmla.c
	(raptor_new_qname_from_resource): Use maximal xml name length for
	splitting predicate.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Use maximal xml name length for splitting predicate.

2005-03-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: Update to use rasqal_data_graph* and methods.

	* rasqal/rasqal_query.c (rasqal_query_print): Prefer printing
	query->data_graphs not sources.

	* rasqal/sparql_parser.y (FromClauseOpt): Add either a NAMED or
	BACKGROUND rasqal_data_graph with FROM and WITH respectively.

	* rasqal/rasqal_internal.h: rasqal_query gains data_graphs field,
	note sources is DEPRECATED.

	* rasqal/rasqal_query.c (rasqal_new_query, rasqal_free_query):
	Added data_graphs field init, tidy.
	(rasqal_query_add_data_graph,
	rasqal_query_get_data_graph_sequence,
	rasqal_query_get_data_graph): Added for rasqal_data_graph access
	(rasqal_query_add_source, rasqal_query_get_source_sequence,
	rasqal_query_get_source): Added deprecated docs

	* rasqal/rasqal_expr.c (rasqal_query_add_source,
	rasqal_query_get_source_sequence and rasqal_query_get_source):
	Added deprecated notices.
	(rasqal_new_data_graph, rasqal_free_data_graph,
	rasqal_data_graph_print): Added for rasqal_data_graph class.

	* rasqal/rasqal.h: Added rasqal_data_graph and
	rasqal_data_graph_flags.  Deprecated rasqal_query_add_source,
	rasqal_query_get_source_sequence and rasqal_query_get_source Added
	prototypes for rasqal_query_add_data_graph,
	rasqal_query_get_data_graph_sequence, rasqal_query_get_data_graph,
	rasqal_new_data_graph, rasqal_free_data_graph,
	rasqal_data_graph_print

2005-02-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/win32_rasqal_config.h, rasqal/configure.ac,
	rasqal/ChangeLog: Bumped version to 0.9.8

2005-02-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.1: roqet is a query util

	* rasqal/roqet.c (roqet_graph_pattern_walk): Renamed from
	roqet_walk_graph_pattern

	* rasqal/roqet.c (roqet_query_walk): Added to do all query API
	walking.

	* rasqal/rasqal_query.c (rasqal_query_print): Tweak distinct,
	limits wording>

	* rasqal/tests/sparql/syntax/Makefile.am: Added distinct0.rq
	limit0.rq

	* rasqal/tests/sparql/syntax/distinct0.rq,
	rasqal/tests/sparql/syntax/limit0.rq: Tests for DISTINCT and LIMIT
	syntax

	* rasqal/librasqal.3: Added rasqal_query_get_distinct and
	rasqal_query_get_limit

	* rasqal/sparql_parser.y (LimitClauseOpt): Set limit field.

	* rasqal/rasqal_query.c: Tidy some docucomments.
	(rasqal_new_query): Initialise distinct, limit fields.
	(rasqal_query_get_distinct): Added, returning if query results
	should be distinct.
	(rasqal_query_get_limit): Added, returning the query results limit
	specified in the query.
	(rasqal_query_print): Print distinct, limit fields.

	* rasqal/rasqal.h: Added rasqal_query_get_distinct and
	rasqal_query_get_limit

	* rasqal/rasqal_internal.h: Added limit field to struct
	rasqal_query_s

	* rasqal/rasqal_literal.c (rasqal_literal_compare): Recheck for
	NULL variable values so that ?var1 compare ?var2 fails properly
	when one is not bound.

	* rasqal/sparql_parser.y: tweak optional warning

2005-02-23  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: Casts for C++

	* rasqal/rasqal_redland.c (rasqal_redland_new_triples_source):
	Return -1 on no data.

	* rasqal/rasqal_raptor.c (rasqal_raptor_new_triples_source):
	Return -1 on no data.

	* rasqal/rasqal_query.c (rasqal_query_prepare): Init line, column,
	byte to undefined.

	* rasqal/rasqal_engine.c (rasqal_new_triples_source): Throw no
	data/general error when new triple source factory fails to
	construct.
	(rasqal_engine_execute_init): Remove error throwing from here.

	* rasqal/rasqal.h: new_triples_source factory method document
	return value

	* rasqal/roqet.c: Use raptor_stringbuffer to read large queries
	from files, > buffer size.

2005-02-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/examples/Makefile.am: Add gconf-2.0 to grapper args

2005-02-19  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/part1/Makefile.am: Add dawg-query-004
	dawg-result-004.n3

	* rasqal/tests/sparql/part1/dawg-query-001,
	rasqal/tests/sparql/part1/dawg-query-002,
	rasqal/tests/sparql/part1/dawg-query-003,
	rasqal/tests/sparql/part1/dawg-query-004: 2005-02-17 WD syntax
	changes

2005-02-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: help typo

	* rasqal/tests/sparql/syntax/construct2.rq,
	rasqal/tests/sparql/syntax/construct1.rq,
	rasqal/tests/sparql/syntax/construct0.rq,
	rasqal/tests/sparql/syntax/ask0.rq: FROM to WITH for 2005-02-17 WD

	* rasqal/sparql_parser.y (PatternElementForms): Remove unused
	vars.

	* rasqal/sparql_parser.y: Some updates for 2005-02-17 SPARQL query
	WD.  Added GRAPH, WITH tokens
	(FromClauseOpt): Warn about FROM, add WITH.
	(PatternElementForms): Warn with SOURCE, add GRAPH.  Use
	rasqal_graph_pattern_set_origin to pass on the varOrURI
	(PatternElementForms): Warn about []

	* rasqal/sparql_lexer.l: Added graph, with

	* rasqal/rasqal_internal.h: Added rasqal_graph_pattern_set_origin
	prototype.

	* rasqal/rasqal_query.c (rasqal_graph_pattern_set_origin): Added,
	to recursively set the origin on all triples inside.

2005-02-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/librasqal.3: Document 0.9.7 and graph pattern api calls.

	* rasqal/roqet.1: Document -d, -n

	* rasqal/roqet.c: Added -n/--dryrun to stop after preparing the
	query.  Added -w/--walk-query to walk and print the query using
	the API.
	(roqet_walk_graph_pattern): Added to walk the tree.

	* rasqal/rasqal_query.c (rasqal_graph_pattern_get_triple): fix
	range check

	* rasqal/rasqal_query.c (rasqal_query_add_triple): Deprecated as
	it doesn't construct the graph patterns and is of little use.
	(rasqal_query_get_graph_pattern_sequence,
	rasqal_query_get_graph_pattern): Added to get the
	rasqal_graph_patterns inside a query.
	(rasqal_graph_pattern_get_triple): Added to get a rasqal_triple
	inside a graph_pattern.
	(rasqal_graph_pattern_get_sub_graph_pattern_sequence,
	(rasqal_graph_pattern_get_sub_graph_pattern): Added to get a
	sub-graph pattern inside a graph pattern.
	(rasqal_graph_pattern_get_flags): Added to get graph pattern
	flags.

	* rasqal/rasqal.h: Typo

	* rasqal/rasqal_internal.h: Move rasqal_graph_pattern typedef,
	rasqal_pattern_flags and rasqal_graph_pattern_print to public api.
	Added RASQAL_DEPRECATED_MESSAGE macro.

	* rasqal/rasqal.h: Export rasqal_graph_pattern typedef Export
	rasqal_pattern_flags enum with value RASQAL_PATTERN_FLAGS_OPTIONAL
	Deprecate rasqal_query_add_triple as it doesn't construct the
	graph patterns and is of little use.  Added prototypes for
	rasqal_query_get_graph_pattern_sequence,
	rasqal_query_get_graph_pattern, rasqal_graph_pattern_get_triple,
	rasqal_graph_pattern_get_sub_graph_patterns_sequence,
	rasqal_graph_pattern_get_sub_graph_pattern,
	rasqal_graph_pattern_get_flags and exported
	rasqal_graph_pattern_print

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql: Handle roqet select: and bound
	variables:

	* rasqal/rasqal.h: Added RASQAL_DEPRECATED macro.  Deprecated
	rasqal_query_get_variable_sequence Added
	rasqal_query_get_bound_variable_sequence and
	rasqal_query_get_all_variable_sequence.

	* rasqal/rasqal_query.c (rasqal_query_get_variable_sequence):
	Deprecate, prefer rasqal_query_get_bound_variable_sequence
	(rasqal_query_get_bound_variable_sequence): Added, returning the
	sequence of rasqal_variable* that are to be bound - appearing in
	the query result.
	(rasqal_query_get_all_variable_sequence): Added, return the
	sequence of all rasqal_variable* mentioned in the query.
	(rasqal_query_print): Print all variables as well as selected.

	* rasqal/rasqal_literal.c (rasqal_literal_as_integer,
	rasqal_literal_as_floating, rasqal_literal_as_string,
	rasqal_literal_compare): Added remaining LITERAL enums for
	-Wswitch-enum.
	(rasqal_literal_compare): Handle two literal values.
	(rasqal_literal_as_node): Handle RASQAL_LITERAL_BOOLEAN into a
	xsd:boolean typed value.

	* rasqal/rasqal_query.c (rasqal_query_results_get_binding_name):
	Work even when query results are finished.

	* rasqal/rasqal_query.c (rasqal_query_set_feature): Added
	RASQAL_FEATURE_LAST case for -Wswitch-enum (there are no
	features).
	(rasqal_query_results_write, rasqal_query_results_get_triple):
	Added RASQAL_LITERAL_UNKNOWN case for -Wswitch-enum.
	(rasqal_query_results_get_triple): Added remaining LITERAL enums
	for -Wswitch-enum.  Note why forbidden - literal subjects,
	predicates, bnode predicates.

	* rasqal/rasqal_expr.c (rasqal_free_expression,
	rasqal_expression_foreach, rasqal_expression_evaluate,
	rasqal_expression_print): Added RASQAL_EXPR_UNKNOWN case for
	-Wswitch-enum.  Deleted "pattern" from rasqal_op_labels.
	(rasqal_expression_print): Deleted RASQAL_EXPR_PATTERN Handle
	RASQAL_EXPR_FUNCTION.

	* rasqal/rasqal_literal.c (rasqal_free_literal,
	rasqal_literal_print, rasqal_literal_as_boolean,
	rasqal_literal_as_integer, rasqal_literal_as_floating,
	rasqal_literal_as_string, rasqal_literal_compare,
	rasqal_literal_equals): Added RASQAL_LITERAL_UNKNOWN case for
	-Wswitch-enum.
	(rasqal_literal_as_integer, rasqal_literal_as_floating): Return
	RASQAL_LITERAL_BLANK as an error.

	* rasqal/rasqal.h: Deleted RASQAL_EXPR_PATTERN - never used.

	* rasqal/configure.ac: Add -Wswitch-enum to maintainer-mode gcc
	switches to catch missing enum values in switches.  Lots of those
	near expression and literal handling.

	* librdf/rdf_statement.c (librdf_free_statement): with threads fix

2005-02-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/examples/grapper.c: Added gconf storing of window
	width/height at namespace /apps/grapper

2005-02-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/win32_raptor_config.h: Define RASQAL_INLINE to __inline

	* raptor/raptor_nfc.c: Change inline to RAPTOR_INLINE

	* raptor/raptor_internal.h:
	Define RAPTOR_INLINE to inline if not alerady defined to something
	else

	* rasqal/win32_rasqal_config.h: Define RASQAL_INLINE to __inline

	* rasqal/rasqal_query.c: Change inline to RASQAL_INLINE

	* rasqal/rasqal_internal.h: Add RASQAL_INLINE protection and set
	RASQAL_DEBUG if LIBRDF_DEBUG set.

	* rasqal/rasqal.h: rasqal_query_results_write with RASQAL_API prefix.

2005-02-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_serialize_rdfxmla.c
	 (raptor_rdfxmla_emit_subject_list_items,
	 raptor_rdfxmla_emit_subject_properties,
	 raptor_rdfxmla_emit_subject, raptor_rdfxmla_serialize_start): Copy
	base URIs only when they are not NULL.
	(raptor_rdfxmla_serialize_statement): Handle
	predicate type RAPTOR_IDENTIFIER_TYPE_RESOURCE as an alternative.

	* librdf/rdf_query_rasqal.c (librdf_query_rasqal_execute): Free
	any existing stored rasqal result before executing.
	(librdf_query_rasqal_free_results): Zap results pointer after
	freeing rasqal results.

	* rasqal/rasqal_engine.c (rasqal_reset_triple_meta): End any
	triples match when resetting rasqal_triple_meta; this frees any
	resources that were providing a source of triples.

2005-02-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_xml.c (raptor_valid_xml_ID): Just return an error
	status, don't error out here.

	* rasqal/rasqal_query_test.c (main): Execute a query/free twice
	with no checking of results in between.

2005-02-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/bound/Makefile.am,
	rasqal/tests/sparql/examples/Makefile.am,
	rasqal/tests/sparql/part1/Makefile.am,
	rasqal/tests/sparql/simple/Makefile.am,
	rasqal/tests/sparql/syntax/Makefile.am, rasqal/configure.ac,
	rasqal/tests/rdql/testsuite/Makefile.am: Add @RAPPER_PATH@ to the
	PATH before check-rdql/sparql calls so that if both raptor and
	rasqal are being built, rapper can be found before installation.

	* raptor/Makefile.am: Add n3_lexer.l n3_parser.y to EXTRA_DIST
	otherwise building with --enable-maintainer-mode from tarball will
	fail.

	* raptor/raptor_rss.c: Add RSS enclosures serializing into RSS 1.0
	raptor_rss10_serializer_context gains enclosures sequence
	(raptor_rss10_serialize_init, raptor_rss10_serialize_terminate):
	Init, free enclosures sequence.
	(raptor_rss10_store_statement): If subject isn't an RSS item, see
	if it is an enclosure and if so, set the type.
	(raptor_rss10_serialize_statement): If type is enclosure, walk the
	list of enclosures and add a new one if not seen already.
	(raptor_rss10_emit_item): Add indent arg as this is called
	recursively.  Use it to print spaces from teh raptor_rss10_spaces
	constant.  Only serialize an rdf:about if the item has a URI.  If
	field is enc:enclosure, find the enclosure item and write it
	indented further recursively calling raptor_rss10_emit_item.

	* raptor/raptor_rss.c: re-comment back item enclosure thing

2005-02-07  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss_parser_processNode): Do not
	assign 'alternate' attribute values when there's no field to use.

	* librdf/rdf_node.c (librdf_node_encode): init datatype_uri_string
	to prevent a gcc warning.

2005-02-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* configure.ac, librdf/win32_rdf_config.h:
	Bumped version to 1.0.1

	* rasqal/configure.ac, rasqal/win32_rasqal_config.h:
	Bumped version to 0.9.7

	* raptor/configure.ac, raptor/win32_raptor_config.h:
	Bumped version to 1.4.6

	* librdf/win32_rdf_config.h, configure.ac: 1.0.0

	* Snapshotted redland_1_0_0 for 1.0.0 release

2005-02-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: librdf_query_results_to_string returns a char*

	* Redland.i: librdf_query_results_to_file returns an int.
	%newobject librdf_query_results_to_string

	* rasqal/autogen.sh, raptor/autogen.sh: Add autoheader to the path
	search.

	* rasqal/configure.ac, raptor/configure.ac, configure.ac:
	AM_PROG_LIBTOOL to AC_PROG_LIBTOOL seems to make things happier

	* autogen.sh: fix

	* autogen.sh: Add autoheader to the fun

	* rasqal/autogen.sh: Add libtoolize to the path search.

	* raptor/autogen.sh: tidy

	* raptor/autogen.sh: Add libtoolize to the path search.

	* autogen.sh: No need for swig here.  Add libtoolize to the path
	search.

2005-02-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* utils/rdfproc.c, rasqal/sparql_lexer.l, rasqal/rasqal_expr.c:
	casts for C++

	* rasqal/configure.ac: In maintainer mode, stop if flex is too
	old, no flex or YACC is not GNU bison.

	* raptor/configure.ac: In maintainer mode, stop if there is no
	flex.

	* raptor/configure.ac: In maintainer mode, stop if flex is too old
	or YACC is not GNU bison.

	* rasqal/sparql_lexer.l (sparql_copy_string_token): Fix wrong
	length on checking qname.

	* rasqal/sparql_lexer.l ({QNAME}): Now assigns a uri using
	sparql_copy_qname.
	(sparql_copy_qname): expands and returns a raptor_uri* here.  When
	running standalone as rasqal_lexer_test, ignore unexpanded qnames.
	(sparql_copy_string_token): When running standalone as
	rasqal_lexer_test, ignore unexpanded qnames.

	* rasqal/sparql_lexer.l (sparql_copy_string_token): Check and
	expand datatype qnames here, since prefixes are always defined
	before qname use..

	* rasqal/rasqal_expr.c: Added support for expressions:
	STR, LANG, DATATYPE, ISURI, ISBLANK and ISLITERAL
	(rasqal_free_expression, rasqal_expression_foreach,
	rasqal_expression_print_op, rasqal_expression_print):  Updated to
	handle the expression types above.
	(rasqal_expression_evaluate): Print evaluation before and after debug
	messages.  Edit main body to not return in cases.
	Implement the expressions above.

	* rasqal/sparql_parser.y:
	Added tokens STR, LANG, DATATYPE, ISURI, ISBLANK and ISLITERAL
	(BuiltinExpression): Use the tokens above to implement built in
	functions of the same names.

	* rasqal/sparql_lexer.l:
	Added keywords STR, LANG, DATATYPE, ISURI, ISBLANK and ISLITERAL

	* rasqal/rasqal.h: Added rasqal_op RASQAL_EXPR_STR, RASQAL_EXPR_LANG,
	RASQAL_EXPR_DATATYPE, RASQAL_EXPR_ISURI, RASQAL_EXPR_ISBLANK,
	RASQAL_EXPR_ISLITERAL,

	* rasqal/librasqal.3, rasqal/rasqal_literal.c: Updates for 0.9.6

	* raptor/raptor_libxml.c:
	Use RAPTOR_LIBXML_XMLSAX2INTERNALSUBSET test for a function rather
	than HAVE_LIBXML_SAX2_H test for a header to work on OSX 10.3.x which
	has inconsistent system libxml shared library/headers.

	* raptor/configure.ac:
	Test for xmlSAX2InternalSubset so that it checks for the broken OSX
	10.3.x libxml features in the shared library rather than the ones
	declared in the inconsistent header.

2005-02-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal.rdf.in: Updates for schema

	* configure.ac, Makefile.am: Added redland.rdf.in DOAP

	* redland.rdf.in: Redland DOAP

	* raptor/raptor.rdf.in: Updates for schema

	* configure.ac: need rasqal 0.9.6

	* configure.ac: Sleepycat/BDB 4.3

	* raptor/tests/Makefile.am (check-rdfxmla):
	rdfdiff should read $name-rdfxmla.rdf from builddir

2005-02-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdiff.c: C style
	Move more declarations to start of blocks.

	* raptor/rdfdiff.c (rdfdiff_free_file): Restore what I broke.

	* raptor/rdfdiff.c: C style
	Move more declarations to start of blocks.

	* raptor/raptor_xml_writer.c (raptor_xml_writer_end_element):
	Move int decl to start of block.

	* raptor/raptor_serialize_rdfxmla.c (raptor_unique_id):
	Terminate string right.

	* raptor/rdfdiff.c, raptor/raptor_serialize_rdfxmla.c: Casts for C++

	* raptor/raptor_serialize_rdfxmla.c: C style
	(raptor_rdfxmla_emit_subject_list_items,
	raptor_rdfxmla_emit_subject_properties): Declare i at start of block.

	* raptor/rdfdiff.c, raptor/raptor_serialize_rdfxmla.c: Import
	rdf/xml with abbreviations serializer 'rdfxml-abbrev' written by
	Steve Shepard

	* raptor/rapper.1: rdfxml-abbrev

	* raptor/rdfdump.c: Widen help formatting for longer serializer name

	* raptor/raptor_xml_writer.c: Various C style fixes.
	Make an enum for raptor_xml_writer_flags.
	Added XML_WRITER_ prefixes to macro and defines.
	Moved spaces_buffer to module static.
	Noted struct nsd and namespaces sorting are duplicated code.
	Docucomments for several methods (not yet used by doc system) noting
	use of the flags.

	* raptor/Makefile.am: clean rdfdiff

	* raptor/Makefile.am: rdfdiff to EXTRA_PROGRAMS for now

	* raptor/ChangeLog, raptor/Makefile.am, raptor/raptor.h,
	raptor/raptor_feature.c, raptor/raptor_general.c,
	raptor/raptor_internal.h, raptor/raptor_xml_writer.c,
	raptor/tests/Makefile.am: Import rdf/xml with abbreviations
	serializer 'rdfxml-abbrev' written by Steve Shepard

	* rasqal/rasqal_engine.c (rasqal_engine_do_optional_step):
	When the constraint fails, zero the
	new_bindings_count since none matter now.

	* rasqal/sparql_lexer.l: Added BNAME token
	({BNAME}): Added to just do a blank node.

	* rasqal/configure.ac: Added dir tests/sparql/bound

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/construct2.rq: Construct with bnodes in
	construct2.rq

	* rasqal/tests/sparql/bound/Makefile.am,
	rasqal/tests/sparql/bound/bound1-result.n3,
	rasqal/tests/sparql/bound/bound1.rq,
	rasqal/tests/sparql/bound/data.n3,
	rasqal/tests/sparql/bound/manifest.n3: DAWG BOUND tests

	* rasqal/tests/sparql/Makefile.am: added bound

	* rasqal/sparql_lexer.l ({QNAME}): If it starts _:, make a
	BLANK_LITERAL
	(sparql_token_print, sparql_token_free): Added BLANK_LITERAL
	support.

	* rasqal/sparql_parser.y:
	Added tokens BLANK_LITERAL ConstructPattern (rq23) BNode (rq23),
	TripleTemplate (rq23) and VarOrLiteralOrBNode VarOrURIOrBNode
	(ConstructClause): Now using ConstructPattern
	(ConstructPattern): Added from rq23, using TripleTemplate
	(TripleTemplate): Added from rq23, using VarOrURIOrBNode for subject
	and VarOrLiteralOrBNode for object.
	(VarOrURIOrBNode): Added, using BNode
	(VarOrLiteralOrBNode): Added, using BNode
	(BNode): Added from rq23

	* rasqal/rasqal_expr.c (rasqal_free_expression,
	rasqal_expression_evaluate, rasqal_expression_print_op): Added
	RASQAL_EXPR_BOUND support.

	* rasqal/rasqal.h: Added RASQAL_EXPR_BOUND

	* rasqal/sparql_parser.y:
	Updates from http://www.w3.org/2001/sw/DataAccess/rq23/
	$Revision: 1.187 $ of $Date: 2005/02/01 10:56:24 $
	Added tokens BASE LOAD BOUND
	Renumbered some of comments to rq23 above.
	(ReportFormat) Moved big () inside Query here
	(SelectClause, DescribeClause, ConstructClause): Note now in rq23
	(AskClause): Added from rq23.
	(LoadClauseOpt): Added from rq23.
	(LimitCaluseOpt): Added from rq23.
	(PatternElementForms OPTIONAL GraphPattern1): Mark the graph pattern
	as optional in the flags.
	(BaseDeclOpt): Added from rq23.
	(UnaryExpression): Call BuiltinExpression
	(BuiltinExpression): Added from rq23 just with BOUND

	* rasqal/sparql_lexer.l: Added OPTIONAL, BASE, LOAD and BOUND
	tokens and keywords

	* librdf/rdf_query_rasqal.c
	(librdf_query_rasqal_query_results_update_statement): Handle empty
	rstatement right away.
	(librdf_query_rasqal_results_as_stream): If no statements at all,
	return NULL.

	* librdf/rdf_query_rasqal.c:
	(librdf_query_rasqal_query_results_next_statement) Remove unused
	vars.

	* utils/rdfproc.c: Handle bindings, boolean and RDF graph query
	results.

	* librdf/rdf_query_rasqal.c
	(librdf_query_rasqal_query_results_update_statement): Return 0

	* librdf/rdf_query_rasqal.c:
	Protect all query results from NULL pointers.
	(librdf_query_rasqal_query_results_end_of_stream,
	librdf_query_rasqal_query_results_update_statement,
	librdf_query_rasqal_query_results_next_statement,
	librdf_query_rasqal_query_results_get_statement
	librdf_query_rasqal_query_results_finished): Added, implementing
	RDF graph query results.
	(librdf_query_rasqal_results_as_stream): Updated to use the above.

2005-01-31  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Added librdf_query_results_is_bindings,
	librdf_query_results_is_boolean, librdf_query_results_is_graph,
	and librdf_query_results_get_boolean

	* librdf/rdf_query_rasqal.c
	(librdf_query_rasqal_results_is_bindings,
	librdf_query_rasqal_results_is_boolean,
	librdf_query_rasqal_results_is_graph,
	librdf_query_rasqal_results_get_boolean):
	Added, calling rasqal.
	(librdf_query_rasqal_results_as_stream): Added, not implemented.

	* librdf/rdf_query_results.c (librdf_query_results_as_stream):
	Moved to end to match new query results.
	(librdf_query_results_is_bindings, librdf_query_results_is_boolean,
	librdf_query_results_is_graph, librdf_query_results_get_boolean,
	librdf_query_results_as_stream): Added.

	* librdf/rdf_query.h: Added results_is_bindings,
	results_is_boolean, results_is_grpah and results_get_boolean
	factory methods.
	Added prototypes for librdf_query_results_is_bindings,
	librdf_query_results_is_boolean, librdf_query_results_is_graph and
	librdf_query_results_get_boolean

	* rasqal/rasqal_query.c (rasqal_query_execute): Init ask_result.
	(rasqal_free_query_results, rasqal_query_results_is_bindings,
	rasqal_query_results_is_boolean, rasqal_query_results_is_graph):
	Docs.
	(rasqal_query_results_next, rasqal_query_results_get_triple,
	rasqal_query_results_next_triple): C style.
	(rasqal_query_results_get_triple): FIXME about bnodeids is done.
	(rasqal_query_results_get_boolean): Docs and implement by getting
	first result and storing if it worked.

	* rasqal/rasqal_internal.h: Added ask_result to rasqal_query.

	* rasqal/tests/sparql/syntax/Makefile.am: Added ask0.rq

	* rasqal/tests/sparql/syntax/ask0.rq: ASK test

2005-01-30  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_query.c: docs

	* librdf/rdf_query.c (main): C99

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables): C99

	* librdf/rdf_storage_sqlite.c: Casts for C++

	* librdf/rdf_query_rasqal.c (rasqal_redland_bind_match): Casts for C++
	and calculate, return the matched parts.
	Updated untested origin code.
	(librdf_query_rasqal_execute): Remove code for rasqal < 0.9.4 fixes.

	* rasqal/rasqal_xsd_datatypes.c: Casts for C++

	* rasqal/rasqal_redland.c (rasqal_redland_bind_match):
	Updated untested redland origin code.

	* rasqal/rasqal_query.c: Casts for C++

	* rasqal/rasqal_engine.c (rasqal_graph_pattern_get_next_match):
	int parts

	* rasqal/librasqal.3: Updates for API changes to 2005-01-30

2005-01-29  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.1: Document -f/--format.  Reference -o xml spec

	* rasqal/roqet.c: Note that -o xml writes the SPARQL xml format.

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables):
	variables_declared_in is now an array of integer (triple) column
	numbers not pointers to graph patterns.
	(rasqal_reset_triple_meta): Return number of variables that were
	set to NULL.
	(rasqal_graph_pattern_init): Update to compare triple column
	numbers, not graph patterns for defining vars.
	(rasqal_query_build_declared_in): Update for variables_declared_in
	changed.
	(rasqal_graph_pattern_get_next_match): Adjust new_bindings_count
	by number of variables reset by rasqal_reset_triple_meta.  Only
	run the bind_match factory method if there are triple parts to
	bind. If it is run, adjust the new_bindings_count when variables
	are set.
	(rasqal_engine_do_optional_step): If there were new bindings,
	return a result otherwise continue searching.
	(rasqal_engine_get_next_result): Reset new_bindings_count on
	entry.

	* rasqal/rasqal_internal.h: rasqal_query: variables_declared_in is
	now an array of integer column numbers.  Added new_bindings_count

	* rasqal/rasqal_query.c (rasqal_free_query): tidy free of
	variables_declared_in, now an intarray.

2005-01-28  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c: Add -f / --format to set output syntax format
	for graph results.

	* rasqal/roqet.c: Update for rasqal_query_results_get_triple
	returning a shared raptor_statement.  Use a raptor_serializer to
	format it.

	* rasqal/rasqal_query.c (rasqal_free_query): Free rasqal_triple
	allocated.
	(rasqal_prefix_id): Prefix a blank node id with 'r'<query result
	number>'_'
	(rasqal_query_results_get_triple): Return a shared
	raptor_statement.
	(rasqal_query_results_next_triple): Free the internal
	rasqal_triple before moving on.

	* rasqal/rasqal_internal.h: Added rasqal_triple internal to
	rasqal_query

	* rasqal/rasqal.h: Changed rasqal_query_results_get_triple to
	return raptor_statement

	* rasqal/rasqal_internal.h: Added raptor_statement to rasqal_query

2005-01-27  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/rdql/testsuite/check-rdql,
	rasqal/tests/sparql/check-sparql (run_test): don't delete test
	output files here, let main do it.

	* rasqal/roqet.c: Free returned triple result

	* rasqal/roqet.c: Tidy the query result messages

	* rasqal/roqet.c (main): Format bindings, triples and boolean
	results.

	* rasqal/rasqal_query.c (rasqal_query_execute): Init
	current_triple_result.
	(rasqal_query_results_is_bindings,
	rasqal_query_results_is_boolean, rasqal_query_results_is_graph):
	Added to test query result formats.
	(rasqal_query_results_get_count, rasqal_query_results_next,
	rasqal_query_results_finished, rasqal_query_results_get_bindings,
	rasqal_query_results_get_binding_value,
	rasqal_query_results_get_binding_name,
	rasqal_query_results_get_binding_value_by_name,
	rasqal_query_results_get_bindings_count): Fail if result type is
	not bindings.
	(rasqal_query_results_get_triple): Added, to get the current
	triple from a graph result.
	(rasqal_query_results_next_triple): Added, to move to the next
	triple in a graph result.
	(rasqal_query_results_get_boolean): Added, always false for now.

	* rasqal/rasqal_literal.c (rasqal_literal_as_node): Handle
	variable values, convert the variable result.

	* rasqal/rasqal_internal.h: Added current_triple_result to
	rasqal_query

	* rasqal/rasqal.h: Added rasqal_query_results_is_bindings,
	rasqal_query_results_is_boolean, rasqal_query_results_get_boolean,
	rasqal_query_results_is_graph, rasqal_query_results_get_triple and
	rasqal_query_results_next_triple

	* rasqal/rasqal_engine.c (rasqal_engine_assign_variables): Build
	construct triples when CONSTRUCT * is given

	* rasqal/rasqal_expr.c (rasqal_new_triple_from_triple): Added copy
	constructor

	* rasqal/rasqal.h: Added rasqal_new_triple_from_triple

	* rasqal/tests/sparql/syntax/Makefile.am,
	rasqal/tests/sparql/syntax/construct1.rq,
	rasqal/tests/sparql/syntax/construct0.rq: CONSTRUCT syntax

2005-01-26  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rapper.1: mention what RSS tag soup can do

	* raptor/turtle_parser.y, raptor/n3_parser.y: Rename
	raptor_new_triple/raptor_free_triple to have n3/turtle in the
	name.

	* raptor/raptor_internal.h, raptor/raptor_general.c,
	raptor/n3_parser.y, raptor/n3_lexer.l, raptor/n3_common.h,
	raptor/configure.ac, raptor/Makefile.am: Update Notation3 code
	with later Turtle improvements.  Built it with maintainer mode
	only.

	* raptor/turtle_lexer.l (turtle_copy_token): Renamed from
	copy_token
	(turtle_copy_string_token): Renamed from copy_string_token.
	(main): filename moved here from global!

2005-01-24  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss_emit_item): Do not emit an items
	property, that's only done by raptor_rss_emit_connection.

	* rasqal/rasqal_expr.c (rasqal_new_function_expression): Added to
	create a function call expression.
	(rasqal_free_expression, rasqal_expression_print): Handle
	RASQAL_EXPR_FUNCTION.

	* rasqal/rasqal.h: Added name, args fields to rasqal_expression
	Added rasqal_new_function_expression

	* rasqal/Makefile.am: Added rasqal_xsd_datatypes_test

	* rasqal/rasqal_xsd_datatypes.c: Rasqal XSD datatypes

2005-01-22  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c: Added RSS1.1 namespace
	http://inamidst.com/rss1.1/
	(raptor_rss_parser_processNode): Turn Channel into RSS type
	channel.
	(raptor_rss_emit_type_triple, raptor_rss_emit_enclosure,
	raptor_rss_emit_item, raptor_rss_emit_connection,
	raptor_rss_emit): Add error return value and stop if there is no
	identifier.
	(raptor_rss_emit): Stop if channel or any item has no identifier.
	(raptor_rss_parse_chunk): Pass on failures from above to user.
	(raptor_rss10_build_xml_names): Replace RSS1.1 namespace with
	RSS1.0
	(raptor_rss10_emit_item): Add item_type arg and use it to only
	emit items for the channel.

2005-01-21  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor.h: Added const to src arg of
	raptor_ntriples_string_as_utf8_string.

	* rasqal/tests/rdql/testsuite/Makefile.am: S-03, S-04, S-05 work

	* rasqal/sparql_lexer.l (PREFIX): Allow \
	(NAME): Allow \
	(<ID>{NAME}, <PREF>{PREFIX}, {QNAME}) Terminate when a name is not
	created.
	(sparql_copy_name, sparql_copy_qname): Use
	rasqal_escaped_name_to_utf8_string to turn the escaped name into
	just UTF-8, then check it is a legal XML name.

	* rasqal/rdql_lexer.l (PREFIX): Allow \
	(NAME): Allow \
	(<*>{NAME}, {QNAME}, <{QNAME}>) Terminate when a name is not
	created.
	(rdql_copy_name, rdql_copy_qname): Use
	rasqal_escaped_name_to_utf8_string to turn the escaped name into
	just UTF-8, then check it is a legal XML name.

	* rasqal/rasqal_internal.h: Added prototype for
	rasqal_escaped_name_to_utf8_string

	* rasqal/rasqal_general.c (rasqal_escaped_name_to_utf8_string):
	Added to turn a UTF-8 and/or \u-escaped name as a UTF-8 string.
	Intended as a lexer helper function.  A combination of
	raptor_ntriples_string_as_utf8_string and raptor_ntriples_term
	with the parsing part stripped out, and just \u, \U allowed,
	always allowing UTF-8 and working just on full strings.

	* raptor/libraptor.3: Deprecate
	raptor_ntriples_string_as_utf8_string

	* raptor/raptor.h: Deprecate raptor_ntriples_string_as_utf8_string
	- rather too internal to be useful, since it only works with a
	parser.

	* raptor/ntriples_parse.c (raptor_ntriples_term_valid): Remove
	rdf_parser arg; only for a fatal error - just die.
	(raptor_ntriples_term): Make start a const arg.  When copying UTF8
	bytes, move on the correct number of bytes in src and dest.
	Update use of raptor_ntriples_term_valid.
	(raptor_ntriples_string_as_utf8_string,
	raptor_ntriples_parse_line): Update uses of
	raptor_ntriples_term_valid.

2005-01-18  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/rdql/testsuite/Makefile.am: Remove S-02 from
	expected failures now that the formatting matches the expected
	N-Triples escaped output.

	* rasqal/rasqal_literal.c (rasqal_literal_print): Print string as
	N-Triples-escaped using raptor_print_ntriples_string.

2005-01-17  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_general.c
	(raptor_statement_part_as_counted_string): Declare language_len to
	NULL, uri_string as unsigned char*.

2005-01-16  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c (raptor_rss10_emit_item): Copy original
	base_uri each time, a raptor_new_xml_element is made and don't
	lose the original reference.

	* raptor/raptor_xml_writer.c (main): Copy original base_uri each
	time, don't lose the original reference.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Copy
	original base_uri each time, don't lose the original reference.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Handle
	RASQAL_LITERAL_BLANK. Doh!

	* rasqal/win32_rasqal_config.h, rasqal/configure.ac: Bumped
	version to 0.9.6

	* rasqal/Makefile.am: Add @RASQAL_EXTERNAL_LIBS@ $(MEM_LIBS) to
	all *_LDADD It seems to help mysterious shared library linking
	problems on Solaris.

	* rasqal/Makefile.am: Remove AM_LDFLAGS, libtool works that out
	from the LIBADD for librasqal and adds it into the .la and uses it
	from there.

	* rasqal/Makefile.am: Make the tests using automake rules rather
	than hand-crafted compile and link rules which were tricky to
	maintain.  Added EXTRA_PROGRAMS for the tests.

	* rasqal/rasqal_query_test.c: Handle rdql or sparql tests

	* rasqal/rasqal_query_test.c:
	(main) Handle no rdql available with an warning and exit 0

2005-01-15  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_literal.c (rasqal_literal_compare): Move
	declarations to start of block.

	* rasqal/librasqal.3: Updates for 0.9.5

	* rasqal/configure.ac: Require raptor 1.4.4

	* raptor/raptor_general.c
	(raptor_statement_part_as_counted_string): Initialise
	language_len, uri_string used in some cases to prevent gcc
	warnings.

	* raptor/win32_raptor_config.h, raptor/configure.ac: Bumped
	version to 1.4.5

	* raptor/Makefile.am: Add ChangeLog.2 ChangeLog.3 ChangeLog.4

	* raptor/raptor_rss.c (raptor_rss10_emit_item): Portability -
	declare rdf_Seq* variables at start of block.

	* rasqal/rasqal_redland.c, rasqal/rasqal_raptor.c,
	rasqal/rasqal_engine.c: Casts for C++

	* rasqal/sparql_parser.y (URIList): Copy the URI before freeing
	the rasqal_literal.

2005-01-14  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* Redland.i: Added librdf_model_contains_context

	* rasqal/tests/sparql/part1/dawg-result-004.n3,
	rasqal/tests/sparql/part1/manifest.n3,
	rasqal/tests/sparql/part1/dawg-query-004: Import dawg-query-004
	dawg-result-004.n3

	* librdf/rdf_model.h: Added librdf_model_contains_context

	* librdf/rdf_model.c (librdf_model_contains_context): Added, to
	find a context node in a model.
	(main): Added test.

2005-01-13  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/win32_raptor_config.h: win32 build update (patch from
	Dave Viner)

	* raptor/win32/Makefile.am: Added rapepr.dsp

	* raptor/win32/rapper.dsp, raptor/win32/raptor.dsp,
	raptor/win32/raptor.dsw, raptor/win32/raptortest.dsp: win32 build
	update (patch from Dave Viner)

	* raptor/win32_raptor_config.h: RAPTOR_INTERNAL should be defined
	in the build configuration

	* rasqal/win32_rasqal_config.h: RASQAL_INTERNAL should be defined
	in the build configuration

	* librdf/win32_rdf_config.h: Do not define REDLAND_INTERNAL at
	all.  LIBRDF_INTERNAL should be defined in the build configuration

	* librdf/librdf.h: Use LIBRDF_INTERNAL not REDLAND_INTERNAL

2005-01-12  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_rss.c: Recognise old RSS 0.9 namespace and handle
	it as rss 1.0.

	* rasqal/sparql_lexer.l: Updated to use yyterminate() when an
	error is reported, either in the lexer or in a failing function
	called.  Deleted use of ERROR_TOKEN.  Mention SPARQL in all the
	error and warning messages.

	* rasqal/rdql_lexer.l: Updated to use yyterminate() when an error
	is reported, either in the lexer or in a failing function called.
	Deleted use of ERROR_TOKEN.  Mention RDQL in all the error and
	warning messages.

	* rasqal/sparql_parser.y: Delete ERROR_TOKEN
	(PatternElementForms): Add SPARQL to warning message.
	(sparql_parse): Add SPARQL to error message.

	* rasqal/rdql_parser.y: Delete ERROR_TOKEN

	* Redland.i: Export librdf_query_results_to_file and
	librdf_query_results_to_string

	* rasqal/rasqal_expr.c (rasqal_expression_evaluate): For
	STR_MATCH, STR_NMATCH ensure the literal returned from the lhs
	expression evaluation is always freed.

2005-01-11  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rdql_parser.y (rdql_parse): set parsing debug flag before
	starting parse when RASQAL_DEBUG > 2

	* librdf/rdf_serializer.c (main): Update latest raptor 1.4.3+
	style serialised rdf/xml length.

	* librdf/rdf_serializer.c
	(librdf_serializer_serialize_model_to_file_handle): Require FILE*
	to be not null.

	* librdf/rdf_query_rasqal.c (rasqal_redland_bind_match): Update
	return to add parts arg, return.
	(librdf_query_rasqal_results_to_counted_string): Added to
	implement query results as string factory method, via Rasqal.
	(librdf_query_rasqal_results_to_file_handle): Added to implement
	query results to a file handle factory method, via Rasqal.

	* librdf/rdf_query_results.c
	(librdf_query_results_to_counted_string,
	librdf_query_results_to_string): Added to write formatted query
	results as a syntax in a string (via Rasqal).
	(librdf_query_results_to_file_handle,
	 librdf_query_results_to_file): Added to write formatted query
	 results as a syntax to a file or already open FILE* handle (via
	 Rasqal)

	* librdf/rdf_query.c (main): Add query results to string test.

	* librdf/rdf_query.h: Added results_to_counted_string,
	results_to_file_handle to librdf_query_factory.  Added prototypes
	for librdf_query_results_to_counted_string,
	librdf_query_results_to_string,
	librdf_query_results_to_file_handle and
	librdf_query_results_to_file to public api.

	* rasqal/rasqal_engine.c (rasqal_engine_do_optional_step): Handle
	an all optional query and finish all results when first optional
	finishes.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Handle NULL
	base_uri, pass it on the XML writer.

	* rasqal/tests/sparql/examples/ex2-4a.rq: Kill the , between
	SELECT vars

	* rasqal/rasqal_xml.c: Removed, not used

2005-01-10  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_raptor.c (rasqal_raptor_finish_triples_match):
	Free any literals copied into the triple used for comparing
	matches.

	* rasqal/rasqal_raptor.c (rasqal_raptor_bind_match): Reformatting.
	(rasqal_raptor_new_triples_match): Set unbound triple matches
	literal values as shared pointers, not copies of literals.

	* rasqal/rasqal_redland.c (rasqal_redland_bind_match): Update
	return value.

	* rasqal/rasqal_engine.c (rasqal_free_graph_pattern): Zap
	triple_meta pointer when done.

	* rasqal/sparql_lexer.l, rasqal/rdql_lexer.l (<PATTERN>.): Recover
	state after an error in a regex.

	* rasqal/rasqal_engine.c (rasqal_graph_pattern_order): Sort using
	pointers in data, not array pointers.

	* rasqal/rasqal_query.c (rasqal_free_query): Delete
	ordered_triples tidy.
	(rasqal_query_print): Delete ordered_triples tidy.

	* rasqal/rasqal_engine.c:
	(rasqal_query_order_triples_score, rasqal_query_order_triples):
	Deleted - no longer used.

	* rasqal/rasqal_internal.h: Deleted unused ordered_triples field
	from rasqal_query.

2005-01-09  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/tests/sparql/part1/Makefile.am: All tests pass, empty
	EXPECTED_SPARQL_CORRECT_FAILURES

	* rasqal/rasqal_internal.h: Added max_optional_graph_pattern to
	query.

	* rasqal/rasqal_engine.c (rasqal_engine_do_step): Set gp->matched
	flag here
	(rasqal_engine_do_optional_step): Set gp->matched flag
	(rasqal_engine_get_next_result): Do not set gp->matched flag here.
	For an optional step, if no bound values were returned ensure
	search continues.

	* rasqal/rasqal_engine.c: Add a few more debug messages.

	* rasqal/rasqal_engine.c: delete a #if 1

	* rasqal/rasqal_engine.c (rasqal_engine_move_to_graph_pattern):
	Use max_optional_graph_patterns to walk through combinations of
	optional graph patterns.
	(rasqal_engine_do_optional_step): CHeck against
	max_optional_graph_patterns limit and lower it when backtracking.
	(rasqal_engine_get_next_result): Count # returned values and
	continue searching when=0.  This is a fixup hack, not a final
	solution.

	* rasqal/rasqal_engine.c (rasqal_engine_move_to_graph_pattern):
	Take a delta since only ever moving by +1 or -1.  When there are
	no optionals, just move.  When backtracking optionals, re-init the
	finished graph pattern.
	(rasqal_engine_do_step, rasqal_engine_do_optional_step): Update
	calls to above.

2005-01-08  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal_engine.c (rasqal_reset_triple_meta): Added.
	(rasqal_free_graph_pattern, rasqal_graph_pattern_get_next_match):
	Call new rasqal_reset_triple_meta
	(rasqal_engine_do_optional_step): Comment out duff test

	* rasqal/rasqal_engine.c: messages

	* rasqal/rasqal_engine.c (rasqal_engine_do_optional_step): Copy
	tidying

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Debug
	messages.

	* rasqal/rasqal_engine.c (rasqal_engine_check_constraint): Added,
	from body of rasqal_engine_get_next_result.
	(rasqal_engine_do_step): Now just for mandatory graph patterns
	rasqal_engine_do_optional_step): Added, just for optional graph
	patterns.
	(rasqal_engine_get_next_result): Call rasqal_engine_do_step or
	rasqal_engine_do_optional_step depending on graph pattern optional
	flag.

	* rasqal/rasqal_engine.c (rasqal_engine_do_step): Added, from body
	of rasqal_engine_get_next_result
	(rasqal_engine_get_next_result): Smaller, see above.

	* rasqal/rasqal_engine.c: Added rasqal_engine_step and use in
	(rasqal_engine_get_next_result): Replace step=X; break with
	step=X; continue to let the loop do the work

	* rasqal/rasqal_engine.c: Added rasqal_engine_step and use in
	rasqal_engine_get_next_result

	* rasqal/rasqal_engine.c (rasqal_engine_move_to_graph_pattern): No
	need for return

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Init all
	matched flags to 0 at start.

	* rasqal/rasqal_engine.c: Comment out not-used triple ordering
	code.
	(rasqal_triples_match_bind_match): Add parts arg and pass on to
	factory bind_match method.
	(rasqal_new_graph_pattern_from_triples): Add query arg at start.
	Init query, finished, matches_returned.
	(rasqal_new_graph_pattern_from_sequence): Add query arg at start.
	Init query, finished, matches_returned.
	(rasqal_free_graph_pattern): Free variables matching the parts.
	(rasqal_graph_pattern_init): Initialise the triple meta parts
	depending on the variables_declared_in information.
	(rasqal_query_build_declared_in): Added to mark which in graph
	pattern variables are first declared in the query so that they are
	never bound multiple times.  Also warns of selected but never used
	variables.
	(rasqal_graph_pattern_get_next_match): After a triple match ends,
	free variables matching the parts only.
	(rasqal_engine_prepare): Disable ordering triples.  Call
	rasqal_query_build_declared_in.
	(rasqal_engine_move_to_graph_pattern): Helper added for:
	(rasqal_engine_get_next_result): Many changes trying to get
	optionals working.

	* rasqal/rasqal_internal.h: Add query, finished, matches fields to
	graph_pattern.  Add query arg to start of
	rasqal_new_graph_pattern_from_triples and
	rasqal_new_graph_pattern_from_sequence Add variables_declared_in
	array field, optional_graph_pattern_matches_count field to query.

	* rasqal/rasqal_redland.c (rasqal_redland_bind_match): Take parts
	argument and use to just bind those parts of the triple.

	* rasqal/rasqal_raptor.c (rasqal_raptor_bind_match): Take parts
	argument and use to just bind those parts of the triple.

	* rasqal/rdql_parser.y, rasqal/sparql_parser.y: Add query arg at
	start of rasqal_new_graph_pattern_from_triples and
	rasqal_new_graph_pattern_from_sequence calls.

	* rasqal/rasqal.h: Added triple parts to rasqal_triple_meta.

	* rasqal/rasqal_query.c (rasqal_free_query): Tidy
	query->variables_declared_in.

2005-01-06  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/rasqal.h: Added rasqal_triple_parts rasqal_triples_match
	factory method bind_match now takes and returns
	rasqal_triple_parts, returns 0 on failure

	* librdf/rdf_query_rasqal.c, rasqal/rasqal_redland.c,
	rasqal/rasqal_raptor.c, rasqal/rasqal_engine.c, rasqal/rasqal.h:
	Invert return value of rasqal_triples_match factory method
	bind_match.  Now returns 0 on failure.

	* rasqal/rasqal_engine.c (rasqal_engine_get_next_result): Handle
	failed constraint by moving to next match.

	* rasqal/tests/sparql/part1/dawg-data-01.n3,
	rasqal/tests/sparql/part1/dawg-result-003.n3: <fred@edu> to
	<mailto:fred@edu>

	* rasqal/tests/sparql/check-sparql: Remove =NULL from roqet output
	to handle optionals

	* rasqal/rasqal_query.c (rasqal_new_query): Init
	gp->optional_graph_pattern.

	* rasqal/rasqal_internal.h: Add finished, matches,
	optional_graph_pattern to rasqal_graph_pattern Add
	optional_graph_pattern to rasqal_query.

	* rasqal/rasqal_engine.c (rasqal_new_graph_pattern_from_triples):
	Init gp->optional_graph_pattern.
	(rasqal_graph_pattern_init): Init optional_graph_pattern, finished
	and matches.
	(rasqal_graph_pattern_order): Added, to sort graph_patterns in a
	query into mandatory first, optional last.
	(rasqal_engine_execute_init): Sort graph_patterns using
	raptor_sequence_sort and above helper Initialise
	query->optional_graph_pattern to the index of the first optional
	graph_pattern.
	(rasqal_engine_get_next_result): Many changes on the way to
	getting optionals working.  Track what patterns have ended with
	the finished flag, and count matches to determine when nothing
	matched.

2005-01-05  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* librdf/rdf_storage_sqlite.c: Implement get_contexts.
	(librdf_storage_sqlite_get_next_context_common,
	librdf_storage_sqlite_get_contexts_is_end,
	librdf_storage_sqlite_get_contexts_next_method,
	librdf_storage_sqlite_get_contexts_get_method,
	librdf_storage_sqlite_get_contexts_finished,
	librdf_storage_sqlite_get_contexts): Implement, based on
	find_statements technique.  No special database schema support for
	contexts at present.

2005-01-04  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/raptor_serialize.c:
	(raptor_rdfxml_serialize_start,
	raptor_rdfxml_serialize_statement): Only copy non-NULL base URIs

	* raptor/raptor_rss.c:
	(raptor_rss10_move_statements, raptor_rss10_store_statement,
	raptor_rss10_build_xml_names, raptor_rss10_emit_item):Handle
	predicates of type RAPTOR_IDENTIFIER_TYPE_RESOURCE as well as type
	RAPTOR_IDENTIFIER_TYPE_PREDICATE

	* raptor/raptor_general.c (raptor_free_statement): Free predicate
	URIs that were RAPTOR_IDENTIFIER_TYPE_RESOURCE

	* raptor/raptor_uri.c (raptor_uri_to_relative_counted_uri_string):
	Handle no path in base URI
	(main): Add test for that and test for no path in both.

	* raptor/raptor_uri.c (raptor_uri_to_relative_counted_uri_string):
	Handle no path in reference URI
	(main): Add test for that

	* rasqal/rasqal_query.c (rasqal_new_query): Init sources sequence
	always.
	(rasqal_query_add_source): No need to init sources sequence here.

	* rasqal/sparql_parser.y (WhereClauseOpt): Don't overwrite
	query->graph_patterns sequence, append if necessary.

	* rasqal/sparql_parser.y (FromClauseOpt): Don't overwrite
	query->sources sequence, append if necessary.

	* rasqal/rdql_parser.y (Query): Don't overwrite query->sources
	sequence, append if necessary.
	(TriplePattern): Append to query->triples sequence, don't
	overwrite it.

2005-01-03  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* rasqal/roqet.c (main): Declare query_string as void* to prevent
	type punning warning.

	* rasqal/sparql_lexer.l, rasqal/roqet.c, rasqal/rdql_lexer.l,
	rasqal/rasqal_query.c: casts for c++

	* raptor/win32_raptor_config.h, raptor/configure.ac: Bumped
	version to 1.4.4

	* raptor/raptor_rdfxml.c (raptor_xml_start_element_handler):
	Updates for unsigned char* string namespace URI strings.

	* raptor/raptor_namespace.c: Turn namespace URI string constants
	into unsigned char* strings.

	* raptor/raptor_identifier.c (raptor_identifier_print): Casts for
	printing rdf:XMLLiteral URI string constant.

	* raptor/raptor_general.c: Turn rdf:XMLLiteral URI string constant
	into a unsigned char* string.
	(raptor_print_statement, raptor_print_statement_part_as_ntriples):
	Casts for printing above constants.

	* raptor/raptor_uri.c (raptor_default_new_uri_for_rdf_concept):
	Use RDF namespace URI string constants.

	* raptor/Makefile.am: Link libraptor.la for URI tests, to get the
	namespace URI string constants.

	* raptor/raptor.h: Turn namespace URI string constants into
	unsigned char* strings.  Change namespace URI defines into uses of
	the constants.

	* raptor/rdfdump.c (main): Init parser_feature and
	serializer_feature to -1 to avoid compiler warnings.

	* raptor/raptor_rss.c (raptor_rss10_serialize_statement): Init
	item to NULL to avoid a compiler warning.

	* raptor/rdfdump.c, raptor/raptor_uri.c,
	raptor/raptor_serialize.c, raptor/raptor_rss.c,
	raptor/raptor_parse.c: Casts for c++

	* raptor/raptor.h: remove old comment re xml writer

2005-01-02  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rdfdump.c: set serializer features before starting to
	serialize

	* raptor/rdfdump.c: Actually set parser feature values again.  Set
	strings for parser or serializer string feature values.

	* raptor/raptor_general.c: 2005 copyrights

	* raptor/rapper.1: No simple output format anymore

	* raptor/rapper.1: Added RSS 1.0 ref

2005-01-01  Dave Beckett  <Dave.Beckett@bristol.ac.uk>

	* raptor/rapper.1: Update for new parser, serializers, xmlns
	syntax

	* raptor/raptor_serialize.c
	(raptor_serializer_set_feature_string): Docs, and return values
	for integer value features
	(raptor_serializer_get_feature_string): Return a new string for
	the start uri if set.

	* raptor/raptor_parse.c (raptor_parser_set_feature_string): Docs,
	and return values for integer value features

	* raptor/libraptor.3, raptor/raptor.h: Added
	raptor_uri_to_counted_string and raptor_uri_to_string

	* raptor/raptor_uri.c
	(raptor_uri_to_counted_string,raptor_uri_to_string): Added.

	* raptor/raptor_feature.c: doc

	* raptor/libraptor.3: changelog edit - cluster 1.4.3 entries by
	class

	* raptor/libraptor.3: Added raptor_parser_get_feature_string,
	raptor_parser_set_feature_string,
	raptor_serializer_set_feature_string,
	raptor_serializer_get_feature_string, raptor_feature_value_type,
	raptor_namespaces_find_namespace_by_uri

	* raptor/raptor_serialize.c, raptor/raptor_general.c: Use
	raptor_rdf_namespace_uri and raptor_rdf_namespace_uri_len to
	replace some constants.

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_statement):
	Handle ordinal subject and objects.

	* raptor/raptor_serialize.c: Add XML Writer to
	raptor_rdfxml_serializer_context, delete depth.
	(raptor_rdfxml_serialize_init): Delete depth stuff.
	(raptor_rdfxml_serialize_terminate): Tidy up xml writer,
	namespaces and rdf:RDF element.
	(raptor_rdfxml_serialize_declare_namespace): Don't copy uri,
	prefixes since raptor_new_namesapce_from_uri copies them anyway.
	(raptor_rdfxml_serialize_start): Convert to use xml writer.
	(raptor_rdfxml_serialize_write_xml_attribute): Deleted.
	(raptor_rdfxml_serialize_statement, raptor_rdfxml_serialize_end):
	Convert to use xml writer.

	* raptor/raptor_xml_writer.c (raptor_xml_writer_empty_element):
	Ensure namespace declarations are removed at end of element.

	* raptor/raptor.h: Added raptor_namespaces_find_namespace_by_uri

	* raptor/raptor_namespace.c
	(raptor_namespaces_find_namespace_by_uri): Added.

	* raptor/libraptor.3, raptor/raptor_sax2.c, raptor/raptor_rss.c,
	raptor/raptor.h: raptor_xml_declare_namespace renamed to
	raptor_xml_element_declare_namespace

	* raptor/raptor_rss.c (raptor_rss10_build_xml_names): Use
	raptor_xml_declare_namespace

	* raptor/raptor_rss.c: 9raptor_rss10_build_xml_names): Use
	raptor_xml_declare_namespace

	* raptor/raptor_sax2.c, raptor/raptor.h:
	raptor_sax2_declare_namespace renamed to
	raptor_xml_declare_namespace

	* raptor/raptor_serialize.c (raptor_new_serializer): Default to
	emitting relative URIs

	* raptor/raptor_serialize.c (raptor_rdfxml_serialize_ok_xml_name):
	Deleted.
	(raptor_rdfxml_serialize_statement): Replace use of
	raptor_rdfxml_serialize_ok_xml_name with raptor_xml_name_check for
	XML 1.0 names.

	* raptor/raptor_sax2.c, raptor/raptor_rdfxml.c, raptor/raptor.h,
	raptor/libraptor.3: Rename raptor_xml_element_get_element to
	raptor_xml_element_get_name

	* rasqal/roqet.c (roqet_xml_print_xml_attribute): Deleted
	(roqet_query_results_print_as_xml): Replaced with call to
	rasqal_query_results_write.
	(main): Set error and fatal_error handlers for query.  Remove xml
	format warning.

	* rasqal/rasqal_query.c (rasqal_query_results_write): Added
	docs. Declare own namespace stack and free up elements.

	* rasqal/rasqal.h: Added rasqal_query_results_write

	* raptor/raptor_rss.c: Added rss:image and rss:textinput
	properties

	* raptor/raptor_rss.c (raptor_rss10_store_statement): Don't lose
	statements that are about a known type node, but of unknown
	predicate.
	(raptor_rss10_serialize_end): Add more debug info on remaining
	statements.

	* raptor/raptor_rdfxml.c (raptor_start_element_grammar): Update
	raptor_new_xml_writer call.

	* raptor/raptor.h: raptor_new_xml_writer gets nstack parameter.
	raptor_xml_writer_start_namespace_full deleted

	* raptor/libraptor.3: raptor_new_xml_writer gets nstack param.
	raptor_xml_writer_start_namespace_full gone

	* raptor/raptor_general.c (raptor_free_statement): Don't free null
	pointers.

